/*
	This program allows the user to directly manipulate the data and update the ANOVA
	result instantly. The ANOVA is based on a one-way, three-group design.

	A basic extension of the java.applet.Applet class
 */

package wayanova;
import java.awt.*;
import java.applet.*;
import RVLS.*;


public class OneWayAnova extends closeableFrame implements notified
{
	public OneWayAnova()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(600,490);
		setFont(new Font("Times", Font.PLAIN, 12));
		setBackground(parameters.getBackGroundColor());
		label5 = new java.awt.Label("Choose dataset:");
		label5.setBounds(364,23,100,17);
		add(label5);
		choice1 = new java.awt.Choice();
		choice1.setBounds(364,43,130,22);
		choice1.setBackground(new Color(16777215));
		choice1.addItem("Sample set 1");
		choice1.addItem("Sample set 2");
		choice1.addItem("Sample set 3");
		choice1.addItem("Sample set 4");
		choice1.addItem("Sample set 5");
		choice1.addItem("Sample set 6");
		choice1.addItem("Blank dataset");
		add(choice1);
		label4 = new java.awt.Label("Click and drag inside blue areas below to enter or modify data.");
		label4.setBounds(11,32,320,20);
		label4.setFont(new Font("Serif", Font.PLAIN, 12));
		add(label4);
		diagram1 = new diagram();
		diagram1.setBounds(364,68,200,215);
		diagram1.setBackground(new Color(-657931));
		add(diagram1);
		buttonClear = new java.awt.Button();
		buttonClear.setLabel("Clear All");
		buttonClear.setBounds(501,40,70,22);
		buttonClear.setBackground(new Color(16777215));
		add(buttonClear);
		label3 = new java.awt.Label("Group 3",Label.CENTER);
		label3.setBounds(225,290,50,18);
		add(label3);
		label2 = new java.awt.Label("Group 2",Label.CENTER);
		label2.setBounds(130,290,50,18);
		add(label2);
		label1 = new java.awt.Label("Group 1",Label.CENTER);
		label1.setBounds(35,290,50,18);
		add(label1);
		dataPanel3 = new dataPanel();
		dataPanel3.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		dataPanel3.setBounds(225,65,50,220);
		dataPanel3.setBackground(new Color(-12191233));
		add(dataPanel3);
		dataPanel2 = new dataPanel();
		dataPanel2.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		dataPanel2.setBounds(130,65,50,220);
		dataPanel2.setBackground(new Color(-12191233));
		add(dataPanel2);
		dataPanel1 = new dataPanel();
		dataPanel1.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		dataPanel1.setBounds(28,67,50,220);
		dataPanel1.setBackground(new Color(-12191233));
		add(dataPanel1);
		result1 = new result();
		result1.setLayout(null);
		result1.setBounds(0,320,600,150);
		result1.setFont(new Font("Times", Font.PLAIN, 12));
		add(result1);
		//}}

		dataPanel1.setId(0);
		dataPanel2.setId(1);
		dataPanel3.setId(2);

		dataPanel1.setInform(this);
		dataPanel2.setInform(this);
		dataPanel3.setInform(this);

		dataPanel1.setData(d1, d1.length, 0, 10);
		dataPanel2.setData(d2, d2.length, 0, 10);
		dataPanel3.setData(d3, d3.length, 0, 10);

		dataPanel1.setDrawMean(true);
		dataPanel1.setDrawMedian(false);
		dataPanel2.setDrawMean(true);
		dataPanel2.setDrawMedian(false);
		dataPanel3.setDrawMean(true);
		dataPanel3.setDrawMedian(false);


		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		buttonClear.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		choice1.addItemListener(lSymItem);
		//}}
			//{{INIT_MENUS
		//}}

		setTitle("One-way Anova Analyses");
}

	//{{DECLARE_CONTROLS
	java.awt.Label label5;
	java.awt.Choice choice1;
	java.awt.Label label4;
	diagram diagram1;
	java.awt.Button buttonClear;
	java.awt.Label label3;
	java.awt.Label label2;
	java.awt.Label label1;
	dataPanel dataPanel3;
	dataPanel dataPanel2;
	dataPanel dataPanel1;
	result result1;
	//}}

	double[] d1 = {1,2,3,4};     //default dataset
	double[] d2 = {4,5,6,7};
	double[] d3 = {7,8,9,10};
	boolean if_Reset = false;
	int resetIndex = 0;

	public void dataChanged(int id)
	{
		switch(id){
			case 0: result1.anova1.setData(dataPanel1.getData(), 0); break;
			case 1: result1.anova1.setData(dataPanel2.getData(), 1); break;
			case 2: result1.anova1.setData(dataPanel3.getData(), 2); break;
			default: System.out.println("Problems with DataPanel, id="+id);
		}
		if(if_Reset == true)
		{
			resetIndex ++;
			if(resetIndex == 3)
			{
				updateResult();
				if_Reset = false;
				resetIndex = 0;
			}
		}
		else
			updateResult();
	}

	public void updateResult()
	{
		diagram1.setSSTotal(result1.anova1.get_SSTotal());			//update diagram
		diagram1.setProportion(result1.anova1.get_Proportion());
		diagram1.setDispDiag(true);
		diagram1.repaint();

		result1.repaint();											//update text result
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonClear)
			{
				dataPanel1.clear();
				dataPanel2.clear();
				dataPanel3.clear();

				diagram1.setDispDiag(false);
				diagram1.repaint();

				result1.clear();
				choice1.select(6);
			}

		}

	} //end of class SymAction

	//{{DECLARE_MENUS
	//}}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == choice1)
				choice1_ItemStateChanged(event);
		}
	}

	void choice1_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		if (choice1.getSelectedIndex() == 0)
		{
			dataPanel1.setData(d1, d1.length, 0, 10);
			dataPanel2.setData(d2, d2.length, 0, 10);
			dataPanel3.setData(d3, d3.length, 0, 10);
		}
		else if (choice1.getSelectedIndex() == 1)
		{
			double[] d1 = {1,2,3};
			double[] d2 = {8,9,10};
			double[] d3 = {13,14,15};

			dataPanel1.setData(d1, d1.length, 0, 15);
			dataPanel2.setData(d2, d2.length, 0, 15);
			dataPanel3.setData(d3, d3.length, 0, 15);
		}
		else if (choice1.getSelectedIndex() == 2)
		{
			double[] d1 = {1,2,3,4,5};
			double[] d2 = {6,7,8,9,10};
			double[] d3 = {11,12,13,14,15};

			dataPanel1.setData(d1, d1.length, 0, 15);
			dataPanel2.setData(d2, d2.length, 0, 15);
			dataPanel3.setData(d3, d3.length, 0, 15);
		}
		else if (choice1.getSelectedIndex() == 3)
		{
			double[] d1 = {1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5};
			double[] d2 = {6, 6.5, 7, 7.5, 8, 8.5, 9, 9.5, 10};
			double[] d3 = {11, 11.5, 12, 12.5, 13, 13.5, 14, 14.5, 15};

			dataPanel1.setData(d1, d1.length, 0, 15);
			dataPanel2.setData(d2, d2.length, 0, 15);
			dataPanel3.setData(d3, d3.length, 0, 15);
		}
		else if (choice1.getSelectedIndex() == 4)
		{
			double[] d1 = {1,1.333,1.667,2,2.333,2.667,3,3.333,3.667,4,4.333,4.667,5,5.333,5.667,6};
			double[] d2 = {6,6.333,6.667,7,7.333,7.667,8,8.333,8.667,9,9.333,9.667,10,10.333,10.667,11};
			double[] d3 = {10,10.333,10.667,11,11.333,11.667,12,12.333,12.667,13,13.333,13.667,14,14.333,14.667,15};

			dataPanel1.setData(d1, d1.length, 0, 15);
			dataPanel2.setData(d2, d2.length, 0, 15);
			dataPanel3.setData(d3, d3.length, 0, 15);
		}
		else if (choice1.getSelectedIndex() == 5)
		{
			double[] d1 = {1,3,5,7,9,11,13,15};
			double[] d2 = {1,3,5,7,9,11,13,15};
			double[] d3 = {1,3,5,7,9,11,13,15};
			dataPanel1.setData(d1, d1.length, 0, 15);
			dataPanel2.setData(d2, d2.length, 0, 15);
			dataPanel3.setData(d3, d3.length, 0, 15);
		}
		else if (choice1.getSelectedIndex() == 6)
		{
			dataPanel1.clear();
			dataPanel2.clear();
			dataPanel3.clear();

			diagram1.setDispDiag(false);
			diagram1.repaint();

			result1.clear();
		}

	}
}
