package wayanova;
import RVLS.*;

public class anova
{
	final int groupNumber = 3;						//group number is set to be 3
	double[][] data = new double[groupNumber][1];
	int[] groupSize = new int[groupNumber+1];
	double[] means = new double[groupNumber+1];  //the last element holds the column total
	double[] ssB = new double[groupNumber+1];
	double[] ssW = new double[groupNumber+1];
	double[] ssT = new double[groupNumber+1];		//ssT[i]=ssW[i]+ssB[i]
	double grandMean;		//=means[groupNumber+1]
	int N;		      		//total number of subjects, =groupSize[grounNumber+1]
	int dn;					//degree of nominator, equals to group numbers -1
	probFandT probFandT1;

	public void setData(double[] d, int id)   //update a single group, id: array index
	{
		data[id] = d;
		groupSize[id] = d.length;
		calc_Stats();
	}

	public void calc_Stats()
	{
		int i, j;
		double groupSum, groupSS, total;
		double delta;

		for(i=0, N=0, total=0, dn=-1; i<groupNumber; i++)
		{
			if(groupSize[i]>0)
			{
				for(j=0,groupSum=0,groupSS=0; j<data[i].length; j++)
				{
					groupSum += data[i][j];
					groupSS += data[i][j]*data[i][j];
				}

				total += groupSum;
				means[i] = groupSum/j;
				ssW[i] = groupSS - groupSum*groupSum/j;
				N += j;
				dn ++;
			}
			else
			{
				means[i] = 0;
				ssB[i] = 0;
				ssW[i] = 0;
				ssT[i] = 0;
			}
		}

		grandMean = means[groupNumber] = (N==0? 0:total/N);

		groupSize[groupNumber] = 0;
		ssB[groupNumber] = 0;
		ssW[groupNumber] = 0;
		ssT[groupNumber] = 0;

		for(i=0; i<groupNumber; i++)
			if(groupSize[i]>0)
			{
				delta = means[i]-grandMean;     //difference between the groupMean and the grandMean
				ssB[i] = delta*delta*groupSize[i];
				ssT[i] = ssB[i] + ssW[i];

				groupSize[groupNumber] += groupSize[i];
				ssB[groupNumber] += ssB[i];
				ssW[groupNumber] += ssW[i];
				ssT[groupNumber] += ssT[i];
			}
	}


	public void clear_Stats()
	{
		for(int i=0; i<=groupNumber; i++)
		{
			groupSize[i] = 0;
			means[i] = 0;
			ssB[i] = 0;
			ssW[i] = 0;
			ssT[i] = 0;
			dn = -1;         //dn is reset so that the F value won't show up upon button click
		}
	}


	public double get_SSTotal()
	{
		return ssT[groupNumber];
	}

	public double get_Proportion()
	{
		return Math.abs(ssT[groupNumber]-0.0)<0.001? 0:ssB[groupNumber]/ssT[groupNumber];
	}

	public int get_groupSize(int id)
	{
		return groupSize[id];
	}

	public double get_Means(int id)
	{
		return means[id];
	}

	public double get_ssB(int id)
	{
		return ssB[id];
	}

	public double get_ssW(int id)
	{
		return ssW[id];
	}

	public double get_ssT(int id)
	{
		return ssT[id];
	}

	public int get_dn()
	{
		return dn;
	}

	public int get_dd()
	{
		return (N-dn-1);
	}

	public double get_FValue()
	{
		return (ssB[groupNumber]/dn)/(ssW[groupNumber]/(N-dn-1));
	}

	public double get_PValue()
	{
		double fr = (ssB[groupNumber]/dn)/(ssW[groupNumber]/(N-dn-1));
		return (probFandT1.probF(fr, dn, N-dn-1));
	}

}//end of class anova