package wayanova;
import java.awt.*;

public class diagram extends Canvas
{
	int degreeOfSSB, degreeOfSSW;
	boolean DispDiag = false;
	double ssTotal=0;
	int diameter;
	final double ssStd=10;			//ssStd & deameterStd & this.getSize().width
	final int diameterStd=10;		//determine the maximum displayable SSTotal = 2560
	Image offscreenImg;
	Graphics offscreenG;

	/**
	 *class constructor.
	 */
	public diagram()
	{
		setSize(200,215);
		setBackground(Color.lightGray);
	}

	public void update(Graphics g)
	{
		paint(g);
	}

	/**
	 * Display the diagram according to ssTotal/ssStd, won't dispaly ssTotal>2560.
	 * According to the ratio of SS Between & SS Within, display the pie chart.
	 */
	public void paint(Graphics g)
	{
		int x,y;
		diameter = (int)(diameterStd*Math.sqrt(ssTotal/ssStd));
		offscreenImg = createImage(this.getSize().width, this.getSize().height);
		offscreenG = offscreenImg.getGraphics();

		if(DispDiag)
			if(diameter>=this.getSize().width)
			{
				offscreenG.setColor(Color.red);
				offscreenG.drawString("SS Total too big to display", 30, 60);
			}
			else
			{
				x = (this.getSize().width-diameter)/2;
				y = (this.getSize().height-diameter)/2-10;
				offscreenG.setColor(new Color(4585983));
				offscreenG.fillArc(x,y,diameter,diameter,90,degreeOfSSB);
				offscreenG.setColor(Color.darkGray);
				offscreenG.fillArc(x,y,diameter,diameter,90+degreeOfSSB,degreeOfSSW);
			}

		offscreenG.setFont(new Font("TimesRoman", Font.PLAIN, 12));    //legend
		offscreenG.setColor(new Color(4585983));
		offscreenG.fillRect(40,193,12,12);
		offscreenG.setColor(Color.black);
		offscreenG.drawString("SS Between",55,203);
		offscreenG.setColor(Color.darkGray);
		offscreenG.fillRect(125,193,12,12);
		offscreenG.setColor(Color.black);
		offscreenG.drawString("SS Within",140,203);
		offscreenG.drawRect(0,0,this.getSize().width-1, this.getSize().height-1);
		g.drawImage(offscreenImg, 0, 0, this);
		offscreenG.dispose();

	}

	/**
	 *Set up the diagram to be displayed or not.
	 */
	public void setDispDiag(boolean d)			//controls whether to display the diagram
	{
		DispDiag = d;
	}

	public void setSSTotal(double ss)
	{
		ssTotal = ss;
	}

	/**
	 *Set up the portion of pie chart to be dipslayed according to SS Between & SS Within.
	 */
	public void setProportion(double p)
	{
		degreeOfSSB = (int)(p*360);
		degreeOfSSW = 360-degreeOfSSB;
	}


}//end of class Diagram
