/*
	This part is in charge of the textual display of one-way ANOVA results
*/

package wayanova;
import RVLS.*;
import java.awt.*;

public class result extends Panel
{
	public result()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(600,158);
		setFont(new Font("TimesRoman", Font.PLAIN, 12));
		label10 = new java.awt.Label("Summary table of ANOVA analysis");
		label10.setBounds(369,12,200,17);
		add(label10);
		anova1 = new anova();
		//$$ anova1.move(0,26);
		label9 = new java.awt.Label("Total");
		label9.setBounds(317,92,40,21);
		add(label9);
		label8 = new java.awt.Label("Within");
		label8.setBounds(317,72,40,21);
		add(label8);
		label7 = new java.awt.Label("Between");
		label7.setBounds(317,52,40,21);
		add(label7);
		label6 = new java.awt.Label("p");
		label6.setBounds(567,32,10,21);
		add(label6);
		label5 = new java.awt.Label("F");
		label5.setBounds(527,32,10,21);
		add(label5);
		label4 = new java.awt.Label("MS");
		label4.setBounds(477,32,20,21);
		add(label4);
		label3 = new java.awt.Label("df");
		label3.setBounds(437,32,20,21);
		add(label3);
		label2 = new java.awt.Label("SSq");
		label2.setBounds(387,32,30,21);
		add(label2);
		label1 = new java.awt.Label("Source");
		label1.setBounds(317,32,40,21);
		add(label1);
		//}}
	}

	//{{DECLARE_CONTROLS
	java.awt.Label label10;
	anova anova1;
	java.awt.Label label9;
	java.awt.Label label8;
	java.awt.Label label7;
	java.awt.Label label6;
	java.awt.Label label5;
	java.awt.Label label4;
	java.awt.Label label3;
	java.awt.Label label2;
	java.awt.Label label1;
	//}}
	final int groupNumber=3;
	Image offscreenImg;
	Graphics offscreenG;
	Font bigFont;
	Font smlFont=new Font("TimesRoman", Font.PLAIN, 9);
	double[] SSq = new double[3];
	int[] df = new int[3];


	public void update(Graphics g)
	{
		paint(g);
	}

	void clear()
	{
		anova1.clear_Stats();
		repaint();
	}

	public void paint(Graphics g)
	{
		int xOffset, yOffset, i, groupSize;
		String sTemp;
		FontMetrics fm;
		double d;

		offscreenImg = createImage(this.getSize().width, this.getSize().height);
		offscreenG = offscreenImg.getGraphics();
		bigFont = offscreenG.getFont();
		fm = offscreenG.getFontMetrics();

		offscreenG.drawString("Group(i)", 10, 25);
		offscreenG.drawString("n", 79, 25);
		draw_sub("i",85,28);
		offscreenG.drawString("Mean(x", 115, 25);
		draw_sub("i",151,28);
		offscreenG.drawLine(145, 16, 151, 16);
		offscreenG.drawString(")",155,25);

		xOffset = 175;
		yOffset = 17;
		offscreenG.drawLine(xOffset,yOffset,xOffset+6,yOffset);				//
		offscreenG.drawLine(xOffset,yOffset,xOffset+6,yOffset+4);			//  sigma sign
		offscreenG.drawLine(xOffset,yOffset+9,xOffset+6,yOffset+4);			//	goes here
		offscreenG.drawLine(xOffset,yOffset+9,xOffset+6,yOffset+9);			//
		offscreenG.drawString("(x-x", 185, 25);
		draw_sub("i",204,28);
		offscreenG.drawString(")", 208, 25);
		draw_sub("2", 212, 21);
		offscreenG.drawLine(198, 16, 204, 16);

		offscreenG.drawString("n",231,25);
		draw_sub("i",238,28);
		offscreenG.drawString("(x",242,25);
		draw_sub("i",252,28);
		offscreenG.drawString("-X)", 256,25);
		draw_sub("2",273,21);
		offscreenG.drawLine(245, 16, 251, 16);
		offscreenG.drawLine(260, 14, 268, 14);

		for(i=0, yOffset=46; i<=groupNumber; i++, yOffset=46+i*20)
		{
			xOffset = 30;
			if(i==3)
				sTemp = "Total";
			else
				sTemp = Integer.toString(i+1);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 85;
			groupSize = anova1.get_groupSize(i);
			sTemp = groupSize==0? "":Integer.toString(groupSize);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);

			xOffset = 145;
			if(i<groupNumber)
			{
				sTemp = groupSize==0? "" : format(anova1.get_Means(i), 2);
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			}

			xOffset = 205;
			sTemp = groupSize==0? "" : format(anova1.get_ssW(i), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);

			xOffset = 265;
			sTemp = groupSize==0? "" : format(anova1.get_ssB(i), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
		}

		groupSize = anova1.get_groupSize(groupNumber);
		sTemp = groupSize==0? "": format(anova1.get_Means(groupNumber),2);
	  //offscreenG.drawString("Grand Mean of Total:   "+sTemp,10,yOffset);
		offscreenG.drawString("Grand Mean:                 "+sTemp,10,yOffset);
		//offscreenG.drawLine(75, yOffset-10, 84, yOffset-10);

		if( anova1.get_dn() >= 1 && anova1.get_dd() >= 1)
		{
			SSq[0] = anova1.get_ssB(groupNumber);
			SSq[1] = anova1.get_ssW(groupNumber);
			SSq[2] = SSq[0]+SSq[1];

			df[0] = anova1.get_dn();
			df[1] = anova1.get_dd();
			df[2] = df[0]+df[1];

			for(i=0, yOffset = 65; i<3; i++, yOffset+=20)
			{
				xOffset = 410;
				sTemp = format(SSq[i],2);
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);

				xOffset = 445;
				sTemp = Integer.toString(df[i]);
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			}

			for(i=0, xOffset=500, yOffset=65; i<2; i++, yOffset+=20)
			{
				d = SSq[i]/df[i];
				sTemp = format(d,2);
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			}

			d = anova1.get_FValue();
			sTemp = format(d,2);
			offscreenG.drawString(sTemp, 545-fm.stringWidth(sTemp), 65);

			d = anova1.get_PValue();
			sTemp = format(d,2);
			offscreenG.drawString(sTemp, 582-fm.stringWidth(sTemp), 65);
		}

		g.drawImage(offscreenImg,0,0,this);
		offscreenG.dispose();

	}//end of paint()


	void draw_sub(String s, int x, int y)
	{
		offscreenG.setFont(smlFont);
		offscreenG.drawString(s,x,y);
		offscreenG.setFont(bigFont);
	}


	public String format(double d, int i) //i: # of decimal digits
	{
		String s;
		int n = (int)Math.pow(10,i);
		d = (double)(Math.round(d*n))/n;		//d is rounded

		s = Double.toString(d);                //s is either 1.2 or 1.23
		for(n=s.length()-s.indexOf('.'); n<i+1; n++)
			s = s+"0";

		return(s);
	}

}//end of public class result