/*
	A basic extension of the java.applet.Applet class
 */

package wayanov;

import java.awt.*;
import RVLS.*;

public class MeanFig extends Canvas
{
	/**
	 *class constructor.
	 */
	public MeanFig()
	{
		// Take out this line if you don't use symantec.itools.net.RelativeURL or symantec.itools.awt.util.StatusScroller
		//symantec.itools.lang.Context.setApplet(this);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		//setLayout(null);
		setSize(426,266);
		//setBackground(Color.gray);
		//}}
	}
	//{{DECLARE_CONTROLS
	//}}

	double[] mean = new double[6];
	double[] YL;
	LT Ly;
	int[] y = new int[6];
	boolean drawFig=false,fade=false;
	double dmax, dmin;
	int ymax, ymin=15, xmax, xmin=30, imax=0, imin=0;
	int x0,x1,x2;

	FontMetrics fm;
	Image  	    offscreenImg;
	Graphics 	offscreenG;

	int id; //for notified interface

	Color colorA1 = new Color(255, 0, 0);
	Color colorA2 = new Color(0, 255, 0);

	String A = "A";
	String B = "B";

	notified myNotify;

	public void setData(double[] x)
	{
		setData(x, false);
	}

	/**
	 *setData passes an array of means sent to paint() to draw mean figure
	 */
	public void setData(double[] x, boolean fade)
	{
		int i,j;

		this.fade = fade;

		dmax=x[0];
		dmin=x[0];
		i = x.length;

		if (i==6)
		{
			drawFig = true;

			for (j=0; j<i; j++)
			{
				mean[j]=x[j];

				if (mean[j] > dmax)
				{
					dmax = mean[j];
					imax = j;
				}

				if (mean[j] < dmin)
				{
					dmin = mean[j];
					imin = j;
				}
			}

			if (Math.abs(dmax-dmin)< 0.005)
			{
					dmax=dmax+5;
					dmin=dmin-5;
			}

			ymax = getSize().height - ymin;
			xmax = getSize().width - xmin;

			repaint();
		}
		else
			drawFig = false;
	}

	/**
	 *setClear() will only dispaly all 0 means.
	 */
	public void setClear()
	{
		double[] d = {0, 0, 0, 0, 0, 0};
		setData(d);
	}

	public void clear()
	{
		drawFig = false;
		repaint();
	}

	public void setId(int id)
	{
		this.id = id;
	}

	public void setZero()
	{
		double [] d = {0,0,0,0,0,0};
		setData(d, fade);
	}

	public void setColor(Color A, Color B)
	{
		colorA1 = A;
		colorA2 = B;
	}

	public void setInform(notified myNotify)
	{
		this.myNotify = myNotify;
	}

	public void setString(String A, String B)
	{
		this.A = A;
		this.B = B;
	}

	public void update(Graphics g)
	{
		paint(g);
	}


	/**
	 * Draw mean figure, determine the fade or not-fade color according to drawFig boolean
	 * value. If drawFig==false, will only display sample size <1 warning message.
	 * Call Yaxis.ticks to get the y labels, call LT(YL[YL.length-1], YL[0],ymin, ymax)
	 * to get Ly so that y[i] coordinates and mean values can be converted to each other
	 * easily.
	 */
	public void paint(Graphics g)
	{
		String sTemp;
		double d, dd;
		int i, numLabels, decY, yOffset, xOffset;

		offscreenImg = createImage(this.getSize().width, this.getSize().height);
		offscreenG = offscreenImg.getGraphics();
		fm = offscreenG.getFontMetrics();

		if (drawFig == true)
		{
		drawAxis();

		offscreenG.setColor(colorA1);         //draw A1 figure
		if (fade==true) offscreenG.setColor(new Color(255,128,128));
		offscreenG.fillOval(x0-2, y[0]-2, 5, 5);
		offscreenG.drawLine(x0, y[0], x1, y[1]);
		offscreenG.fillOval(x1-2, y[1]-2, 5, 5);
		offscreenG.drawLine(x1, y[1], x2, y[2]);
		offscreenG.fillOval(x2-2, y[2]-2, 5, 5);

		offscreenG.setColor(colorA2);         //draw A2 figure
		if (fade==true) offscreenG.setColor(new Color(128,128,255));
		offscreenG.fillOval(x0-2, y[3]-2, 5, 5);
		offscreenG.drawLine(x0, y[3], x1, y[4]);
		offscreenG.fillOval(x1-2, y[4]-2, 5, 5);
		offscreenG.drawLine(x1, y[4], x2, y[5]);
		offscreenG.fillOval(x2-2, y[5]-2, 5, 5);

		if (fade==true) offscreenG.setColor(Color.lightGray);
		else offscreenG.setColor(Color.black);

		offscreenG.drawString(A+"1", (x2+11)-fm.stringWidth(A+"1")/2, y[2]+5);
		offscreenG.drawString(A+"2", (x2+11)-fm.stringWidth(A+"2")/2, y[5]+5);

		g.drawImage(offscreenImg,0,0,this);
		offscreenG.dispose();
	    }
	    else
	    {
	    	offscreenG.setColor(new Color(180,0,0));
	    	sTemp="Sample size must >= 1 in";
	    	offscreenG.drawString(sTemp, 15, 30);
	    	sTemp="each group to do two-way";
			offscreenG.drawString(sTemp, 15, 45);
			sTemp="ANOVA analysis!";
			offscreenG.drawString(sTemp, 15, 60);

			g.drawImage(offscreenImg,0,0,this);
			offscreenG.dispose();
		}
	}

	/**
	 * Draw X and Y axises and the Y labels.
	 */
	public void drawAxis()
	{
		String lastLab,sTemp;
		double d;
		int    i, decY;

		offscreenG.setFont(new Font("TimesRoman",Font.BOLD, 12));
		sTemp = "Figure of Means";
		offscreenG.drawString(sTemp, (xmax+xmin)/2-fm.stringWidth(sTemp)/2, ymin);

		if (fade == true) 	offscreenG.setColor(Color.lightGray);
		offscreenG.drawLine(xmin, ymin, xmin, ymax); // draw y axis
		offscreenG.drawLine(xmin, ymax, xmax, ymax); // draw x axis

		offscreenG.setFont(new Font("TimesRoman",Font.PLAIN, 12));
		d = (double)(xmax-xmin)/(double)6 + (double)xmin;
		x0 = (int)Math.round(d);
		offscreenG.drawLine(x0, ymax-3, x0, ymax); //draw b1 line
		offscreenG.drawString(B+"1", x0-fm.stringWidth(B+"1")/2, ymax+ymin);

		d = (double)(xmax-xmin)/(double)2 + (double)xmin;
		x1 = (int)Math.round(d);
		offscreenG.drawLine(x1, ymax-3, x1, ymax); //draw b2 line
		offscreenG.drawString(B+"2", x1-fm.stringWidth(B+"2")/2, ymax+ymin);

		d = (double)((xmax-xmin)*5)/(double)6 + (double)xmin;
		x2 = (int)Math.round(d);
		offscreenG.drawLine(x2, ymax-3, x2, ymax); //draw b3 line
		offscreenG.drawString(B+"3", x2-fm.stringWidth(B+"3")/2, ymax+ymin);

		//get Y axis ticks, adjust for max and min value, let the figure in the center
		//double [] YL = Yaxis.ticks(dmin-0.1*(dmax-dmin),dmax+0.05*(dmax-dmin),ymin,ymax,offscreenG);
		YL = Yaxis.ticks(dmin-0.1*(dmax-dmin),dmax+0.05*(dmax-dmin),ymin,ymax,offscreenG);

		if ( (YL[1]-YL[0]) >= 1) decY=0;
		else if ( (YL[1]-YL[0]) >= 0.1) decY=1;
		else if ( (YL[1]-YL[0]) >= 0.01) decY=2;
		else decY=3;

		//LT Ly = new LT(YL[YL.length-1], YL[0],ymin, ymax);//set range for Y axis
		Ly = new LT(YL[YL.length-1], YL[0],ymin, ymax);
		y = Ly.ItransformArray(mean);

		int[]  labelp = Ly.ItransformArray(YL);

		offscreenG.setFont(new Font("TimesRoman",Font.PLAIN, 10));
		fm = offscreenG.getFontMetrics();
		int adj= (fm.getAscent())/2;

		//draw y labels
		lastLab="";
		for (i=0; i<labelp.length; i++)
		{
			sTemp = graphUtilities.format(YL[i] - 0.0000001, decY);
			offscreenG.drawLine(xmin, labelp[i], xmin+3, labelp[i]);
			if (! sTemp.equals(lastLab) )
				offscreenG.drawString(sTemp, xmin-6-fm.stringWidth(sTemp), labelp[i]+adj);
			lastLab = sTemp;
		}
	}

	/**
	 *format a double number to display a string of certain decimal points
	 */
	public String format(double d, int i) //i: # of decimal digits
	{
		String s;
		int n = (int)Math.pow(10,i);
		d = (double)(Math.round(d*n))/n;		//d is rounded

		s = Double.toString(d);                //s is either 1.2 or 1.23
		for(n=s.length()-s.indexOf('.'); n<i+1; n++)
			s = s+"0";

		return(s);
	}
}
