package wayanov;

import java.awt.*;
//import java.applet.*;
//import MeanFig.*;
import RVLS.*;


public class MeanFigDraw extends MeanFig
{
	/**
	 *class constructor, extends MeanFig, has the two-way communication capbility.
	 */
	public MeanFigDraw()
	{
		super();
		// Take out this line if you don't use symantec.itools.net.RelativeURL or symantec.itools.awt.util.StatusScroller
		//symantec.itools.lang.Context.setApplet(this);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		//setLayout(null);
		setSize(426,266);

		//setBackground(Color.gray);
		//}}

		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
		//}}
	}
	//{{DECLARE_CONTROLS
	//}}



	int i, lastX, lastY;
	int currentX, currentY;

	boolean found=false;


	/**
	 *return the array of mean values in the figure
	 */
	public double[] getData()
	{
		return(mean);
	}


	/**
	 *return the mean value of the point in the figure that just has been pressed or dragged.
	 */
	public double getDataPoint()
	{
		return(mean[i]);
	}


	/**
	 *return the data ID of the point in the figure that just has been pressed or dragged.
	 */
	public int getDataPosition()
	{
		return(i);
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{

		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == MeanFigDraw.this)
				MeanFigDraw_MousePressed(event);
		}

                public void mouseReleased(java.awt.event.MouseEvent event)
                {
                        Object object = event.getSource();
                        if (object == MeanFigDraw.this)
                                MeanFigDraw_MouseReleased(event);
		}
	}


	/**
	 * According to mouse pressed position, determines the data ID, i, of the point in the figure
	 * that has been pressed. If the mouse pressed position is not a mean postion, found==false,
	 * mouse-drag and mouse-released events will do nothing.
	 */
	void MeanFigDraw_MousePressed(java.awt.event.MouseEvent event)
	{
		int x, yy;
		x = event.getX();
		yy = event.getY();

		if ((Math.abs(x-x0)<5) || (Math.abs(x-x1)<5) || (Math.abs(x-x2)<5))
		{
			found=false;
			for (i=0; (i<6)&(found==false); i++)
			{
				if (Math.abs(yy-y[i]) < 5)
				{
					if ( ( (Math.abs(x-x0)<5) && ((i==0)||(i==3)) ) |
					   	 ( (Math.abs(x-x1)<5) && ((i==1)||(i==4)) ) |
					   	 ( (Math.abs(x-x2)<5) && ((i==2)||(i==5)) )  )
					found = true;

					lastY = y[i];
				}
			}
			i=i-1;
		}
	}

	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseDragged(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == MeanFigDraw.this)
				MeanFigDraw_MouseDragged(event);
		}
	}

	/**
	 * According to the data ID, i, that was set up during mouse pressed action, using XOR mode to keep track
	 * of drawing actions, displays the new data position and line positions.
	 * If the mouse did not press on the mean points, it will do nothing.
	 */
	void MeanFigDraw_MouseDragged(java.awt.event.MouseEvent event)
	{
		Graphics g=getGraphics();

		currentX = event.getX();
		currentY = event.getY();

		if (found==true)
		{
                  if (currentY > ymax)
                  y[i] = ymax;
                  else if (currentY < ymin)
                  y[i] = ymin;
                  else
                  y[i] = currentY;

                  mean[i] = Ly.transformToValue(y[i]);
                  repaint();
                  myNotify.dataChanged(id);
		}
	}

        void MeanFigDraw_MouseReleased(java.awt.event.MouseEvent event)
        {
          Graphics g=getGraphics();

          currentX = event.getX();
          currentY = event.getY();

          if (found==true)
          {
            if (currentY > ymax)
            y[i] = ymax;
            else if (currentY < ymin)
            y[i] = ymin;
            else
            y[i] = currentY;

            mean[i] = Ly.transformToValue(y[i]);
            repaint();
            myNotify.dataChanged(id);
            found=false;
          }

	}

}