package wayanov;

public class anova
{
	final int levelOfA = 3;						//factor A has 3 levels
	final int levelOfB = 2;						//factor B has 2 levels
	int sampleSize = 5;
	int MSE = 2;
	double[][] groupMean = { {5,5,5}, {20,20,20} };	//default values
	double[] margMeanA = {12.5, 12.5, 12.5};
	double[] margMeanB = {5, 20};
	double grandMean = 12.5;
	double SSE, SST, SSA, SSB, SSAB;

	public void anova()
	{
		calc_Stats();
	}

	public void setSampleSize(int n)
	{
		sampleSize = n;
	}

	public void setMSE(int mse)
	{
		MSE = mse;
	}

	public void setGroupMean(double d, int b, int a)   //update a single group
	{
		groupMean[b][a] = d;
		calc_Stats();
	}

	public void calc_Stats()
	{
		int a, b;
		double sum, delta;

		for(a=0; a<levelOfA; a++)				//A marginal means
		{
			for(b=0, sum=0; b<levelOfB; b++)
				sum += groupMean[b][a];
			margMeanA[a] = sum/levelOfB;
		}

		for(b=0; b<levelOfB; b++)				//B marginal means
		{
			for(a=0, sum=0; a<levelOfA; a++)
				sum += groupMean[b][a];
			margMeanB[b] = sum/levelOfA;
		}

		for(b=0, sum=0; b<levelOfB; b++)		//grand mean
			sum += margMeanB[b];
		grandMean = sum/levelOfB;

		for(a=0, SSA=0; a<levelOfA; a++)		//SSA
		{
			delta = margMeanA[a]-grandMean;
			SSA += delta*delta;
		}
		SSA *= (sampleSize*levelOfB);


		for(b=0, SSB=0; b<levelOfB; b++)		//SSB
		{
			delta = margMeanB[b]-grandMean;
			SSB += delta*delta;
		}
		SSB *= (sampleSize*levelOfA);


		for(a=0, SSAB=0; a<levelOfA; a++)		//SSAB
			for(b=0; b<levelOfB; b++)
			{
				delta = groupMean[b][a]-margMeanA[a]-margMeanB[b]+grandMean;
				SSAB += delta*delta;
			}
		SSAB *= sampleSize;

		SSE = MSE*levelOfA*levelOfB*(sampleSize-1);
		SST = SSA+SSB+SSAB+SSE;

	}//end of calc_stats()


	public void clear_Stats()
	{
		int a, b;

		for(b=0; b<levelOfB; b++)
			for(a=0; a<levelOfA; a++)
				groupMean[b][a] = 0;

	}


	public double get_SSE()
	{
		return SSE;
	}

	public double get_SSA()
	{
		return SSA;
	}

	public double get_SSB()
	{
		return SSB;
	}

	public double get_SSAB()
	{
		return SSAB;
	}

	public double get_SST()
	{
		return SST;
	}

	public int get_dfA()
	{
		return (levelOfA-1);
	}

	public int get_dfB()
	{
		return (levelOfB-1);
	}

	public int get_dfAB()
	{
		return (levelOfA-1)*(levelOfB-1);
	}

	public int get_dfError()
	{
		return (sampleSize-1)*levelOfA*levelOfB;
	}

	public int get_dfTotal()
	{
		return (levelOfA*levelOfB*sampleSize-1);
	}

}//end of class anova