package wayanov;
import java.awt.*;

public class diagram2way extends Canvas
{
	int degreeOfSSA, degreeOfSSB, degreeOfSSAB;
	boolean DispDiag;
	double ssTotal = 0, ssStd = 20;
	int diameter;					//ssStd & diameterStd & this.getSize().height
	final int diameterStd=6;		//determine the maximum displayable SSTotal = 190*190/6/6*ssStd
	Image offscreenImg;
	Graphics offscreenG;

	public diagram2way()
	{
		setSize(260,190);
		setBackground(new Color(-1973791));
	}

	public void update(Graphics g)
	{
		paint(g);
	}


	/**
	 * According to the given SSA, SSB, SSAB and SSTOTAL, draw color diagram and display
	 * the differences of sum of squares visually.
	 */
	public void paint(Graphics g)
	{
		int x,y;
		String sTemp;
		offscreenImg = createImage(this.getSize().width, this.getSize().height);
		offscreenG = offscreenImg.getGraphics();

		diameter = (int)(diameterStd*Math.rint(Math.sqrt(ssTotal/ssStd)));

		if(DispDiag)
		{
			if(diameter>=this.getSize().height)
			{
				offscreenG.setColor(Color.red);
				offscreenG.drawString("SS Total too big to display", 40, 60);
			}
			else
			{
				x = (this.getSize().width-60-diameter)/2;
				y = (this.getSize().height-diameter)/2;
				offscreenG.setColor(Color.yellow);
				offscreenG.fillArc(x,y,diameter,diameter,90,degreeOfSSA);
				offscreenG.setColor(Color.pink);
				offscreenG.fillArc(x,y,diameter,diameter,90+degreeOfSSA,degreeOfSSB);
				offscreenG.setColor(Color.cyan);
				offscreenG.fillArc(x,y,diameter,diameter,90+degreeOfSSA+degreeOfSSB,degreeOfSSAB);
				offscreenG.setColor(Color.darkGray);
				offscreenG.fillArc(x,y,diameter,diameter,90+degreeOfSSA+degreeOfSSB+degreeOfSSAB,360-degreeOfSSA-degreeOfSSB-degreeOfSSAB);
			}
		}

		offscreenG.setColor(Color.darkGray);
		offscreenG.drawRect(0,0,this.getSize().width-1,this.getSize().height-1);

		offscreenG.setFont(new Font("TimesRoman", Font.PLAIN, 10));    //legend
		offscreenG.setColor(Color.yellow);
		offscreenG.fillRect(195,40,6,6);
		offscreenG.setColor(Color.black);
		offscreenG.drawString("SSA",205,46);

		offscreenG.setColor(Color.pink);
		offscreenG.fillRect(195,75,6,6);
		offscreenG.setColor(Color.black);
		offscreenG.drawString("SSB",205,81);

		offscreenG.setColor(Color.cyan);
		offscreenG.fillRect(195,110,6,6);
		offscreenG.setColor(Color.black);
		offscreenG.drawString("SS A*B", 205, 116);

		offscreenG.setColor(Color.darkGray);
		offscreenG.fillRect(195,145,6,6);
		offscreenG.setColor(Color.black);
		offscreenG.drawString("SS Error", 205, 151);

		g.drawImage(offscreenImg, 0, 0, this);
		offscreenG.dispose();

	}

	public void setDispDiag(boolean d)
	{
		DispDiag = d;
	}


	/**
	 * Receive SSA, SSB, SSAB and SSTOTAL from a two-way ANOVA design.
	 */
	public void setProportion(double a, double b, double ab, double t)
	{
		ssTotal = t;
		degreeOfSSA = (int)(a/t*360);
		degreeOfSSB = (int)(b/t*360);
		degreeOfSSAB = (int)(ab/t*360);
	}
}//end of class Diagram
