package wayanov;

import RVLS.*;
import java.awt.*;

public class result extends Panel
{
	public result()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(600,200);
		setFont(new Font("Times", Font.PLAIN, 12));
		anova1 = new anova();
		//$$ anova1.move(2,4);
		label_total = new java.awt.Label("Total",Label.CENTER);
		label_total.setBounds(10,132,37,20);
		label_total.setBackground(new Color(-1973791));
		add(label_total);
		label_SS = new java.awt.Label("SSQ",Label.CENTER);
		label_SS.setBounds(79,19,25,20);
		add(label_SS);
		diagram1 = new diagram2way();
		diagram1.setBounds(345,5,245,181);
		diagram1.setBackground(new Color(-1973791));
		add(diagram1);
		label15 = new java.awt.Label("p",Label.CENTER);
		label15.setBounds(300,19,25,20);
		add(label15);
		label14 = new java.awt.Label("F",Label.CENTER);
		label14.setBounds(251,19,25,20);
		add(label14);
		label_MS = new java.awt.Label("MS",Label.CENTER);
		label_MS.setBounds(185,19,25,20);
		add(label_MS);
		label11 = new java.awt.Label("Error",Label.CENTER);
		label11.setBounds(10,110,37,20);
		label11.setBackground(new Color(12632256));
		add(label11);
		label10 = new java.awt.Label("AB",Label.CENTER);
		label10.setBounds(10,88,37,20);
		label10.setBackground(new Color(65535));
		add(label10);
		label9 = new java.awt.Label("B",Label.CENTER);
		label9.setBounds(10,66,37,20);
		label9.setBackground(new Color(16756655));
		add(label9);
		label8 = new java.awt.Label("A",Label.CENTER);
		label8.setBounds(10,44,37,20);
		label8.setBackground(new Color(16776960));
		add(label8);
		label_df = new java.awt.Label("df");
		label_df.setBounds(139,19,25,20);
		add(label_df);
		label_source = new java.awt.Label("Source");
		label_source.setBounds(12,20,38,20);
		add(label_source);
		//}}

		anova1.calc_Stats();
		diagram1.setProportion(anova1.get_SSA(), anova1.get_SSB(), anova1.get_SSAB(), anova1.get_SST());
		diagram1.setDispDiag(true);
	}

	//{{DECLARE_CONTROLS
	anova anova1;
	java.awt.Label label_total;
	java.awt.Label label_SS;
	diagram2way diagram1;
	java.awt.Label label15;
	java.awt.Label label14;
	java.awt.Label label_MS;
	java.awt.Label label11;
	java.awt.Label label10;
	java.awt.Label label9;
	java.awt.Label label8;
	java.awt.Label label_df;
	java.awt.Label label_source;
	//}}

	final int levelOfA = 3;
	final int levelOfB = 2;
	boolean statsAvailable = true;
	Image offscreenImg;
	Graphics offscreenG;
	probFandT probFandT1;
	final Color[] color = {Color.yellow, Color.pink, Color.cyan};

	public boolean get_StatsAvailable()
	{
		return statsAvailable;
	}

	void showResult()
	{
		anova1.calc_Stats();

		diagram1.setProportion(anova1.get_SSA(), anova1.get_SSB(), anova1.get_SSAB(), anova1.get_SST());
		diagram1.setDispDiag(true);
		diagram1.repaint();

		statsAvailable = true;
		repaint();             		//update text display
	}

	public void update(Graphics g)
	{
		paint(g);
	}

	void clear()
	{
		diagram1.setDispDiag(false);
		diagram1.repaint();

		anova1.clear_Stats();

		statsAvailable = false;
		repaint();
	}

	public void paint(Graphics g)
	{
		int xOffset, yOffset, a, b, i, groupSize;
		String sTemp;
		FontMetrics fm;
		double[] SS = new double[5];
		int[] df = new int[5];
		double[] MS = new double[5];
		double[] FValue = new double[5];
		double[] PValue = new double[5];

		offscreenImg = createImage(this.getSize().width, this.getSize().height);
		offscreenG = offscreenImg.getGraphics();
		fm = offscreenG.getFontMetrics();

/*		for(i=0,xOffset=12,yOffset=44; i<3; i++,yOffset+=22)
		{
			offscreenG.setColor(color[i]);
			offscreenG.fillRect(xOffset,yOffset,290,20);
		}
*/
		//System.out.println("statsAvailable=="+statsAvailable);

		offscreenG.setColor(Color.black);
		if(statsAvailable==true)				//significance test goes here
		{

			SS[0] = anova1.get_SSA();
			SS[1] = anova1.get_SSB();
			SS[2] = anova1.get_SSAB();
			SS[3] = anova1.get_SSE();
			SS[4] = anova1.get_SST();

			df[0] = anova1.get_dfA();
			df[1] = anova1.get_dfB();
			df[2] = anova1.get_dfAB();
			df[3] = anova1.get_dfError();
			df[4] = anova1.get_dfTotal();

			offscreenG.setColor(Color.yellow);
			offscreenG.fillRect(47,44, 275, 20);
			offscreenG.setColor(Color.pink);
			offscreenG.fillRect(47,66, 275, 20);
			offscreenG.setColor(Color.cyan);
			offscreenG.fillRect(47,88, 275, 20);
			offscreenG.setColor(Color.lightGray);
			offscreenG.fillRect(47,110, 275, 20);
			offscreenG.setColor(new Color(-1973791));
			//offscreenG.setColor(Color.lightGray);
			offscreenG.fillRect(47,132, 275, 20);

			offscreenG.setColor(Color.black);
			yOffset = 57;
			for(i=0; i<5; i++, yOffset+=22)
			{
				xOffset = 105;
				sTemp = Utility.format(SS[i], 2);
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);

				xOffset = 145;
				sTemp = Integer.toString(df[i]);
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			}

			yOffset = 57;
			for(i=0; i<4; i++, yOffset+=22)
			{
				xOffset = 210;
				if(df[i] != 0)
				{
					MS[i] = SS[i]/df[i];
					sTemp = Utility.format(MS[i],2);
				}
				else
					sTemp = "n/a";

				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			}

			yOffset = 57;
			for(i=0; i<3; i++, yOffset+=22)
			{
				xOffset = 270;

				if(df[3] != 0)
				{
					FValue[i] = MS[i]/MS[3];
					sTemp = Utility.format(FValue[i],2);
				}
				else
					sTemp = "n/a";
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);

				xOffset = 320;
				if(df[3] != 0)
				{
					PValue[i] = probFandT1.probF(FValue[i], df[i], df[3]);
					sTemp = Utility.format(PValue[i],2);
				}
				else
					sTemp = "n/a";
				offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			}
		}
		else
		{
			offscreenG.setColor(Color.yellow);
			offscreenG.fillRect(47,44, 275, 20);
			offscreenG.setColor(Color.pink);
			offscreenG.fillRect(47,66, 275, 20);
			offscreenG.setColor(Color.cyan);
			offscreenG.fillRect(47,88, 275, 20);
			offscreenG.setColor(Color.lightGray);
			offscreenG.fillRect(47,110, 275, 20);
			offscreenG.setColor(new Color(-1973791));
			offscreenG.fillRect(47,132, 275, 20);
			//statsAvailable = true;
		}

		g.drawImage(offscreenImg,0,0,this);
		offscreenG.dispose();

	}//end of paint()

}//end of public class result