package wayanova;
/*
	A basic extension of the java.applet.Applet class
 */
//package RVLS;
//import twoanov;
import java.awt.*;
import java.applet.*;
import RVLS.*;


public class commonality extends Panel
{
	/**
	* class constructor, commonality calculates SS compositions for type I, II & III
	* ANOVA analyses
	*/
	public commonality()
	{
		// Take out this line if you don't use symantec.itools.net.RelativeURL or symantec.itools.awt.util.StatusScroller
		//symantec.itools.lang.Context.setApplet(this);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(200,160);
		setFont(new Font("TimesRoman", Font.PLAIN, 12));
		twoanov1 = new twoanov();
		choice2 = new java.awt.Choice();
		choice2.addItem("Source A");
		choice2.addItem("Source B");
		choice2.addItem("Source AB");
                choice2.setFont(new Font("TimesRoman", Font.PLAIN, 11));
		add(choice2);
		choice2.setBounds(105,125,90,16);
		choice1 = new java.awt.Choice();
		choice1.addItem("Type I");
		choice1.addItem("Type II");
		choice1.addItem("Type III");
                choice1.setFont(new Font("TimesRoman", Font.PLAIN, 11));
		add(choice1);
		choice1.setBounds(18,125,85,16);
		//}}

		//{{REGISTER_LISTENERS
		SymItem lSymItem = new SymItem();
		choice1.addItemListener(lSymItem);
		choice2.addItemListener(lSymItem);
		//}}
	}

	//{{DECLARE_CONTROLS
	twoanov twoanov1;
	java.awt.Choice choice2;
	java.awt.Choice choice1;
	//}}

	boolean drawFigure=false,fade=false;

	/**
	 *setFig determines whether to show the commonality results, fade or not fade.
	 */
	void setFig(boolean fade)
	{
		drawFigure = true;
		this.fade = fade;
		repaint();
	}

	/**
	 * clear() will be called only when sample size < 1 in certain testing group,
	 * it causes commonality displays a warning message.
	 */
	void clear()
	{
		drawFigure = false;
		repaint();
	}

	public void update(Graphics g)
	{
		paint(g);
	}


	/**
	 * Paint in three situations, display commonality result with or without fade,
	 * or display warning message if sample size < 1 in certain group
	 */
	public void paint(Graphics g)
	{
		int xOffset=18, yOffset=10;
		message m;

		String sTemp="";
		FontMetrics fm;
		Font oldFont;

		Image offscreenImg;
		Graphics offscreenG;

		offscreenImg = createImage(this.getSize().width, this.getSize().height);
		offscreenG = offscreenImg.getGraphics();
		fm = offscreenG.getFontMetrics();

		if ( (drawFigure == true) && (fade==false) )
		{

			choice2.setVisible(true);
			choice1.setVisible(true);

			//m = new message("\r drawFigure="+drawFigure+" fade="+fade);
			//m.show();
			//setFont(new Font("TimesRoman", Font.PLAIN, 12));

			sTemp = "Unique:       A            B           AB";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			yOffset = yOffset+18;
			xOffset=85;
			sTemp = format(twoanov1.get_u_A(),2);
			if (choice2.getSelectedIndex() == 0)
				offscreenG.setColor(Color.magenta);
			else
				offscreenG.setColor(Color.black);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_u_B(),2);
			if (choice2.getSelectedIndex() == 1)
				offscreenG.setColor(Color.magenta);
			else
				offscreenG.setColor(Color.black);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_u_AB(),2);
			if (choice2.getSelectedIndex() == 2)
				offscreenG.setColor(Color.magenta);
			else
				offscreenG.setColor(Color.black);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset=18;
			yOffset = yOffset+18;
			offscreenG.setColor(Color.black);
			sTemp = "Common:  A&B     A&AB    B&AB";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			yOffset = yOffset+18;
			xOffset=85;
			sTemp = format(twoanov1.get_c_AB(),2);
			if ((choice2.getSelectedIndex()==0) & (choice1.getSelectedIndex()==0))
				offscreenG.setColor(Color.magenta);
			else
				offscreenG.setColor(Color.black);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_c_AAB(),2);
			if ((choice2.getSelectedIndex()==0) & (choice1.getSelectedIndex()<2))
				offscreenG.setColor(Color.magenta);
			else
				offscreenG.setColor(Color.black);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_c_BAB(),2);
			if ((choice2.getSelectedIndex()==1) & (choice1.getSelectedIndex()<2))
				offscreenG.setColor(Color.magenta);
			else
				offscreenG.setColor(Color.black);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset=18;
			yOffset = yOffset+18;
			offscreenG.setColor(Color.black);
			sTemp = "Common:  A&B&AB";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			yOffset = yOffset+18;
			xOffset=90;
			sTemp = format(twoanov1.get_c_ABAB(),2);
			if ((choice2.getSelectedIndex()==0) & (choice1.getSelectedIndex()==0))
				offscreenG.setColor(Color.magenta);
			else
				offscreenG.setColor(Color.black);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset=18;
			yOffset = yOffset+18;
			offscreenG.setColor(Color.black);
			sTemp = "Choose ANOVA Sum of Squares:";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			if (choice2.getSelectedIndex() == 0)  //A
			{
				if (choice1.getSelectedIndex() == 0) //type 1
					sTemp = format(twoanov1.getSSA(1),2);
				else if (choice1.getSelectedIndex() == 1)	//type 2
					sTemp = format(twoanov1.getSSA(2),2);
				else
					sTemp = format(twoanov1.getSSA(3),2); //type 3
			}
			else if (choice2.getSelectedIndex() == 1)  //B
			{
				 if (choice1.getSelectedIndex() < 2) //type 1&2
				 	sTemp = format(twoanov1.getSSB(1),2);
				 else
				 	sTemp = format(twoanov1.getSSB(3),2); //type 3
			}
			else
			{
				sTemp = format(twoanov1.getSSAB(),2); //AB
			}

			xOffset=195;
			yOffset = yOffset+42;
			//offscreenG.drawString("SS of choice: ", xOffset-fm.stringWidth(sTemp)-fm.stringWidth("SS of choice: "), yOffset);
			offscreenG.drawString("Chosen SS:   ",  xOffset-fm.stringWidth(sTemp)-fm.stringWidth("chosen SS:   "), yOffset);
			offscreenG.setColor(Color.magenta);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			g.drawImage(offscreenImg,0,0,this);
			offscreenG.dispose();
		}
		else if ( (drawFigure == true) && (fade==true) )
		{
			//m = new message("\r drawFigure="+drawFigure+" fade="+fade);
			//m.show();

			sTemp = "Unique:       A            B           AB";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			yOffset = yOffset+18;
			xOffset=85;
			sTemp = format(twoanov1.get_u_A(),2);
			if (choice2.getSelectedIndex() == 0)
				offscreenG.setColor(new Color(255,180,255));
			else
				offscreenG.setColor(Color.lightGray);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_u_B(),2);
			if (choice2.getSelectedIndex() == 1)
				offscreenG.setColor(new Color(255,180,255));
			else
				offscreenG.setColor(Color.lightGray);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_u_AB(),2);
			if (choice2.getSelectedIndex() == 2)
				offscreenG.setColor(new Color(255,180,255));
			else
				offscreenG.setColor(Color.lightGray);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset=18;
			yOffset = yOffset+18;
			offscreenG.setColor(Color.black);
			sTemp = "Common:  A&B     A&AB    B&AB";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			yOffset = yOffset+18;
			xOffset=85;
			sTemp = format(twoanov1.get_c_AB(),2);
			if ((choice2.getSelectedIndex()==0) & (choice1.getSelectedIndex()==0))
				offscreenG.setColor(new Color(255,180,255));
			else
				offscreenG.setColor(Color.lightGray);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_c_AAB(),2);
			if ((choice2.getSelectedIndex()==0) & (choice1.getSelectedIndex()<2))
				offscreenG.setColor(new Color(255,180,255));
			else
				offscreenG.setColor(Color.lightGray);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = xOffset+43;
			sTemp = format(twoanov1.get_c_BAB(),2);
			if ((choice2.getSelectedIndex()==1) & (choice1.getSelectedIndex()<2))
				offscreenG.setColor(new Color(255,180,255));
			else
				offscreenG.setColor(Color.lightGray);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset=18;
			yOffset = yOffset+18;
			offscreenG.setColor(Color.black);
			sTemp = "Common:  A&B&AB";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			yOffset = yOffset+18;
			xOffset=90;
			sTemp = format(twoanov1.get_c_ABAB(),2);
			if ((choice2.getSelectedIndex()==0) & (choice1.getSelectedIndex()==0))
				offscreenG.setColor(new Color(255,180,255));
			else
				offscreenG.setColor(Color.lightGray);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset=18;
			yOffset = yOffset+18;
			offscreenG.setColor(Color.black);
			sTemp = "Choose ANOVA Sum of Squares:";
			offscreenG.drawString(sTemp, xOffset, yOffset);

			if (choice2.getSelectedIndex() == 0)  //A
			{
				if (choice1.getSelectedIndex() == 0) //type 1
					sTemp = format(twoanov1.getSSA(1),2);
				else if (choice1.getSelectedIndex() == 1)	//type 2
					sTemp = format(twoanov1.getSSA(2),2);
				else
					sTemp = format(twoanov1.getSSA(3),2); //type 3
			}
			else if (choice2.getSelectedIndex() == 1)  //B
			{
				 if (choice1.getSelectedIndex() < 2) //type 1&2
				 	sTemp = format(twoanov1.getSSB(1),2);
				 else
				 	sTemp = format(twoanov1.getSSB(3),2); //type 3
			}
			else
			{
				sTemp = format(twoanov1.getSSAB(),2); //AB
			}

			xOffset=195;
			yOffset = yOffset+42;
			//offscreenG.drawString("SS of choice: ", xOffset-fm.stringWidth(sTemp)-fm.stringWidth("SS of choice: "), yOffset);
			offscreenG.drawString("Chosen SS:   ",  xOffset-fm.stringWidth(sTemp)-fm.stringWidth("Chosen SS:   "), yOffset);
			offscreenG.setColor(new Color(255,180,255));
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);
			g.drawImage(offscreenImg,0,0,this);
			offscreenG.dispose();
		}
		else
		{
			choice2.setVisible(false);
			choice1.setVisible(false);
			//setFont(new Font("Dialog", Font.PLAIN, 12));
	    	offscreenG.setColor(new Color(180,0,0));
	    	sTemp="Sample size must >= 1 in";
	    	offscreenG.drawString(sTemp, 30, 30);
	    	sTemp="each group to do two-way";
			offscreenG.drawString(sTemp, 30, 45);
			sTemp="ANOVA analysis!";
			offscreenG.drawString(sTemp, 30, 60);

			g.drawImage(offscreenImg,0,0,this);
			offscreenG.dispose();
		}
	}


	/**
	 *format a double number to display a string of certain decimal points
	 */
	public String format(double d, int i) //i: # of decimal digits
	{
		String s;
		int n = (int)Math.pow(10,i);
		d = (double)(Math.round(d*n))/n;		//d is rounded

		s = Double.toString(d);                //s is either 1.2 or 1.23
		for(n=s.length()-s.indexOf('.'); n<i+1; n++)
			s = s+"0";

		return(s);
	}


	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == choice1)
				choice1_ItemStateChanged(event);
			else if (object == choice2)
				choice2_ItemStateChanged(event);
		}
	}

	/**
	 *choose different SS by choice button, change display
	 */
	void choice1_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		repaint();
	}

	void choice2_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		repaint();
	}
}
