package wayanova;
/*
	This part is in charge of the display of the ANOVA results
*/

import symantec.itools.awt.WrappingLabel;
//import twoanov;
//import diagram;
import java.awt.*;
import RVLS.*;

public class result extends Panel
{
	public result()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(630,130);
		setFont(new Font("Times", Font.PLAIN, 12));
		twoanov1 = new RVLS.twoanov();
		//$$ twoanov1.move(0,0);
		wrappingLabel1 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel1.setText("Source      df");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel1.setBounds(5,22,80,16);
		add(wrappingLabel1);
		wrappingLabel4 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel4.setText("SSQ        MSE         F          p");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel4.setBounds(456,22,171,17);
		add(wrappingLabel4);
		wrappingLabel2 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel2.setText("ANOVA  Type III  Analysis");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel2.setBounds(458,2,171,17);
		wrappingLabel2.setFont(new Font("Times", Font.BOLD, 12));
		add(wrappingLabel2);
		wrappingLabel3 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel3.setText("SSQ        MSE         F          p");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel3.setBounds(276,22,171,17);
		add(wrappingLabel3);
		wrappingLabel5 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel5.setText("SSQ        MSE         F          p");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel5.setBounds(95,22,171,17);
		add(wrappingLabel5);
		wrappingLabel6 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel6.setText("ANOVA  Type I  Anaysis");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel6.setBounds(96,2,171,17);
		wrappingLabel6.setFont(new Font("Times", Font.BOLD, 12));
		add(wrappingLabel6);
		wrappingLabel7 = new symantec.itools.awt.WrappingLabel();
		try {
			wrappingLabel7.setText("ANOVA  Type II  Analysis");
		}
		catch(java.beans.PropertyVetoException e) { }
		wrappingLabel7.setBounds(278,2,171,17);
		wrappingLabel7.setFont(new Font("Times", Font.BOLD, 12));
		add(wrappingLabel7);
		//}}
	}

	//{{DECLARE_CONTROLS
	RVLS.twoanov twoanov1;
	symantec.itools.awt.WrappingLabel wrappingLabel1;
	symantec.itools.awt.WrappingLabel wrappingLabel4;
	symantec.itools.awt.WrappingLabel wrappingLabel2;
	symantec.itools.awt.WrappingLabel wrappingLabel3;
	symantec.itools.awt.WrappingLabel wrappingLabel5;
	symantec.itools.awt.WrappingLabel wrappingLabel6;
	symantec.itools.awt.WrappingLabel wrappingLabel7;
	//}}
	boolean drawFigure,fade;
	Image offscreenImg;
	Graphics offscreenG;

	void setFig(boolean fade)
	{
		drawFigure = true;
		this.fade = fade;
		repaint();
	}

	void clear()
	{
		drawFigure = false;
		twoanov1.clearData();
		repaint();
	}

	public void update(Graphics g)
	{
		paint(g);
	}

	public void paint(Graphics g)
	{
		int xOffset, yOffset=51, i, imin=0, imax=0;
		double[] mean;
		int[] y = new int[6];
		double max=0.0, min=99999.9, dd;

		String sTemp;
		FontMetrics fm;
		Font oldFont;

		offscreenImg = createImage(this.getSize().width, this.getSize().height);
		offscreenG = offscreenImg.getGraphics();
		fm = offscreenG.getFontMetrics();

		if (drawFigure == true)
		{
			//A type I
			xOffset = 20;
			sTemp = twoanov1.getSourceA();
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);


			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdA());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			if (fade == true) offscreenG.setColor(Color.lightGray);

			xOffset = 105;
			sTemp = format(twoanov1.getSSA(1),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 153;
			sTemp = format(twoanov1.getMSA(1), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 195;
			sTemp = format(twoanov1.get_F_A(1), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 235;
			sTemp = format(twoanov1.get_P_A(1), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//A type II

			xOffset = 290;
			sTemp = format(twoanov1.getSSA(2),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 335;
			sTemp = format(twoanov1.getMSA(2), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 377;
			sTemp = format(twoanov1.get_F_A(2), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 415;
			sTemp = format(twoanov1.get_P_A(2), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//A type III

			xOffset = 470;
			sTemp = format(twoanov1.getSSA(3),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 516;
			sTemp = format(twoanov1.getMSA(3), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 557;
			sTemp = format(twoanov1.get_F_A(3), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 595;
			sTemp = format(twoanov1.get_P_A(3), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//B type I

			offscreenG.setColor(Color.black);
			yOffset=yOffset+18;

			xOffset = 20;
			sTemp = twoanov1.getSourceB();
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdB());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			if (fade == true) offscreenG.setColor(Color.lightGray);

			xOffset = 105;
			sTemp = format(twoanov1.getSSB(1),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 153;
			sTemp = format(twoanov1.getMSB(1), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 195;
			sTemp = format(twoanov1.get_F_B(1), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 235;
			sTemp = format(twoanov1.get_P_B(1), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//B type II

			xOffset = 290;
			sTemp = format(twoanov1.getSSB(2),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 335;
			sTemp = format(twoanov1.getMSB(2), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 377;
			sTemp = format(twoanov1.get_F_B(2), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 415;
			sTemp = format(twoanov1.get_P_B(2), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//B type III

			xOffset = 470;
			sTemp = format(twoanov1.getSSB(3),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 516;
			sTemp = format(twoanov1.getMSB(3), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 557;
			sTemp = format(twoanov1.get_F_B(3), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 595;
			sTemp = format(twoanov1.get_P_B(3), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);


			//AB type I
			offscreenG.setColor(Color.black);
			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = twoanov1.getSourceA()+twoanov1.getSourceB();
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdAB());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			if (fade == true) offscreenG.setColor(Color.lightGray);

			xOffset = 105;
			sTemp = format(twoanov1.getSSAB(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 153;
			sTemp = format(twoanov1.getMSAB(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 195;
			sTemp = format(twoanov1.get_F_AB(), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 235;
			sTemp = format(twoanov1.get_P_AB(), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//AB type II

			xOffset = 290;
			sTemp = format(twoanov1.getSSAB(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 335;
			sTemp = format(twoanov1.getMSAB(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 377;
			sTemp = format(twoanov1.get_F_AB(), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 415;
			sTemp = format(twoanov1.get_P_AB(), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//AB type III

			xOffset = 470;
			sTemp = format(twoanov1.getSSAB(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 516;
			sTemp = format(twoanov1.getMSAB(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 557;
			sTemp = format(twoanov1.get_F_AB(), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 595;
			sTemp = format(twoanov1.get_P_AB(), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);


			/*//Model Type I
			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = "Model";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdG());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 105;
			sTemp = format(twoanov1.getSSG(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 153;
			sTemp = format(twoanov1.getMSG(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 195;
			sTemp = format(twoanov1.get_F_G(), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 235;
			sTemp = format(twoanov1.get_P_G(), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//Model type II

			xOffset = 290;
			sTemp = format(twoanov1.getSSG(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 335;
			sTemp = format(twoanov1.getMSG(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 377;
			sTemp = format(twoanov1.get_F_G(), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 415;
			sTemp = format(twoanov1.get_P_G(), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//Model type III

			xOffset = 470;
			sTemp = format(twoanov1.getSSG(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 516;
			sTemp = format(twoanov1.getMSG(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 557;
			sTemp = format(twoanov1.get_F_G(), 2);
			if (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 595;
			sTemp = format(twoanov1.get_P_G(), 2);
			if  (twoanov1.getdE()==0 ) sTemp="N/A ";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);*/

			//Error Type 1
			offscreenG.setColor(Color.black);
			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = "Error";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			if (fade==true) offscreenG.setColor(Color.lightGray);

			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdE());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 105;
			sTemp = format(twoanov1.getSSE(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 153;
			sTemp = format(twoanov1.getMSE(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//Error type II

			xOffset = 290;
			sTemp = format(twoanov1.getSSE(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 335;
			sTemp = format(twoanov1.getMSE(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//Erroe type III

			xOffset = 470;
			sTemp = format(twoanov1.getSSE(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 516;
			sTemp = format(twoanov1.getMSE(), 2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			//Total Type 1
			offscreenG.setColor(Color.black);
			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = "Total";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);


			if (fade==true) offscreenG.setColor(Color.lightGray);
			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdTOT());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);

			xOffset = 105;
			sTemp = format(twoanov1.getSSTOT(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);


			//Total type II

			xOffset = 290;
			sTemp = format(twoanov1.getSSTOT(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);


			//Total type III

			xOffset = 470;
			sTemp = format(twoanov1.getSSTOT(),2);
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2, yOffset);


			g.drawImage(offscreenImg,0,0,this);
			offscreenG.dispose();
		}
		else if (drawFigure==false)
		{
			xOffset = 20;
			sTemp = twoanov1.getSourceA();
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdA());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);


			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = twoanov1.getSourceB();
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdB());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);


			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = twoanov1.getSourceA()+twoanov1.getSourceB();
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			xOffset = 65;
			sTemp = Integer.toString(twoanov1.getdAB());
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp), yOffset);


			/*yOffset=yOffset+18;
			xOffset = 20;
			sTemp = "Model";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);*/

			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = "Errors";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);


			yOffset=yOffset+18;
			xOffset = 20;
			sTemp = "Total";
			offscreenG.drawString(sTemp, xOffset-fm.stringWidth(sTemp)/2,yOffset);

			g.drawImage(offscreenImg,0,0,this);
			offscreenG.dispose();
		}

	}//end of paint()



	public String format(double d, int i) //i: # of decimal digits
	{
		String s;
		int n = (int)Math.pow(10,i);
		d = (double)(Math.round(d*n))/n;		//d is rounded

		s = Double.toString(d);                //s is either 1.2 or 1.23
		for(n=s.length()-s.indexOf('.'); n<i+1; n++)
			s = s+"0";

		return(s);
	}

}//end of public class result