package districompare;
import java.awt.*;
import java.awt.Component;
import java.text.*;
import RVLS.*;
public class chisquareAdjust extends chisquare
{
	protected double mean=df, sd=Math.sqrt(2*df);
	protected double k=1.0, u=0.0;

	public chisquareAdjust()
	{
		super();
		setTitle("Chi-square adjusted, df="+df+", mean="+mean+", sd="+sd);
	}

	public void setSkewDegree(int degree) {
		if (degree==1) setDf(4);
		else if (degree==2) setDf(6);
		else if (degree==3) setDf(10);
		else
		{
			message m = new message("\r\r\rSkew degree=1: very skew;\rSkew degree=1: moderate skew;Skew degree=3: slight skew.");
			m.show();
		}

	}

	public void setMeanSd(double mean, double sd)
	{
		if (Math.abs(sd-0) < 0.001)
		{
			message m = new message("\r\r\rStandard Error should not be 0");
			m.show();
			return;
		}
		else
		{
			k = sd/(Math.sqrt(2.0*(double)df));
			u = mean - sd * Math.sqrt((double)df/2.0);
			//System.out.println("k="+k+", u="+u);
			paramChange();
		}
	}

	public  void paramChange() {
			if (autoSetLimits) {
				lowLimit= u;
				firstTick=lowLimit;

				upLimit=df+4*Math.sqrt((double)2*df);
				upLimit=k*upLimit+u;

				range = upLimit-lowLimit;
			}
			if (autoRepaint) repaint();
		}

	public double getDensity(double x) {
			int vv=1, v=1;
			double y;

			x = (x-u)/k;
			for (int i=1; i<(df/2)-1; i++  ){vv=vv*(v+1); v++;}

			if ( x > 0.0) y=(Math.pow(x,(double)((df/2)-1))*Math.exp(-x/2.0))/((double)(Math.pow(2,df/2)*vv)*k);
			else  y=0.0;

			 return y;
		}

		public  double getYmax() {
			int vv=1, v=1;
			double y, ymax=0;

			for (int i=1; i<(df/2)-1; i++  ){vv=vv*(v+1); v++;}
			for (double x=(lowLimit-u)/k; x<(upLimit-u)/k; x++)
			{
				//double xx = (x-u)/k;
				if (x > 0.0)
				{
				    y=(Math.pow(x,(double)((df/2)-1))*Math.exp(-x/2.0))/((double)(Math.pow(2,df/2)*vv)*k);
			 	 	ymax = Math.max(ymax, y);
			 	}
			 }
			 //System.out.println("ymax="+ymax);
			 return ymax;
		}


	}