package analysis;

import java.awt.*;
import java.awt.event.*;
import RVLS.*;
import VisualNumerics.math.Statistics;

public class ChisquareTest extends closeableFrame {
  private CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  private Checkbox checkbox1 = new Checkbox();
  private Checkbox checkbox2 = new Checkbox();
  private Label label1 = new Label();
  private TextField textField1 = new TextField();
  private Label label2 = new Label();
  private TextField textField2 = new TextField();
  private Button button1 = new Button();
  private Button button2 = new Button();
  private Label[] labelTRow = new Label[8];
  private Label[] labelTColumn = new Label[6];
  private Label[][] result = new Label[3][2];
  private TextField[][] textFieldT = new TextField[6][8];
  private boolean ind=true;
  int column, row, df;
  double chi, p;

  public ChisquareTest() {
    setTitle("Chi-square Test");
    setLayout(null);
    setVisible(false);
    setSize(410,400);
    setFont(new Font("SansSerif", Font.PLAIN, 12));
    checkbox1.setCheckboxGroup(checkboxGroup1);
    checkbox1.setLabel("Test of independence (Contingency Table)");
    checkbox1.setBounds(new Rectangle(35, 30, 330, 20));
    checkbox1.setState(true);
    checkbox1.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        checkbox1_itemStateChanged(e);
      }
    });
    this.setBackground(Color.white);
    this.setLayout(null);
    checkbox2.setCheckboxGroup(checkboxGroup1);
    checkbox2.setLabel("Test of deviation from theoretical frequency");
    checkbox2.setBounds(new Rectangle(35, 50, 330, 20));
    checkbox2.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        checkbox2_itemStateChanged(e);
      }
    });
    label1.setText("Number of column:");
    label1.setBounds(new Rectangle(15, 75, 120, 20));
    textField1.setText(" ");
    textField1.setBounds(new Rectangle(135, 75, 50, 20));
    label2.setText("Number of rows:");
    label2.setBounds(new Rectangle(15, 95, 120, 20));
    textField2.setText(" ");
    textField2.setBounds(new Rectangle(135, 95, 50, 20));
    button1.setLabel("Creat Table");
    button1.setBounds(new Rectangle(225, 85, 150, 25));
    button1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        button1_actionPerformed(e);
      }
    });
    for (int i=0; i<6; i++)
    {
      labelTColumn[i] = new Label(""+(i+1));
      labelTColumn[i].setBounds(40+60*i,130, 60, 20);
      labelTColumn[i].setAlignment(Label.CENTER);
      labelTColumn[i].setVisible(false);
      this.add(labelTColumn[i]);
    }
    for (int i=0; i<8; i++)
    {
      labelTRow[i] = new Label(""+(i+1));
      labelTRow[i].setBounds(0,150+20*i, 40, 20);
      labelTRow[i].setAlignment(Label.CENTER);
      labelTRow[i].setVisible(false);
      this.add(labelTRow[i]);
    }

    for (int i=0; i<6; i++)
      for (int j=0; j<8; j++)
      {
        textFieldT[i][j] = new TextField();
        textFieldT[i][j].setBounds(40+60*i,150+20*j, 60, 20);
        textFieldT[i][j].setVisible(false);
        this.add(textFieldT[i][j]);
      }

      button2.setLabel("Compute");
      button2.setBounds(new Rectangle(25, 330, 150, 25));
      button2.setVisible(false);
      button2.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          button2_actionPerformed(e);
        }
      });

    for (int i=0; i<3; i++)
      for (int j=0; j<2; j++)
      {
        if ((j==0) && (i==0)) result[i][j] = new Label("Chi Square");
        else if ((j==0) && (i==1)) result[i][j] = new Label("df");
        else if ((j==0) && (i==2)) result[i][j] = new Label("p");
        else result[i][j] = new Label("");
        if (i==0) result[i][j].setBounds(210, 320+20*j, 75, 20);
        else result[i][j].setBounds(285+60*(i-1), 320+20*j, 60, 20);
        result[i][j].setVisible(false);
        result[i][j].setAlignment(Label.CENTER);
        this.add(result[i][j]);
      }

    this.add(checkbox1, null);
    this.add(checkbox2, null);
    this.add(label1, null);
    this.add(textField1, null);
    this.add(label2, null);
    this.add(textField2, null);
    this.add(button1, null);
    this.add(button2, null);
  }

  void button1_actionPerformed(ActionEvent e)
  {
    try {
      column = Integer.valueOf(textField1.getText().trim()).intValue();
      row = Integer.valueOf(textField2.getText().trim()).intValue();

      if ((column>6) || (row>8))
      {
        message m = new message("The maximum column is 6 and maximum row is 8.");
        m.show();
        return;
      }

      for (int i=0; i<column; i++)
      {
        if (ind==true)
         labelTColumn[i].setText(""+(i+1));
        else
        {
          if (i==0)
            labelTColumn[i].setText("Exp");
          else
            labelTColumn[i].setText("Obs");
        }

        labelTColumn[i].setVisible(true);
      }

      for (int i=0; i<row; i++)
        labelTRow[i].setVisible(true);

      for (int i=0; i<column; i++)
        for (int j=0; j<row; j++)
        {
          textFieldT[i][j].setVisible(true);
          textFieldT[i][j].setBackground(Color.white);
        }

      button2.setVisible(true);
    }
    catch(Exception ee)
    {
      message m = new message("Please enter integer values for column and row in your Chi-square table.");
      m.show();
    }

  }
  void checkbox1_itemStateChanged(ItemEvent e) {
    if (checkbox1.getState()==true)
    {
          textField1.setEnabled(true);
          for (int i=0; i<column; i++)
          {
             labelTColumn[i].setText(""+(i+1));
          }
          ind=true;

          for (int i=0; i<3; i++)
          for (int j=0; j<2; j++)
          {
              result[i][j].setVisible(false);
         }

         for (int i=0; i<column; i++)
          for (int j=0; j<row; j++)
          {
              textFieldT[i][j].setBackground(Color.white);
         }
    }
  }

  void checkbox2_itemStateChanged(ItemEvent e) {
    if (checkbox2.getState()==true)
    {
      textField1.setText("2");
      textField1.setEnabled(false);
      labelTColumn[0].setText("Exp");
      labelTColumn[1].setText("Obs");
      for (int i=2; i<6; i++)
        labelTColumn[i].setVisible(false);

      ind=false;
      for (int i=0; i<3; i++)
      for (int j=0; j<2; j++)
      {
           result[i][j].setVisible(false);
      }
      for (int i=0; i<column; i++)
          for (int j=0; j<row; j++)
          {
              textFieldT[i][j].setBackground(Color.white);
         }
    }
  }

  void button2_actionPerformed(ActionEvent e) //compute
  {
    if (ind==true)
    {
        int validRow=0, validColumn=0;
        for (int i=0; i<column; i++)
        {
          if (textFieldT[i][0].getText().trim().equals("")==false)//the first row
            validColumn++;
           else
             break;
        }

        for (int j=0; j<row; j++)
        {
          if (textFieldT[0][j].getText().trim().equals("")==false) //the first column
            validRow++;
           else
             break;
        }
        System.out.println("validColumn="+validColumn+", validRow="+validRow);
        double[][] obs = new double[validColumn][validRow];
        int rowInd=0, columnInd=0;
        for (int i=0; i<validColumn; i++)
        {
          for (int j=0; j<validRow; j++)
          {
             if (textFieldT[i][j].getText().trim().equals("")==false)
             {
              textFieldT[i][j].setBackground(Color.lightGray);
               try {
               obs[columnInd][rowInd] = Double.valueOf(textFieldT[i][j].getText().trim()).doubleValue();
               rowInd++;
              }
               catch(Exception ee)
               {
                 textFieldT[i][j].requestFocus();
                 message m = new message("Please enter numeric values for the observations in the table.");
                 m.show();
                 return;
               }
             }
             else
             {
              textFieldT[i][j].requestFocus();
               message m = new message("Please enter numeric values for the missing observations in the table.");
                 m.show();
                 return;
             }
          }
          rowInd=0;
          columnInd++;
        }

        double[] colTotal=new double[validColumn];
        double[] rowTotal=new double[validRow];
        double total=0;

        for (int i=0; i<validColumn; i++)
        {
           colTotal[i] = 0;
           for (int j=0; j<validRow; j++)
           colTotal[i] = colTotal[i] + obs[i][j];

           total = total + colTotal[i];
        }

        for (int j=0; j<validRow; j++)
        {
           rowTotal[j] = 0;
           for (int i=0; i<validColumn; i++)
           rowTotal[j] = rowTotal[j] + obs[i][j];
        }

        double[][] exp = new double[validColumn][validRow];
        chi=0.0;
        for (int i=0; i<validColumn; i++)
          for (int j=0; j<validRow; j++)
          {
            exp[i][j] = (colTotal[i]*rowTotal[j])/total;
            chi = chi + (obs[i][j]-exp[i][j])*(obs[i][j]-exp[i][j])/exp[i][j];
          }

          df = (validColumn-1)*(validRow-1);
          p = probChi(chi, df);
    }
    else
    {
        int validRow=0;
        for (int j=0; j<row; j++)
        {
          if ( (textFieldT[0][j].getText().trim().equals("")==false) && (textFieldT[1][j].getText().trim().equals("")==false))
           validRow++;
        }

        double[] exp = new double[validRow];
        double[] obs = new double[validRow];
        int k=0;
        for (int j=0; j<row; j++)
        {
          if ( (textFieldT[0][j].getText().trim().equals("")==false) && (textFieldT[1][j].getText().trim().equals("")==false))
          {
           textFieldT[0][j].setBackground(Color.lightGray);
           textFieldT[1][j].setBackground(Color.lightGray);
           try {
             exp[k] = Double.valueOf(textFieldT[0][j].getText().trim()).doubleValue();
            }
           catch(Exception ee)
            {
             textFieldT[0][j].requestFocus();
             message m = new message("Please enter numeric values for the expected and observed values in the table.");
             m.show();
             return;
            }

            try
            {
              obs[k] = Double.valueOf(textFieldT[1][j].getText().trim()).doubleValue();
              k++;
            }
            catch(Exception ee)
            {
             textFieldT[1][j].requestFocus();
              message m = new message("Please enter numeric values for the expected and observed values in the table.");
             m.show();
             return;
            }
          }//end if
        }//end for
        df=validRow-1;
        chi=0;

        for (int i=0; i<validRow; i++)
        {
          chi = chi+(obs[i]-exp[i])*(obs[i]-exp[i])/exp[i];
        }

        p = probChi(chi, df);

    }
       result[0][1].setText(Utility.format(chi,4));
       result[1][1].setText(""+df);
       result[2][1].setText(Utility.format(p,4));
       if (p<=0.05)
         result[2][1].setForeground(Color.red);
       else
         result[2][1].setForeground(Color.black);
       for (int i=0; i<3; i++)
       for (int j=0; j<2; j++)
       {
          result[i][j].setVisible(true);
        }

    }
    public double probChi(double Chisqnorm, int N1) {

                double p = 0;
                double AM = 1.7E-38;
                double WU2P = 2.5066282746310005;
                double pr,z,SU;
                int J;
                 if (Chisqnorm==0)
                         return 1;

                double EC = Math.exp(-Chisqnorm/2);
                // IF ED<AM GOTO 1200
                switch(N1) {
                        case 1:
                         z = Math.sqrt(Chisqnorm);
                                pr = 1 - zdist.zprob(z);
                                p = 2*pr;
                                return p;
                        case 2:
                                p = EC;
                        return p;
                }


                double CX = Math.sqrt(Chisqnorm);
                double ZC = 1.0/WU2P*EC;

                int IE,I1;
                double RD;
                if (N1%2 == 0) {
                        IE = 1;
                        SU = ZC;
                        I1 = (N1-2)/2;
                        RD =ZC;
                }
                else {
                        IE = 0;
                        SU = 0;
                        I1 = (N1-1)/2;
                        RD = ZC/CX;
                }
                if (RD>=AM && N1<=500) {
                //if ( N1<=500) {
                                z = CX;
                            pr = 1 - zdist.zprob(z);

                            if (IE==1)
                                     J = 2;
                            else
                                    J = 1;

                            for (int i=1;i<=I1;i++) {
                                    RD=RD*Chisqnorm/J;
                                    J += 2;
                                    SU += RD;
                            }

                            if (IE==1) {
                                    p = WU2P*SU;

                            }
                            else {
                                    p = 2*(pr + SU);

                            }


                        }
                        else {

                                double z0= Math.pow(Chisqnorm/N1,0.333333333333333333)-1.0+2.0/(9.0*N1);
                                z=z0*Math.sqrt(9.0*N1/2.0);
                                p=1-zdist.zprob(z);

                        }
                         return p;
        }
}