package analysis;

//import java.awt.Canvas;
//import VisualNumerics.math.DoubleMatrix;
import RVLS.message;

public class anovaResult {
double[] ssq;
double [][] dia;
int[] df;
int nc;

  public anovaResult(double[][] means, int [] nl, int[] size) {
    int rep = means.length;
    double[] mean = new double[means[0].length];

    for (int i=0; i<means.length; i++)
    {
      if (means[i].length != mean.length)
      {
        message m = new message("Your mean matrix of repeat measurements has missing data.");
        m.show();
        return;
      }
    }

    for (int j=0; j<mean.length; j++)
    {
      for (int i=0; i<rep; i++)
      {
        mean[j] = mean[j]+means[i][j];
      }
    }
    double repadj = Math.sqrt(rep);
    for (int j=0; j<mean.length; j++)
      mean[j] = mean[j]/repadj; //mean kx1

    setData(mean, nl, size);
  }

  public anovaResult(double[] mean, int [] nl, int[] size)
  {
     setData(mean, nl, size);
  }
  public anovaResult(double[] mean, int [] nl, double n)
  {
     setData(mean, nl, n);
  }
  public void setData(double[] mean, int [] nl, double nh)
  {
    nc=1;
    for (int i=0; i<nl.length; i++)
    {
      nc = nc*nl[i];
    }

    if (nc!=mean.length) //check k var
    {
      message m = new message("Your factorial levels in mean matrix does not the levels in nl matrix. Or your sample size matrix is empty.");
      m.show();
      return;
    }
    anovaIA a = new anovaIA(nl.length, nl);
    int[][] ia = a.getIA();
    double[] stand = new double[nc];

    for (int i=0; i<ia.length; i++)
    {
      for (int j=0; j<ia[i].length; j++)
      stand[i] = stand[i]+ia[i][j]*ia[i][j];
    }
    dia = new double[nc-1][nc];

    for (int i=0; i<ia.length; i++)
    {
      for (int j=0; j<ia[i].length; j++)
      dia[i][j] = (double)ia[i][j]/Math.sqrt(stand[i]);
    }

    double[] l = new double[nc-1];

    for (int i=0; i<ia.length; i++) //k-1
    {
      for (int j=0; j<ia[i].length; j++) //k
      l[i] = l[i]+dia[i][j]*mean[j];
    }

    df = a.getNF();

    int ssnum=0;

    for (int i=0; i<df.length; i++)
    {
      if (df[i]>0) ssnum++;
      else break;
    }

    ssq = new double[ssnum];
    int k=0;
    for (int i=0; i<ssnum; i++)
    {
      for (int j=0; j<df[i]; j++)
      {
        ssq[i] = ssq[i]+l[k]*l[k]*(double)nh;
        k++;
      }
    }

  }
  public void setData(double[] mean, int [] nl, int[] size)
  {
    nc=1;
    for (int i=0; i<nl.length; i++)
    {
      nc = nc*nl[i];
    }

    if ((nc!=mean.length) || (size==null)) //check k var
    {
      message m = new message("Your factorial levels in mean matrix does not the levels in nl matrix. Or your sample size matrix is empty.");
      m.show();
      return;
    }
    anovaIA a = new anovaIA(nl.length, nl);
    int[][] ia = a.getIA();
    double[] stand = new double[nc];

    for (int i=0; i<ia.length; i++)
    {
      for (int j=0; j<ia[i].length; j++)
      stand[i] = stand[i]+ia[i][j]*ia[i][j];
    }
    dia = new double[nc-1][nc];

    for (int i=0; i<ia.length; i++)
    {
      for (int j=0; j<ia[i].length; j++)
      dia[i][j] = (double)ia[i][j]/Math.sqrt(stand[i]);
    }

    double[] l = new double[nc-1];

    for (int i=0; i<ia.length; i++) //k-1
    {
      for (int j=0; j<ia[i].length; j++) //k
      l[i] = l[i]+dia[i][j]*mean[j];
    }

    df = a.getNF();

    int ssnum=0;

    for (int i=0; i<df.length; i++)
    {
      if (df[i]>0) ssnum++;
      else break;
    }
    double nh=0;
    for (int i=0; i<size.length; i++)
      nh = nh+1.0/((double)size[i]);

    nh = ((double)size.length)/nh;

    ssq = new double[ssnum];
    int k=0;
    for (int i=0; i<ssnum; i++)
    {
      for (int j=0; j<df[i]; j++)
      {
        ssq[i] = ssq[i]+nh*l[k]*l[k];
        k++;
      }
    }
  }

  public double[] getSSq()
  {
    return(ssq);
  }

  public double [][] getNIA()
  {
    return(dia);
  }
  public int[] getDf()
  {
   return(df);
  }
  public int getNC()
  {
   return(nc);
  }

}