package analysis;

import java.awt.*;
import RVLS.*;
/**
 * This boxPlots will displays several boxplots in a raw.
 */
public class boxPlots extends Panel {
	int h,w;
	Font font;
	private axisCanvas axisCanvas1;
	final int TOPMARGIN=20;
	final int BOTTOMMARGIN=20;
	boolean created = false;
	int maxWidth=70;
	String yAxisLabel="Y";
	public  boxPlot [] bpArray;// = new boxPlot[10];;
        //Label labels = new java.awt.Label();
        Label [] labels;// = new java.awt.Label[10];
	public boxPlots(int N){
		//bpArray = new boxPlot[1];
		setLayout(null);
		font =new Font("Serif", Font.PLAIN, 12);
		axisCanvas1 = new axisCanvas();
		add(axisCanvas1);
		axisCanvas1.setFont(font);
                bpArray = new boxPlot[N];;
                labels = new java.awt.Label[N];
                for (int i=0;i<N;i++) {
                        labels[i] = new java.awt.Label();
                        this.add(labels[i]);
                        bpArray[i] = new boxPlot();
                        add(bpArray[i]);
		}


	}
	public void setMaxWidth(int maxWidth) {
		this.maxWidth=maxWidth;
	}
	public int getMaxWidth() {
		return maxWidth;
	}

	public desc[] getDescArray() {
		desc[] d=null;
		if (bpArray!=null) {
			d = new desc[bpArray.length];
			for (int i=0;i<bpArray.length;i++) {
				d[i] = bpArray[i].getDesc();
			}
		}
		return d;
	}

	public void setYaxisLabel(String yAxisLabel) {
		this.yAxisLabel = yAxisLabel;
	}
	public String getYaxisLabel() {
		return yAxisLabel;
	}

	public void setBounds (int a, int b, int w, int h) {
		this.h=h;
		this.w=w;
		super.setBounds(a,b,w,h);
	}

	public void setDrawOut(boolean drawOut) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setDrawOut(drawOut);
		}
	}

	public void setDrawFarOut(boolean drawFarOut) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setDrawFarOut(drawFarOut);
		}
	}
	public void setDrawWhisker(boolean drawWhisker) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setDrawWhisker(drawWhisker);
		}
	}

	public void setDrawBox(boolean drawBox) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setDrawBox(drawBox);
		}
	}


	public void setDrawMedian(boolean drawMedian) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setDrawMedian(drawMedian);
		}
	}

	public void setDspSem(boolean dspSem) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setDspSem(dspSem);
		}
	}


	public void setDspSd(boolean dspSd) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setDspSd(dspSd);
		}
	}
	public void setMeanPlus(boolean meanPlus) {
		for (int i=0;i<bpArray.length;i++) {
			bpArray[i].setMeanPlus(meanPlus);
		}
	}

	public void setPlusColor(Color plusColor) {
		if (bpArray != null) {
			for (int i=0;i<bpArray.length;i++) {
				bpArray[i].setPlusColor(plusColor);
			}
		}
	}

	public void setBoxColor(Color boxColor) {
		if (bpArray != null) {
			for (int i=0;i<bpArray.length;i++) {
				bpArray[i].setBoxColor(boxColor);
			}
		}
	}

	public void setMeanSemColor(Color meanSemColor) {
		if (bpArray != null) {
			for (int i=0;i<bpArray.length;i++) {
				bpArray[i].setMeanSemColor(meanSemColor);
			}
		}
	}
	public void setData(double [][] data, String [] names) {
		setData(data,names,font);
	}
	public void setData(double [] data1) {
		setData(data1," ");
	}
	public void setData(double [][] data) {
		String [] s = new String[data.length];
		for (int i=0;i<data.length;i++) {
			s[i]=" ";
		}
		setData(data,s);
	}



	public void setData(double [] data1, String name) {
		String [] names = new String[1];
		names[0]=name;
		double [][] data = new double[1][data1.length];
		data[0]=data1;
		setData(data,names,font);
	}
	/*
	 * This setData is able to pass a two dimension array, each one-dimension array
	 * stores a group of data to be plotted.
	 */
	public void setData(double [][] data, String [] names, Font font) {
		this.font = font;
		int N = data.length;
		double minV = data[0][0];
		double maxV = data [0][0];

		//if (!created)
		if (created) {
			for (int i=0;i<bpArray.length;i++) {
				this.remove(bpArray[i]);
			}
		}

			//bpArray = new boxPlot[N];
		for (int i=0;i<N;i++) {
			for (int j=0;j<data[i].length;j++) {
				minV = Math.min(minV,data[i][j]);
				maxV = Math.max(maxV,data[i][j]);
			}

				//bpArray[i] = new boxPlot();
		}
		created = true;


		//Font font = new Font("Serif", Font.PLAIN, 12);

		//axisCanvas1.setBounds(1,2,ac-5,h-20);

		axisCanvas1.setBounds(1,TOPMARGIN,20,h-BOTTOMMARGIN-TOPMARGIN);
		axisCanvas1.setParams(minV,maxV);
		int ac = axisCanvas1.getreqWidth() + 20;

		axisCanvas1.setBounds(1,TOPMARGIN,ac,h-BOTTOMMARGIN-TOPMARGIN);
		minV = axisCanvas1.getLowestTickValue();
		maxV = axisCanvas1.getHighestTickValue();

                int bpw = (w-ac -2)/N;
                bpw = Math.min(bpw,maxWidth);
                int x= ac + 1;
		//Label [] labels = new java.awt.Label[N];
                //message m = new message("minV="+minV+", maxV="+maxV+", x="+x+", bpw="+bpw+" h="+h+" bpArray="+bpArray+", names="+names+", N="+N);
                //m.show();
		for (int i=0;i<N;i++) {
                        //bpArray[i].setBounds(0,TOPMARGIN,100,h-BOTTOMMARGIN-TOPMARGIN);
                        bpArray[i].setBounds(x,TOPMARGIN,bpw,h-BOTTOMMARGIN-TOPMARGIN);
			bpArray[i].setData(minV,maxV,data[i]);
			bpArray[i].setName(names[i]);
                        bpArray[i].repaint();

                        labels[i].setText(names[i]);
                        labels[i].setAlignment(Label.CENTER);
                        labels[i].setBounds(x,h-15,bpw,14);
			x+=bpw;
		}

		/*int bpw = (w-ac -2)/N;
		bpw = Math.min(bpw,maxWidth);
		int x= ac + 1;
		Label [] labels = new java.awt.Label[N];
                message m = new message("before create boxplots");
                m.show();
		for (int i=0;i<N;i++) {
			bpArray[i].setBounds(x,TOPMARGIN,bpw,h-BOTTOMMARGIN-TOPMARGIN);
			this.add(bpArray[i]);
                        message  mm = new message("bpArray["+i+"] added");
                        mm.show();
			labels[i] = new java.awt.Label(names[i],Label.CENTER);
			labels[i].setBounds(x,h-15,bpw,14);
			labels[i].setFont(font);
			add(labels[i]);
			labels[i].setFont(font);
			x+=bpw;
                        bpArray[i].repaint();
		}*/ //joan 10/15/02
                /*for (int i=0;i<N;i++) {
			bpArray[i].repaint();
                }*/

	}
	public void paint(Graphics g) {
		g.drawString(yAxisLabel,0,TOPMARGIN-2);
	}
	//public axisCanvas getAxisCanvas() {
		//return axisCanvas1;
	//}
	/*
	public void setData(Canvas c) {
		c.setBounds(10,10,100,100);
		this.add(c);

	}
	*/

}
