package analysis;

import symantec.itools.awt.WrappingLabel;
import symantec.itools.awt.util.ProgressBar;
import java.awt.*;
import RVLS.*;
import VisualNumerics.math.Statistics;
public class oneSampleAv extends closeableFrame implements Runnable{
	double [] x;
	String dv;
	Thread th;
	double sigLevel = 0.05;
	boolean go=false;
		//final double [] t05={999999999,12.7062,4.3027,3.1824,2.7765,2.5706,2.4469,2.3646,2.306,2.2622,2.2281,2.201,2.1788,2.1604,2.1448,2.1315,2.1199,2.1098,2.1009,2.093,2.086,2.0796,2.0739,2.0687,2.0639,2.0595,2.0555,2.0518,2.0484,2.0452,2.0423,2.0395,2.0369,2.0345,2.0322,2.0301,2.0281,2.0262,2.0244,2.0227,2.0211,2.0195,2.0181,2.0167,2.0154,2.0141,2.0129,2.0117,2.0106,2.0096,2.0086,2.0076,2.0066,2.0057,2.0049,2.004,2.0032,2.0025,2.0017,2.001,2.0003,1.9996,1.999,1.9983,1.9977,1.9971,1.9966,1.996,1.9955,1.9949,1.9944,1.9939,1.9935,1.993,1.9925,1.9921,1.9917,1.9913,1.9908,1.9905,1.9901,1.9897,1.9893,1.989,1.9886,1.9883,1.9879,1.9876,1.9873,1.987,1.9867,1.9864,1.9861,1.9858,1.9855,1.9852,1.985,1.9847,1.9845,1.984};
	public oneSampleAv() {
		setTitle("Assumption Violation Simulation");
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(387,239);
		label2 = new java.awt.Label("Simulation Results");
		label2.setBounds(232,45,113,21);
		label2.setFont(new Font("Serif", Font.PLAIN, 12));
		add(label2);
		textArea1 = new java.awt.TextArea("",0,0,TextArea.SCROLLBARS_NONE);
		textArea1.setBounds(211,68,159,70);
		textArea1.setFont(new Font("Serif", Font.PLAIN, 12));
		add(textArea1);
		button1 = new java.awt.Button();
		button1.setLabel("OK");
		button1.setBounds(153,176,40,25);
		add(button1);
		progressBar1 = new symantec.itools.awt.util.ProgressBar();
		progressBar1.setVisible(false);
		progressBar1.setBounds(87,139,194,33);
		add(progressBar1);
		label1 = new java.awt.Label("Number of simulations");
		label1.setBounds(13,45,113,21);
		label1.setFont(new Font("Serif", Font.PLAIN, 12));
		add(label1);
		textField1 = new java.awt.TextField();
		textField1.setText("1000");
		textField1.setBounds(9,68,125,30);
		textField1.setFont(new Font("SansSerif", Font.PLAIN, 12));
		add(textField1);
		Group1 = new CheckboxGroup();
		radioButton2 = new java.awt.Checkbox("0.01", Group1, false);
		radioButton2.setBounds(13,128,69,25);
		add(radioButton2);
		radioButton1 = new java.awt.Checkbox("0.05", Group1, true);
		radioButton1.setBounds(14,105,69,25);
		add(radioButton1);
		//}}
		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		radioButton1.addItemListener(lSymItem);
		radioButton2.addItemListener(lSymItem);
		//}}
	}
	//{{DECLARE_CONTROLS
	java.awt.Label label2;
	java.awt.TextArea textArea1;
	java.awt.Button button1;
	symantec.itools.awt.util.ProgressBar progressBar1;
	java.awt.Label label1;
	java.awt.TextField textField1;
	java.awt.Checkbox radioButton2;
	CheckboxGroup Group1;
	java.awt.Checkbox radioButton1;
	//}}
	//{{DECLARE_MENUS
	//}}

	public void setData (double [] x, String dv) {

		this.x=x;
		this.dv=dv;
	}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
		}
	}
	public void run () {
		try {
			int n = Integer.valueOf(textField1.getText()).intValue();
			//try {Thread.sleep(8);} catch (Exception e){}

			progressBar1.setValue(0);
			progressBar1.setVisible(true);
			try {Thread.sleep(8);} catch (Exception e){}
			double p = simulate(n);
			progressBar1.setVisible(false);

			//labelp.setText(graphUtilities.format(p,3) + "");
			double se = Math.sqrt(p*(1-p)/(double) n);
			double LL = p-1.96*se;
			double UL = p+1.96*se;
			//labelci.setText("From: " + graphUtilities.format(LL,3) + "      To: " + graphUtilities.format(UL,3));
			textArea1.setText("Empirical p value = " + graphUtilities.format(p,3) +
			"\n95% Confidence interval:\nFrom: " + graphUtilities.format(LL,3) + "      To: " + graphUtilities.format(UL,3));
		}
		catch (Exception e) {
			System.out.println("exception");
		}
	}
	public void stop () {
	}


	public void start() {
		if(go) {
			th = new Thread(this);
			th.start();
		}
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{



		//{{CONNECTION
		// Set the progress bar value
		{
			try {
				progressBar1.setValue(0);
				//progressBar1.setVisible(true);
			}
			catch(Exception e) { }
		}
		//}}
		go=true;
		start();


		//{{CONNECTION
		// Show the ProgressBar
		{
			progressBar1.setVisible(true);
		}
		//}}
	}
	public double simulate(int iter) {
		int N = x.length;
		double mean = 0;
		//double tcrit = Math.sqrt(probFandT.Finv(sigLevel,1,N-1));
                double tcrit = Statistics.inverseTCdf(1.0-0.5*sigLevel,(double)(N-1));
		int nd;

		//System.out.println("df= " + (N-1) + " tcrit= " + tcrit);
		for (int i=0;i<N;i++) {
			mean+=x[i];
		}
		int N1=N-1;
		mean/=N;

		double M,ssq;
		int sig=0;
		for (int i=0;i<iter;i++) {
			M=0;
			ssq=0;
			for (int j=0;j<N;j++) {
				int k = (int) Math.floor(Math.random()*N);
				double d = x[k];
				M+=d;
				ssq+=d*d;
			}
			double sem = Math.sqrt(((ssq-M*M/N)/N1)/N);
			if(sem == 0) {
				sig++;
			}
			else {
				M/=N;
				double t = (M-mean)/sem;
				if (Math.abs(t) >=tcrit	) sig++;
			}
			if (i%100 == 0) {
				double pr = ((double) i)/((double) iter);
				int pr0 = (int) Math.rint(100*pr);
				try {
					progressBar1.setValue(pr0);
				}
				catch(Exception e) { }

		}
		}

		double p = ((double) sig)/ ((double) iter);
		return p;
	}


	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == radioButton1)
				radioButton1_ItemStateChanged(event);
			else if (object == radioButton2)
				radioButton2_ItemStateChanged(event);
		}
	}

	void radioButton1_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		sigLevel=0.05;
	}

	void radioButton2_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		sigLevel=0.01;
	}
}