package analysis;

import VisualNumerics.math.Statistics;
//import VisualNumerics.math.DoubleMatrix;

public class twoWayEquANOVA {
	public int df1,df2, df12, dfe,dft, n1, n2, n; //k trials, n subjects
	double [] mean1, mean2, mean12;

	public double sst,ss1,ss2,ss12,sse, ms1, ms2, ms12, mse, F1,F2,F12, p1, p2, p12, grandmean;

	public twoWayEquANOVA() {
	}

	public void setData(double [][][] X) {
		sst=0;
		ss1=0;
		ss2=0;
		ss12=0;
		sse=0;
		grandmean=0;

		n1 = X.length;
		n2 = X[0].length;
		n = X[0][0].length;

		df1 = n1-1;
		df2 = n2-1;
		df12 = df1*df2;
		dft = n1*n2*n -1;
		dfe = dft - df1- df2 - df12;

        mean1 = new double[n1];
        mean2 = new double[n2];
        mean12 = new double[n1*n2];
        //System.out.println("mean1.length="+mean1.length+", mean2.length="+mean2.length+", mean12.length="+mean12.length);
        for (int i=0; i<n1; i++)
        for (int j=0; j<n2; j++)
        {
        	for (int k=0; k<n; k++)
        	{
        		mean1[i] = mean1[i] + X[i][j][k];
        		mean2[j] = mean2[j] + X[i][j][k];
        		mean12[i*n2+j]= mean12[i*n2+j] + X[i][j][k];
        		//System.out.println("mean12["+(i*n2+j)+"]="+mean12[i*n2+j]);
        		grandmean = grandmean+X[i][j][k];
        	}
        }

       for (int i=0; i<n1; i++) mean1[i] = mean1[i]/(double)(n2*n);
       for (int j=0; j<n2; j++) mean2[j] = mean2[j]/(double)(n1*n);
       for (int k=0; k<(n1*n2); k++)  mean12[k] = mean12[k]/(double)(n);

       grandmean = grandmean/(double)(n1*n2*n);

       //System.out.println("grandmean="+grandmean);

       for (int i=0; i<n1; i++)
       for (int j=0; j<n2; j++)
       {
        	for (int k=0; k<n; k++)
        	{
        		 sst = sst + Math.pow(X[i][j][k]-grandmean, 2.0);
        	}
       }

	   for	(int i=0; i<n1; i++)
	   {
	   	ss1 = ss1 + (double)(n*n2)*Math.pow(mean1[i]-grandmean, 2.0);
	   }

	   for	(int j=0; j<n2; j++)
	   {
	   	ss2 = ss2 + (double)(n*n1)*Math.pow(mean2[j]-grandmean, 2.0);
	   }

	   for (int k=0; k<(n1*n2); k++)
	   {
	   	ss12= ss12+(double)n*Math.pow(mean12[k]-grandmean,2);
	   }
	   sse = sst - ss12;

	   ss12 = ss12-ss1-ss2;

	   ms1 = ss1/df1;
	   ms2 = ss2/df2;
	   ms12 = ss12/df12;
	   mse = sse/dfe;
	   //System.out.println("sst="+sst+", ss1="+ss1+", ss2="+ss2+", sse="+sse+", df1="+df1+", df2="+df2+", df12="+df12+", dfe="+dfe);
	   if (mse>0.00001)
	   {
	   	F1 = ms1/mse;
	   	F2 = ms2/mse;
	   	F12 = ms12/mse;

	   	p1 =1.0-Statistics.FCdf(F1, df1, dfe);
	   	p2 =1.0-Statistics.FCdf(F2, df2, dfe);
	   	p12 = 1.0-Statistics.FCdf(F12, df12, dfe);
	   }
	   else
	   {
	   	 F1 = -1.0;
	   	 F2 = -1.0;
	   	 F12= -1.0;
	   	 p1 = -1.0;
	   	 p2 = -1.0;
	   	 p12 = -1.0;
	   }
	}


}