package analysis;

import RVLS.message;
import RVLS.Utility;
import VisualNumerics.math.DoubleMatrix;
public class anovaHResult {
double[] ssq;
double nh;
double[][][] H;
public int[] df;
int nc;

  public anovaHResult(double[][] means, int [] nl, int[] size) {

    for (int i=0; i<means.length; i++)
    {
      if (means[i].length != means[0].length)
      {
        message m = new message("Your mean matrix of repeat measurements has missing data.");
        m.show();
        return;
      }
    }

    nc=1;
    for (int i=0; i<nl.length; i++)
    {
      nc = nc*nl[i];
    }

    if ((nc!=means[0].length) || (size==null)) //check k var means: depxnc
    {
      message m = new message("Your factorial levels in mean matrix does not the levels in nl matrix. Or your sample size matrix is empty.");
      m.show();
      return;
    }

    anovaIA a = new anovaIA(nl.length, nl);
    int[][] ia = a.getIA();
    double[] stand = new double[nc];

    for (int i=0; i<ia.length; i++)
    {
      for (int j=0; j<ia[i].length; j++)
      stand[i] = stand[i]+ia[i][j]*ia[i][j];
    }
    double[][] dia = new double[nc-1][nc];
    for (int i=0; i<ia.length; i++)
    {
      for (int j=0; j<ia[i].length; j++)
      dia[i][j] = (double)ia[i][j]/Math.sqrt(stand[i]);
    }

    double [][][] l = new double[dia.length][][];

    for (int i=0; i<dia.length; i++)
    {
      double[] contrast = dia[i];

      double[]   lc = DoubleMatrix.multiply(means, contrast); //depxnc ncx1
      l[i] = new double[lc.length][lc.length];
      for (int j=0; j<lc.length; j++)
      {
        for (int k=0; k<lc.length; k++)
        l[i][j][k] = lc[j]*lc[k];
      }
    }

    df = a.getNF();
    int ssnum=0;
    for (int i=0; i<df.length; i++)
    {
      if (df[i]>0) ssnum++;
      else break;
    }

    nh=0.0;
    for (int i=0; i<size.length; i++)
      nh = nh+1.0/((double)size[i]);

    nh = ((double)size.length)/nh;

    H = new double[ssnum][][];
    int k=0;
    for (int i=0; i<ssnum; i++)
    {
      for (int j=0; j<df[i]; j++)
      {
        if (j==0) H[i]=l[k];
        else H[i] = DoubleMatrix.add(H[i], l[k]);
        k++;
      }
    }

    ssq = new double[ssnum];
    for (int i=0; i<ssnum; i++)
    {
      for (int j=0; j<means.length; j++)
        for (k=0; k<means.length; k++)
          ssq[i] = ssq[i]+H[i][j][k];

      ssq[i] = ssq[i]*nh/(double)means.length;
    }
  }

  public double[] getSSq()
  {
    return(ssq);
  }

  public double getnh()
  {
    return(nh);
  }

  public double[][][] getHs()
  {
    return(H);
  }
  public int getNC()
  {
    return(nc);
  }

}