package analysis;

import java.util.*;
import RVLS.message;
public class dataSet {
	public double [][] X;
	public String [] names;
	public int n,k;
	public dataSet(int n, int k,Vector vn, Vector data) {
		X = new double[n][k];
		names = new String[k];
		this.n=n;
		this.k=k;
		for (int i=0;i<n;i++) {
			X[i] = (double []) data.elementAt(i);
		}
		for (int i=0;i<k;i++) {
			names[i] = (String) vn.elementAt(i);

		}

	}
	public dataSet(String [] names, double [][] X) {
		this.names=names;
		this.X=X;
		n=X.length;
		k=X[0].length;
	}

	public boolean [] grouping() {
		boolean [] r = new boolean[k];
		double max,min;
		for (int i=0;i<k;i++) {

			r[i]=true;
			max = X[0][i];
			min = max;

			for (int j=0;j<n;j++) {
				//System.out.println("--- " + j + " " + i + " " + X[j][i]);
				max = Math.max(max,X[j][i]);
				min = Math.min(min,X[j][i]);
				if ((X[j][i] <0) || (X[j][i] > 15) || (Math.rint(X[j][i]) != X[j][i])) {
					r[i] = false;
					break;
				}
			}
			if (r[i]) {
				if((min != 1.0) || (min==max)) {
					r[i]=false;
				}
			}
			if (r[i]) {
				int ncat = (int) max;
				int [] check = new int[ncat];
				for (int j=0;j<ncat;j++) {
					check[j]=1;
				}
				int sum = 0;
				for (int j=0;j<n;j++) {

					int v = (int) X[j][i];
				//System.out.println("v= " + v);
					sum+= check[v-1];
					check[v-1]=0;

				}

				if(sum != (int)Math.rint(max)) r[i] = false;
			}
			/*
			if (r[i]) {
				System.out.println("passed test");
			}
			else {
				System.out.println("sum not equal to max");
			}
			*/

		}
		return r;
	}


	int getIndexFromName(String vname) {
		int L=-1;
		for (int i=0;i<k;i++) {
			if (names[i].equals(vname)) {
					L=i;
					break;
			}
		}
		return L;
	}
	public double [] getVar(int L) {
		double [] Z = new double[n];
		for (int i=0;i<n;i++) {
			Z[i] = X[i][L];
		}
		return Z;
	}

	public double [] getVar(String s) {
		int L =	getIndexFromName(s);
		return getVar(L);
	}

	public double [][] getVars(String [] s) {
		int L = s.length;
		int v[] = new int[L];
		for (int i=0;i<L;i++) {
			v[i] = getIndexFromName(s[i]);
		}
		return getVars(v);
	}
	public double[][] getVars(int [] v) {
		int nv = v.length;
		double [][] Z = new double [nv][n];
		for (int i=0;i<n;i++) {
			for (int j=0;j<nv;j++) {
				int L=v[j];
				Z[j][i]= X[i][L];
			}
		}
		return Z;
	}
	public int getMaxLevel(String vname) {
		int L = getIndexFromName(vname);
		int m = getMaxLevel(L);
		return m;
	}
	public int getMaxLevel(int L) {
		if (L==-1) return 0;
		double m = X[0][L];
		for (int i=1;i<n;i++) {
			m = Math.max(m,X[i][L]);
		}
		return (int) Math.rint(m);
	}

	int [] nPerCell(int LL) {
		int ncell=getMaxLevel(LL);

		int[] nn = new int[ncell];


		for (int i=0;i<n;i++){
			int index = (int) X[i][LL]-1;
			nn[index]++;

		}
		return nn;
	}

	public double [][] getGroups(String g, String x) {
		int LL=getIndexFromName(g);
		int v=getIndexFromName(x);
		return getGroups(LL,v);
	}

        public double [][][] getGroups(String Y, String g1, String g2) {
                int LL=getIndexFromName(Y);
                int v1=getIndexFromName(g1);
                int v2=getIndexFromName(g2);
                return getGroups(LL,v1, v2);
	}

        public double []getMeans(String Y, String[] g) {
                int LL=getIndexFromName(Y);
                int[] v=new int[g.length];
                for (int i=0; i<g.length; i++)
                v[i] = getIndexFromName(g[i]);
                return getMeans(LL,v);
	}

        public double [][] getMultiGrps(String Y, String[] g) {
                int LL=getIndexFromName(Y);
                int[] v=new int[g.length];
                for (int i=0; i<g.length; i++)
                v[i] = getIndexFromName(g[i]);
                return getMultiGrps(LL,v);
	}

        public int []getSizes(String Y, String[] g) {
                int LL=getIndexFromName(Y);
                int[] v=new int[g.length];
                for (int i=0; i<g.length; i++)
                v[i] = getIndexFromName(g[i]);
                return getSizes(LL,v);
	}

	public double [][] getGroups(int  LL, int v) {
		int [] nn = nPerCell(LL);
		int k = nn.length;
		int [] count = new int[k];
		double [][] G = new double[k][];
		for (int i=0;i<k;i++) {
			 G[i] = new double[nn[i]];
		}
		for (int i=0;i<n;i++) {
			int index = (int) X[i][LL]-1;
			G[index][count[index]]=X[i][v];
			count[index]++;
		}
		return G;
	}

        public double [][][] getGroups(int  LL, int v1, int v2) {
                int [] a1 = nPerCell(v1);
                int [] a2 = nPerCell(v2);
                double [][][] G = new double[a1.length][a2.length][];
                int count[][] = new int[a1.length][a2.length];
                for (int i=0;i<n;i++) {
                        int aa1 = (int) X[i][v1]-1;
                        int aa2 = (int) X[i][v2]-1;
                        count[aa1][aa2]++;
                }

                for (int i=0; i<a1.length; i++)
                  for (int j=0; j<a2.length; j++)
                  {
                    if (count[i][j]==0)
                      return(null);

                    G[i][j]= new double[count[i][j]];
                  }

                int[][] k = new int[a1.length][a2.length];
                for (int i=0;i<n;i++) {
                        int aa1 = (int) X[i][v1]-1;
                        int aa2 = (int) X[i][v2]-1;
                        G[aa1][aa2][k[aa1][aa2]]= X[i][LL];
                        k[aa1][aa2]++;
                }

                return G;
	}

        public double [] getMeans(int  LL, int[] v) {
          int nc = 1;
          int[] maxLevel = new int[v.length];
          for (int i=0; i<v.length; i++)
          {
            maxLevel[i] = getMaxLevel(v[i]);
            nc = nc * maxLevel[i];
          }
          double[] means = new double[nc];
          int[] size = new int[nc];
          int current, column;
          for (int i=0;i<n;i++)
          {
            current=0;
            for (int j=0; j<v.length; j++)
            {
              column = (int) X[i][v[j]]-1;

              for (int k=j+1; k<v.length; k++)
              column=column*maxLevel[k];

              current = current+column;
            }

            means[current]= means[current] + X[i][LL];
            size[current]++;
          }

          for (int i=0; i<nc; i++)
          {
            if (size[i]==0) return(null);
            else means[i] = means[i]/(double)size[i];
          }

          return(means);
        }

        public double[][] getMultiGrps(int  LL, int[] v) {
          int nc = 1;
          int[] maxLevel = new int[v.length];
          int[] sizes = getSizes(LL, v);
          for (int i=0; i<v.length; i++)
          {
            maxLevel[i] = getMaxLevel(v[i]);
            nc = nc * maxLevel[i];
          }
          double[][] ind = new double[nc][];
          for (int i=0; i<nc; i++)
            ind[i] = new double[sizes[i]];

          int[] keeptrack = new int[nc];
          int current, column;
          for (int i=0;i<n;i++)
          {
            current=0;
            for (int j=0; j<v.length; j++)
            {
              column = (int) X[i][v[j]]-1;

              for (int k=j+1; k<v.length; k++)
              column=column*maxLevel[k];

              current = current+column;
            }
            ind[current][keeptrack[current]] = X[i][LL];
            keeptrack[current]++;
          }
          return(ind);
        }

        public int [] getSizes(int  LL, int[] v) {
          int nc = 1;
          int[] maxLevel = new int[v.length];
          for (int i=0; i<v.length; i++)
          {
            maxLevel[i] = getMaxLevel(v[i]);
            nc = nc * maxLevel[i];
          }
          int[] size = new int[nc];
          int current, column;
          for (int i=0;i<n;i++)
          {
            current=0;
            for (int j=0; j<v.length; j++)
            {
              column = (int) X[i][v[j]]-1;

              for (int k=j+1; k<v.length; k++)
              column=column*maxLevel[k];

              current = current+column;
            }
            size[current]++;
          }

          for (int i=0; i<nc; i++)
          {
            if (size[i]==0) return(null);
          }

          return(size);
        }
	public String toString() {
		String s= "Number of obs = " + n + "\n";
		s+= "Number of var = " + k + "\n";
		s+="Variable names: ";

		for (int i=0;i<k;i++) {
			s+=names[i] + " " ;

		}
		s+="\n";

		for (int i=0;i<n;i++) {
			for(int j=0;j<k;j++) {
				s+= X[i][j] + " ";
			}
			s+="\n";
		}

		return s;
	}


}
