package analysis;

import RVLS.*;
import java.awt.*;
import java.awt.event.*;
import VisualNumerics.math.DoubleMatrix;
public class multiAnova extends closeableFrame {

  public multiAnova() {
    //{{INIT_CONTROLS
    setLayout(null);
    setVisible(false);
    setSize(400,320);
    setFont(new Font("SansSerif", Font.PLAIN, 12));
    /*wrappingLabelT = new symantec.itools.awt.WrappingLabel();
    //wrappingLabelT.setFont(new Font("SansSerif", Font.PLAIN, 10));
    wrappingLabelT.setBounds(10,30,380,70);
    try {
      wrappingLabelT.setText("If you have 0 or 1 within-subject variables, fill out the information below and click the \"Do ANOVA\" button. If you have 2 or more within-subject variables, click the \"2 or more within-subject variables\" button.");
    }
    catch(Exception e) {}
    add(wrappingLabelT);*/

    label0 = new java.awt.Label("For 0 or 1 within-subject variables,");
    label0.setBounds(10,30,380,18);
    label0.setFont(new Font("SansSerif", Font.BOLD, 12));
    add(label0);
    setTitle ("Choosing varibles for ANOVA");
  }

  public void setData(dataSet ds) {
    int i;
    this.ds =ds;

    label1 = new java.awt.Label("Select dependent variable(s):");
    label1.setBounds(10,50,200,18);
    add(label1);
    boolean[] grp = ds.grouping();
    int grpnum=0;
    for (i=0; i<grp.length; i++)
    {
      if  (grp[i]==true) grpnum++;
    }
    depchecks = new java.awt.Checkbox[ds.names.length];
    int k=0;
    for (i=0; i<ds.names.length; i++)
    {
      depchecks[k] = new java.awt.Checkbox(ds.names[i]);
      depchecks[k].setBounds(10,70+20*k, 180, 20);
      add(depchecks[k]);
      k++;
    }

    int j=0;
    if (grpnum>0)
    {
      label2 = new java.awt.Label("Select group variable(s):");
      label2.setBounds(210,50,180,18);
      add(label2);
      grpchecks = new java.awt.Checkbox[grpnum];
      for (int kk=0; kk<grp.length; kk++)
      {
        if (grp[kk]==true)
        {
        grpchecks[j] = new java.awt.Checkbox(ds.names[kk]);
        grpchecks[j].setBounds(210,70+20*j, 180, 20);
        add(grpchecks[j]);
        j++;
      }
      }
    }
    else
    {
      label1.setText("Select dependent variable(s):");
    }

    //if ((90+20*Math.max(k, j)+60)>300)
    this.setSize(400, (200+20*Math.max(k, j)+40));

    button1 = new java.awt.Button("Do Anova");
    button1.setBounds(10, 80+20*Math.max(k, j), 310, 20);
    add(button1);
    button1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        button1_actionPerformed(e);
      }
    });
    label02 = new java.awt.Label("-----------------------------------------------------------------------------------------");
    label02.setBounds(0,120+20*Math.max(k, j),400,18);
    add(label02);
    label02 = new java.awt.Label("For 2 or more within-subject variables:");
    label02.setBounds(10,150+20*Math.max(k, j),380,18);
    label02.setFont(new Font("SansSerif", Font.BOLD, 12));
    add(label02);
    button2 = new java.awt.Button("Do complex ANOVA");
    button2.setBounds(10, 180+20*Math.max(k, j), 310, 20);
    add(button2);
    button2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        button2_actionPerformed(e);
      }
    });


  }
  java.awt.Label label0;
  java.awt.Label label02;
  java.awt.Label label1;
  java.awt.Label label2;
  java.awt.Button button1;
  java.awt.Button button2;
  java.awt.Checkbox [] depchecks;
  java.awt.Checkbox [] grpchecks;
  symantec.itools.awt.WrappingLabel wrappingLabelT;

  dataSet ds=null;
  void button2_actionPerformed(ActionEvent e)
  {
    multiDependent m = new multiDependent();
    m.setData(ds);
    m.show();
  }
  void button1_actionPerformed(ActionEvent e)
  {
    int dep=0;
    for (int i=0; i<depchecks.length; i++)
    {
      if (depchecks[i].getState()==true)
      {
        if (grpchecks!=null)
        {
          for (int j=0; j<grpchecks.length; j++)
          {
            if (grpchecks[j].getState()==true)
            {
                 if (depchecks[i].getLabel().equals(grpchecks[j].getLabel()))
                 {
                    message m = new message("You have choosen duplicated group variable and dependent variable.");
                    m.show();
                    return;
                 }

            }
           }
         }
         dep++;
      }
    }

    int grp=0;
    if (grpchecks!=null)
    {
      for (int i=0; i<grpchecks.length; i++)
      {
        if (grpchecks[i].getState()==true)
          grp++;
      }
    }

    if (dep==0)
    {
      message m = new message("You must choose at least one dependent variable.");
      m.show();
    }
    if ((dep==1) && (grp==0))
    {
      message m = new message("Please select multiple dependent variables to do repeated-measures ANOVA, or at lease one group factor to do one-way or two-way ANOVA.");
      m.show();
    }
    else if  ((dep>1) && (grp==0))
    {
      double[][] x = new double[dep][];
      int k=0;
      for (int i=0; i<depchecks.length; i++)
      {
        if (depchecks[i].getState()==true)
        {
        x[k] = ds.getVar(depchecks[i].getLabel());
        k++;
      }
      }
      repeatanovaFrame raf = new repeatanovaFrame();
      raf.setData("DV","Subjects", x);
      raf.show();
    }
    else if ((dep==1) && (grp==1))
    {
      anovaFrame af = new anovaFrame();
      String gn="";
      for (int i=0; i<grpchecks.length; i++)
      {
        if (grpchecks[i].getState()==true)
        {
        gn = grpchecks[i].getLabel();
        af.setName(gn);
      }
      }

      for (int i=0; i<depchecks.length; i++)
      {
        if (depchecks[i].getState()==true)
        {
        double [][] dataY = ds.getGroups(gn,depchecks[i].getLabel());
        af.setData(dataY);
      }
      }
      af.show();
    }
    else if ((dep==1) && (grp>1))
    {
      String[] group = new String[grp];
      int k=0;
      for (int i=0; i<grpchecks.length; i++)
      {
        if (grpchecks[i].getState()==true)
        {
        group[k] = grpchecks[i].getLabel();
        k++;
      }
      }

      String[] dependent = new String[dep];
      k=0;
      for (int i=0; i<depchecks.length; i++)
      {
        if (depchecks[i].getState()==true)
        {
        dependent[k] = depchecks[i].getLabel();
        k++;
      }
      }

      String[] labelbs = new String[(int)Math.pow(2, grp)];
      k=0;
      for (int i=0; i<grp; i++)
      {
        labelbs[k] = group[i].substring(0,Math.min(2,group[i].length())); k++;
        int m =k-1;
        for (int j=0; j<m; j++)
        {
          labelbs[k] = labelbs[j]+"x"+group[i].substring(0,Math.min(2,group[i].length()));
          k++;
        }
      }
      labelbs[k] = "Error";

      double [][] means = new double[dep][];
      for (int i=0; i<dep; i++)
      {
        means[i] = ds.getMeans(dependent[i], group);
        if (means[i]==null)
        {
          message mm = new message("You have missing data in your factorial design");
          mm.show();
          return;
        }
      }

      int[] nl = new int[grp];
      for (int i=0; i<grp; i++)
        nl[i] = ds.getMaxLevel(group[i]);

      int [] sizes = ds.getSizes(dependent[0], group);

      anovaHResult aa = new anovaHResult(means, nl, sizes);
      double[] ssqbs = new double[aa.ssq.length+1]; //+1 for err
      for (int i=0; i<aa.ssq.length; i++)
        ssqbs[i] = aa.ssq[i];

      double[][][] ind = new double[dep][][];
      for (int i=0; i<dep; i++)
      {
        ind[i] = ds.getMultiGrps(dependent[i], group);
      }

      double[][] err = new double[dep][dep];
      for (int i=0; i<ind[0].length; i++) //ind[0].length=nc, for each cell
      {
        double[][] sub = new double[dep][sizes[i]];

        for (int j=0; j<dep; j++)
          for (k=0; k<sizes[i]; k++)
            sub[j][k] = ind[j][i][k];

        err = DoubleMatrix.add(err,  calsse(sub));
      }

      double sse = 0;
      for (int i=0; i<dep; i++)
        for (int j=0; j<dep; j++)
          sse = sse + err[i][j];

      sse = sse/(double)dep;
      ssqbs[ssqbs.length-1] = sse;

      int[] dfbs = new int[ssqbs.length];
      for (int i=0; i<(ssqbs.length-1); i++)
        dfbs[i] = aa.df[i];
      dfbs[dfbs.length-1] = ds.n - sizes.length;

      multianovaFrame af = new multianovaFrame();
      af.setData(ssqbs, dfbs, labelbs);
      af.show();
    }

    else //if ((dep==1) && (grp>1))
    {
      String[] group = new String[grp];
      int k=0;
      for (int i=0; i<grpchecks.length; i++)
      {
        if (grpchecks[i].getState()==true)
        {
        group[k] = grpchecks[i].getLabel();
        k++;
      }
      }

      String[] dependent = new String[dep];
      k=0;
      for (int i=0; i<depchecks.length; i++)
      {
        if (depchecks[i].getState()==true)
        {
        dependent[k] = depchecks[i].getLabel();
        k++;
      }
      }

      String[] labelbs = new String[(int)Math.pow(2, grp)];
      k=0;
      for (int i=0; i<grp; i++)
      {
        labelbs[k] = group[i].substring(0,Math.min(2,group[i].length())); k++;
        int m =k-1;
        for (int j=0; j<m; j++)
        {
          labelbs[k] = labelbs[j]+"x"+group[i].substring(0,Math.min(2,group[i].length()));
          k++;
        }
      }
      labelbs[k] = "Error";

      double [][] means = new double[dep][];
      for (int i=0; i<dep; i++)
      {
        means[i] = ds.getMeans(dependent[i], group);
        if (means[i]==null)
        {
          message mm = new message("You have missing data in your factorial design");
          mm.show();
          return;
        }
      }

      int[] nl = new int[grp];
      for (int i=0; i<grp; i++)
        nl[i] = ds.getMaxLevel(group[i]);

      int [] sizes = ds.getSizes(dependent[0], group);

      anovaHResult aa = new anovaHResult(means, nl, sizes);
      double[] ssqbs = new double[aa.ssq.length+1]; //+1 for err
      for (int i=0; i<aa.ssq.length; i++)
        ssqbs[i] = aa.ssq[i];

      double[][][] ind = new double[dep][][];
      for (int i=0; i<dep; i++)
      {
        ind[i] = ds.getMultiGrps(dependent[i], group);
      }

      double[][] err = new double[dep][dep];
      for (int i=0; i<ind[0].length; i++) //ind[0].length=nc, for each cell
      {
        double[][] sub = new double[dep][sizes[i]];

        for (int j=0; j<dep; j++)
          for (k=0; k<sizes[i]; k++)
            sub[j][k] = ind[j][i][k];

        err = DoubleMatrix.add(err,  calsse(sub));
      }

      double sse = 0;
      for (int i=0; i<dep; i++)
        for (int j=0; j<dep; j++)
          sse = sse + err[i][j];

      sse = sse/(double)dep;
      ssqbs[ssqbs.length-1] = sse;

      int[] dfbs = new int[ssqbs.length];
      for (int i=0; i<(ssqbs.length-1); i++)
        dfbs[i] = aa.df[i];
      dfbs[dfbs.length-1] = ds.n - sizes.length;


      //start within subjects
      double[] mean = new double[dep];
      String[] labelws = new String[1];//[labelbs.length+1]; //labelbs.length+1, +1 for within only
      labelws[0] = "DV";

      String[][] labelwsbs = new String[1][labelbs.length+1];
      labelwsbs[0][0] = labelws[0];

      for (int j=0; j<labelbs.length-1; j++)
        labelwsbs[0][j+1] = labelbs[j]+"x"+labelws[0];
      labelwsbs[0][labelbs.length] = "Error";

      int[] nlws = new int[1];
      nlws[0] = dep;

      for (int i=0; i<dep; i++)
        for (int j=0; j<means[i].length; j++)
          mean[i] = mean[i] + means[i][j]; //for each dep var, sum all cell's means

      for (int i=0; i<dep; i++)
        mean[i] = mean[i]/(double)means[i].length;//for each dep var, average of all cell's means

      anovaResult aws = new anovaResult(mean, nlws, (aa.getnh()*aa.getNC()));
      double[] ssqws = aws.getSSq();

      double [][] depcontrws = aws.getNIA(); //normalized within subjects factor contrast
      int[] df = aws.getDf();
      double[][][] H = aa.getHs();
      double nh = aa.getnh();
      double[][] sswsbs = new double[ssqws.length][H.length+2]; //H: H matrix for between subject, +1 for within subjects only, +1 for err; ssq is the within subjects ssq array
      int[][] dfwsbs = new int[ssqws.length][H.length+2];

      for (int i=0; i<ssqws.length; i++)
        dfwsbs[i][0] = df[i];
      for (int i=0; i<labelws.length; i++)
        for (int j=0; j<labelbs.length; j++)
          dfwsbs[i][j+1] = df[i]*dfbs[j];

      for (int i=0; i<ssqws.length; i++)
        sswsbs[i][0] = ssqws[i];

      int cr=0; //index for within subject contrast matrix rows
      for (int i=0; i<df.length; i++) //contrast matrix's total df
      {
        if (df[i]==0) break;
        else //take day , trial, dayxtrial
        {
          for (int j=0; j<df[i]; j++)
          {
            double[] c = depcontrws[cr];
            int Hi=0; //depx1
            for (Hi=0; Hi<H.length; Hi++) //Hi: 1 for a, 2 for b, 2 for ab
            {
              double[][] HH = H[Hi]; //HH is sum x sum = dep x dep
              double s = calsum(c, HH);
              sswsbs[i][Hi+1] = sswsbs[i][Hi+1] + nh*s;

            }
            sswsbs[i][Hi+1] = sswsbs[i][Hi+1]+calsum(c, err); //err term
            cr++;
          } //add up for all contrasts for one within-subjects factor
        }
      }

      multianovaFrame af = new multianovaFrame();
      af.setData(ssqbs, dfbs, labelbs, sswsbs, dfwsbs, labelwsbs);
      af.show();
    }

  }//end of button
  public double calsum(double[] d, double[][] H)
  {
    if (d.length!=H.length)
    {
      message m = new message("dHd' calculation wrong!");
      m.show();
      return(0);
    }
    double[] dh = DoubleMatrix.multiply(d, H);
    double out=0;
    for (int i=0; i<d.length; i++)
    {
      out=out+dh[i]*d[i];
    }
    return(out);
  }
  double[][] calsse(double[][] x) //x: mtrial(dep) x nsub
  {
    int mtrial = x.length;
    int nsub = x[0].length;

    double[] submean = new double[mtrial];
    for (int i=0; i<mtrial; i++)
      for (int j=0; j<nsub; j++)
        submean[i] = submean[i]+x[i][j];

    for (int i=0; i<mtrial; i++)
      for (int j=0; j<nsub; j++)
        x[i][j] = x[i][j]-submean[i]/(double)nsub;

    double[][] xt =DoubleMatrix.transpose(x); //nxm

    double [][] E = DoubleMatrix.multiply(x, xt); //mxn x nxm = mxm

    return(E);
  }
}
