package analysis;

import RVLS.*;
import java.awt.event.*;
import java.awt.*;
import VisualNumerics.math.DoubleMatrix;
public class multiDependent extends closeableFrame {

	public multiDependent() {
			//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(450,500);
		setTitle ("Choosing multiple within-subjects factor for ANOVA");
        }

        int grpnum=0, ylevel, sum; //sum is # of tot dep vars
        boolean[] grp;
        int nvws;
        java.awt.Label label0;
        java.awt.Label label1;
        java.awt.Label label2;
        java.awt.Label [] names = new java.awt.Label[5];
        java.awt.Label [] levels = new java.awt.Label[5];
        java.awt.TextField [] tnames = new java.awt.TextField[5];
        java.awt.TextField [] tlevels = new java.awt.TextField[5];
        java.awt.Checkbox [] grpchecks;
        java.awt.Button button2;
        java.awt.Button button3;
        java.awt.Choice[] choice = new java.awt.Choice[30];;
        java.awt.Label [] dnames = new java.awt.Label[30];;
        int[] level = new int[5];
        String[] name = new String[5];

        dataSet ds=null;

        public void setData(dataSet ds) {
          int i;
          this.ds =ds;

            label1 = new java.awt.Label("Specify within-subjects factors and their levels:");
            label1.setBounds(10,30,280,20);
            add(label1);
            grp = ds.grouping();
            for (i=0; i<grp.length; i++)
            {
              if  (grp[i]==true) grpnum++;
            }

            names = new java.awt.Label[ds.names.length-grpnum];
            levels = new java.awt.Label[ds.names.length-grpnum];
            tnames = new java.awt.TextField[ds.names.length-grpnum];
            tlevels = new java.awt.TextField[ds.names.length-grpnum];
            int k;
            for (k=0; k<Math.min((ds.names.length-grpnum),5); k++)
            {
                 names[k] = new java.awt.Label("Name:");
                 levels[k] = new java.awt.Label("Levels:");
                 tnames[k] = new java.awt.TextField();
                 tlevels[k] = new java.awt.TextField();
                 tnames[k].addTextListener(new java.awt.event.TextListener() {
                   public void textValueChanged(TextEvent e) {
                     enterChanged();
                   }
                 });
                 tlevels[k].addTextListener(new java.awt.event.TextListener() {
                   public void textValueChanged(TextEvent e) {
                     enterChanged();
                   }
                 });
                 names[k].setBounds(10, 50+20*k, 40, 20);
                 tnames[k].setBounds(50, 50+20*k, 90, 20);
                 levels[k].setBounds(160, 50+20*k, 40, 20);
                 tlevels[k].setBounds(200, 50+20*k, 40, 20);
                 add(names[k]);
                 add(levels[k]);
                 add(tnames[k]);
                 add(tlevels[k]);
            }

            int j=0;
            if (grpnum>0)
            {
              label2 = new java.awt.Label("Select group variable(s):");
              label2.setBounds(300,30,130,20);
              add(label2);
              grpchecks = new java.awt.Checkbox[grpnum];
              for (int kk=0; kk<grp.length; kk++)
              {
                if (grp[kk]==true)
                {
                  grpchecks[j] = new java.awt.Checkbox(ds.names[kk]);
                  grpchecks[j].setBounds(300,50+20*j, 130, 20);
                  add(grpchecks[j]);
                  j++;
                }
              }
            }

           button2 = new java.awt.Button("OK");
           button2.setBounds(150, 50+20*Math.max(k,j)+20, 150, 20);
           add(button2);
           button2.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                  button2_actionPerformed(e);
                }
            });
           ylevel =50+20*Math.max(k,j)+20+20;

           label0 = new java.awt.Label("", Label.CENTER);
           label0.setBounds(0,ylevel,400,20);
           add(label0);
           for (i=0; i<30; i++)
           {
              dnames[i] = new java.awt.Label("", Label.RIGHT);
              dnames[i].setBounds(10+200*(i%2),ylevel+20+25*(i/2), 60, 25);
              add(dnames[i]);
              dnames[i].setVisible(false);
              choice[i] = new java.awt.Choice();
              choice[i].setBounds(70+200*(i%2),ylevel+20+25*(i/2), 130, 25);
              add(choice[i]);
              choice[i].setVisible(false);
            }

           button3 = new java.awt.Button("Do ANOVA");
           button3.setBounds(150, 480, 150, 20);
           add(button3);
           button3.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                  button3_actionPerformed(e);
                }
            });
           button3.setVisible(false);
        }

        void button2_actionPerformed(ActionEvent e)
        {
          int k=0;
          for (int i=0; i<Math.min((ds.names.length-grpnum),5); i++)
          {
            if (tnames[i].getText().trim().equals("")==false)
            {
              name[k] = tnames[i].getText();
              try{
              level[k] = Integer.valueOf(tlevels[i].getText().trim()).intValue();
              }
              catch(Exception ee)
              {
                message m = new message("Please enter an integer numbers for levels of "+ name[k]);
                m.show();
                return;
              }
              k++;
            }
          }
          if (k==0)
          {
            message m = new message("Please select at least one dependent variable.");
            m.show();
            return;
          }
          nvws = k;
          sum=1;
          for (int i=0; i<k; i++)
          {
           sum = sum*level[i];
          }

          if (sum>(ds.names.length-grpnum))
          {
            message m = new message("The total within-subjects levels exceed the dependent variables' number.");
            m.show();
            return;
          }
          else
          {
            String [] l = new String[sum];
            for (int i=0; i<sum; i++)
              l[i]="";
            int kk=0;

            if (k==1)
            {
              for (int m0=0; m0<level[0]; m0++)
              {
                 l[kk] = name[0]+(m0+1);
                 kk++;
              }
            }
            else if (k==2)
            {
              for (int m0=0; m0<level[0]; m0++)
               for (int m1=0; m1<level[1]; m1++)
               {
                 l[kk] = name[0]+(m0+1)+name[1]+(m1+1);
                 kk++;
               }
            }
            else if (k==3)
            {
              for (int m0=0; m0<level[0]; m0++)
                for (int m1=0; m1<level[1]; m1++)
                 for (int m2=0; m2<level[2]; m2++)
                 {
                    l[kk] = name[0]+(m0+1)+name[1]+(m1+1)+name[2]+(m2+1);
                   kk++;
                 }
            }
            else if (k==4)
            {
              for (int m0=0; m0<level[0]; m0++)
                for (int m1=0; m1<level[1]; m1++)
                 for (int m2=0; m2<level[2]; m2++)
                   for (int m3=0; m3<level[3]; m3++)
                   {
                    l[kk] = name[0]+(m0+1)+name[1]+(m1+1)+name[2]+(m2+1)+name[3]+(m3+1);
                    kk++;
                   }
            }
            else if (k==5)
            {
              for (int m0=0; m0<level[0]; m0++)
                for (int m1=0; m1<level[1]; m1++)
                 for (int m2=0; m2<level[2]; m2++)
                   for (int m3=0; m3<level[3]; m3++)
                     for (int m4=0; m4<level[4]; m4++)
                     {
                       l[kk] = name[0]+(m0+1)+name[1]+(m1+1)+name[2]+(m2+1)+name[3]+(m3+1)+name[4]+(m4+1);
                       kk++;
                     }
            } //sum is the total number of dependent vars


            for (int i=0; i<sum; i++)
            {
              dnames[i].setText(l[i]+": ");
              dnames[i].setVisible(true);
              choice[i].add("Not selected");
              for (int j=0; j<ds.names.length; j++)
              {
                //if (grp[j]==false)
                //{
                  choice[i].addItem(ds.names[j]);
                //}
              }
              choice[i].setVisible(true);
            }
          }//end if
          button2.setVisible(false);
          label0.setText("Specify the order of your dependent varibles:");

          if ( (ylevel+20+25*(sum/2+1)) >500 )
          {
            this.setSize(400, (ylevel+20+25*(sum/2+1))+20 );
          }
          button3.setLocation(150, (ylevel+20+25*(sum/2+1)));
          button3.setVisible(true);
        }
        void button3_actionPerformed(ActionEvent e)
        {
          int grp=0;
          if (grpchecks!=null)
          {
                for (int i=0; i<grpchecks.length; i++)
                {
                  if (grpchecks[i].getState()==true)
                  grp++;
                }
          }

          String[] dependent = new String[sum];
          for (int i=0; i<sum; i++)
          {
            if (choice[i].getSelectedItem().equals("Not selected"))
            {
              message m = new message("Please select dependent variable for all within subjects' factors");
              m.show();
              return;
            }
            else
            {
              for (int j=0; j<i; j++)
              {
                if (choice[i].getSelectedItem().equals(choice[j].getSelectedItem()))
                {
                  message m = new message("You selected the duplicated dependent variable for different within subjects' factor.");
                  m.show();
                  return;
                }
              }
              if (grpchecks!=null)
              {
                for (int gi=0; gi<grpchecks.length; gi++)
                {
                  if ((grpchecks[gi].getState()==true) && (grpchecks[gi].getLabel().equals(choice[i].getSelectedItem())) )
                  {
                    message m = new message("You selected the duplicated dependent variable and group variable.");
                    m.show();
                    return;
                  }
                }
              }
              dependent[i] = choice[i].getSelectedItem();
            }
          }//end of for
          if (grp==0)
          {
            doWithinOnly(dependent);
            return;
          }

          String[] group = new String[grp];
          int k=0;
          for (int i=0; i<grpchecks.length; i++)
          {
                 if (grpchecks[i].getState()==true)
                 {
                    group[k] = grpchecks[i].getLabel();
                    k++;
                 }
          }

          //start between subjects
          String[] labelbs = new String[(int)Math.pow(2, grp)];
          k=0;
          for (int i=0; i<grp; i++)
          {
                           labelbs[k] = group[i].substring(0,Math.min(2,group[i].length())); k++;
                           int m =k-1;
                           for (int j=0; j<m; j++)
                           {
                             labelbs[k] = labelbs[j]+"x"+group[i].substring(0,Math.min(2,group[i].length()));
                             k++;
                           }
          }
          labelbs[k] = "Error";

          double [][] means = new double[sum][];
          for (int i=0; i<sum; i++)
          {
                 means[i] = ds.getMeans(dependent[i], group);
                 if (means[i]==null)
                 {
                   message mm = new message("You have missing data in your factorial design.");
                   mm.show();
                   return;
                 }
          }

          int[] nl = new int[grp];
          for (int i=0; i<grp; i++)
          nl[i] = ds.getMaxLevel(group[i]);

          int [] sizes = ds.getSizes(dependent[0], group);

          anovaHResult aa = new anovaHResult(means, nl, sizes);

          double[][][] ind = new double[sum][][];//for err
          for (int i=0; i<sum; i++)
          {
                 ind[i] = ds.getMultiGrps(dependent[i], group);
          }

          double[][] err = new double[sum][sum];
          for (int i=0; i<ind[0].length; i++) //ind[0].length=nc, for each cell
          {
                 double[][] sub = new double[sum][sizes[i]];

                 for (int j=0; j<sum; j++)
                   for (k=0; k<sizes[i]; k++)
                     sub[j][k] = ind[j][i][k];

                 err = DoubleMatrix.add(err,  calsse(sub));
           }

          double sse = 0;
          for (int i=0; i<sum; i++)
           for (int j=0; j<sum; j++)
            sse = sse + err[i][j];

          sse = sse/(double)sum;

          double[] ssqbs = new double[aa.ssq.length+1];
          for (int i=0; i<aa.ssq.length; i++)
            ssqbs[i] = aa.ssq[i];
          ssqbs[ssqbs.length-1] = sse;

          int[] dfbs = new int[ssqbs.length];
          for (int i=0; i<(ssqbs.length-1); i++)
            dfbs[i] = aa.df[i];
          dfbs[dfbs.length-1] = ds.n - sizes.length;

          //start within-subjects
         double[] mean = new double[sum];
         String[] labelws = new String[(int)Math.pow(2, nvws)-1];//[labelbs.length+1]; //labelbs.length+1, +1 for within only
         k=0;
         for (int i=0; i<nvws; i++)
         {
                labelws[k] = name[i].substring(0,Math.min(2,name[i].length())); k++;
                int m =k-1;
                for (int j=0; j<m; j++)
                {
                  labelws[k] = labelws[j]+"x"+name[i].substring(0,Math.min(2,name[i].length()));
                  k++;
                }
         }

         String[][] labelwsbs = new String[(int)Math.pow(2, nvws)-1][labelbs.length+1];
         for (int i=0; i<labelws.length; i++)
           labelwsbs[i][0] = labelws[i];

         for (int i=0; i<labelws.length; i++)
         {
           for (int j=0; j<labelbs.length-1; j++)
             labelwsbs[i][j+1] = labelbs[j]+"x"+labelws[i];
           labelwsbs[i][labelbs.length] = "Error";
         }

         int[] nlws = new int[nvws];
         for (int i=0; i<nvws; i++)
         {
           nlws[i] = level[i];
          }

          for (int i=0; i<sum; i++)
            for (int j=0; j<means[i].length; j++)
              mean[i] = mean[i] + means[i][j]; //for each dep var, sum all cell's means

          for (int i=0; i<sum; i++)
          mean[i] = mean[i]/(double)means[i].length;//for each dep var, average of all cell's means*/

          anovaResult aws = new anovaResult(mean, nlws, aa.getnh()*aa.getNC());
          //anovaResult aws = new anovaResult(means, nlws, sizes); //joan change 5/27
          double[] ssqws = aws.getSSq();

          double [][] depcontrws = aws.getNIA(); //normalized within subjects factor contrast
          int[] df = aws.getDf();
          double[][][] H = aa.getHs();
          double nh = aa.getnh();
          double[][] sswsbs = new double[ssqws.length][H.length+2]; //H: H matrix for between subject, +1 for within subjects only, +1 for err; ssq is the within subjects ssq array
          int[][] dfwsbs = new int[ssqws.length][H.length+2];

          for (int i=0; i<ssqws.length; i++)
            dfwsbs[i][0] = df[i];
          for (int i=0; i<labelws.length; i++)
           for (int j=0; j<labelbs.length; j++)
             dfwsbs[i][j+1] = df[i]*dfbs[j];

          for (int i=0; i<ssqws.length; i++)
            sswsbs[i][0] = ssqws[i];

          int cr=0; //index for within subject contrast matrix rows
          for (int i=0; i<df.length; i++) //contrast matrix's total df
          {
            if (df[i]==0) break;
            else //take day , trial, dayxtrial
            {
              for (int j=0; j<df[i]; j++)
              {
                double[] c = depcontrws[cr];
                int Hi=0; //depx1
                for (Hi=0; Hi<H.length; Hi++) //Hi: 1 for a, 2 for b, 2 for ab
                {
                  double[][] HH = H[Hi]; //HH is sum x sum = dep x dep
                  double s = calsum(c, HH);
                  sswsbs[i][Hi+1] = sswsbs[i][Hi+1] + nh*s;
                  //message m0 = new message("nh="+nh+", calsum="+s+", ssbsws["+i+"]["+Hi+"]="+ssbsws[i][Hi]);
                  //m0.show();
                }
                sswsbs[i][Hi+1] = sswsbs[i][Hi+1]+calsum(c, err); //err term
                cr++;
              } //inc 1 within contrast vec, add up for all contrasts for one within-subjects factor
            }
          }

          multianovaFrame af = new multianovaFrame();
          af.setData(ssqbs, dfbs, labelbs, sswsbs, dfwsbs, labelwsbs);
          af.show();
          //message mm = new message(l);
          //mm.show();
        }

        public double calsum(double[] d, double[][] H)
        {
          if (d.length!=H.length)
          {
            message m = new message("dHd' calculation wrong!");
            m.show();
            return(0);
          }
          double[] dh = DoubleMatrix.multiply(d, H);
          double out=0;
          for (int i=0; i<d.length; i++)
          {
            out=out+dh[i]*d[i];
          }
          return(out);
        }
        void enterChanged()
        {
          button2.setVisible(true);
          button3.setVisible(false);
          label0.setText("");
          for (int i=0; i<30; i++)
          {
            dnames[i].setVisible(false);
            choice[i].setVisible(false);
            if (choice[i].countItems() > 1)
              choice[i].removeAll();
          }
        }

        double[][] calsse(double[][] x) //x: mtrial(dep) x nsub
        {
            int mtrial = x.length;
            int nsub = x[0].length;

            double[] submean = new double[mtrial];
            for (int i=0; i<mtrial; i++)
             for (int j=0; j<nsub; j++)
              submean[i] = submean[i]+x[i][j];

            for (int i=0; i<mtrial; i++)
             for (int j=0; j<nsub; j++)
               x[i][j] = x[i][j]-submean[i]/(double)nsub;

            double[][] xt =DoubleMatrix.transpose(x); //nxm

            double [][] E = DoubleMatrix.multiply(x, xt); //mxn x nxm = mxm

            return(E);
        }

        void doWithinOnly(String[] dependent)
        {
          double[] mean = new double[sum];
          for (int i=0; i<sum; i++)
          {
            mean[i]=0.0;
            double[] x = ds.getVar(dependent[i]);
            for (int j=0; j<x.length; j++)
            {
              mean[i] = mean[i]+x[j];
            }
            mean[i] = mean[i]/(double)x.length;
          }
          String[] labelws = new String[(int)Math.pow(2, nvws)-1];//[labelbs.length+1]; //labelbs.length+1, +1 for within only
          int k=0;
          for (int i=0; i<nvws; i++)
          {
                labelws[k] = name[i].substring(0,Math.min(2,name[i].length())); k++;
                int m =k-1;
                for (int j=0; j<m; j++)
                {
                  labelws[k] = labelws[j]+"x"+name[i].substring(0,Math.min(2,name[i].length()));
                  k++;
                }
          }

          String[][] labelwsbs = new String[(int)Math.pow(2, nvws)-1][2];
          for (int i=0; i<labelws.length; i++)
          {
           labelwsbs[i][0] = labelws[i];
           labelwsbs[i][1] = "Error";
          }

          int[] nlws = new int[nvws];
          for (int i=0; i<nvws; i++)
          {
            nlws[i] = level[i];
          }

          anovaResult aws = new anovaResult(mean, nlws, ds.n);
          double[] ssq = aws.getSSq();
          int[] df = aws.getDf();
          double[] ssqws = aws.getSSq();

          double [][] depcontrws = aws.getNIA(); //normalized within subjects factor contrast

          double[][] sswsbs = new double[ssqws.length][2]; //H: H matrix for between subject, +1 for within subjects only, +1 for err; ssq is the within subjects ssq array
          int[][] dfwsbs = new int[ssqws.length][2];

          for (int i=0; i<ssqws.length; i++)
          {
            dfwsbs[i][0] = df[i];
            dfwsbs[i][1] = df[i]*(ds.n-1);
          }

          for (int i=0; i<ssqws.length; i++)
            sswsbs[i][0] = ssqws[i];

          double[][] err = new double[sum][sum];
          double[][] sub = new double[sum][];

          for (int i=0; i<sum; i++)
           sub[i] = ds.getVar(dependent[i]);

          err = calsse(sub);

          int cr=0; //index for within subject contrast matrix rows
          for (int i=0; i<df.length; i++) //contrast matrix's total df
          {
            if (df[i]==0) break;
            else //take day , trial, dayxtrial
            {
              for (int j=0; j<df[i]; j++)
              {
                double[] c = depcontrws[cr];
                sswsbs[i][1] = sswsbs[i][1]+calsum(c, err); //err term
                cr++;
              } //inc 1 within contrast vec, add up for all contrasts for one within-subjects factor
            }
          }

          multianovaFrame af = new multianovaFrame();
          af.setData(null, null, null, sswsbs, dfwsbs, labelwsbs);
          af.show();
        }

}

