package analysis;

import RVLS.closeableFrame;
import java.awt.*;
import java.awt.event.*;
import RVLS.Utility;
import RVLS.message;
import VisualNumerics.math.Statistics;

public class multianovaFrame extends closeableFrame {

  public multianovaFrame() {
    setLayout(null);
    setSize(677,680);
    setTitle("Advanced ANOVA Result");
    label6 = new java.awt.Label("p",Label.CENTER);
    label6.setBounds(528,38,92,18);
    label6.setFont(new Font("Monospaced", Font.BOLD, 12));
    label6.setBackground(new Color(12632256));
    add(label6);
    label5 = new java.awt.Label("F",Label.CENTER);
    label5.setBounds(426,38,92,18);
    label5.setFont(new Font("Monospaced", Font.BOLD, 12));
    label5.setBackground(new Color(12632256));
    add(label5);
    label4 = new java.awt.Label("MS",Label.CENTER);
    label4.setBounds(312,38,108,18);
    label4.setFont(new Font("Monospaced", Font.BOLD, 12));
    label4.setBackground(new Color(12632256));
    add(label4);
    label3 = new java.awt.Label("SSQ",Label.CENTER);
    label3.setBounds(204,38,101,18);
    label3.setFont(new Font("Monospaced", Font.BOLD, 12));
    label3.setBackground(new Color(12632256));
    add(label3);
    label2 = new java.awt.Label("df",Label.CENTER);
    label2.setBounds(143,38,54,18);
    label2.setFont(new Font("Monospaced", Font.BOLD, 12));
    label2.setBackground(new Color(12632256));
    add(label2);
    label1 = new java.awt.Label("Source",Label.CENTER);
    label1.setBounds(22,38,116,18);
    label1.setFont(new Font("Monospaced", Font.BOLD, 12));
    label1.setBackground(new Color(12632256));
    add(label1);
  }

  java.awt.Label label1;
  java.awt.Label label2;
  java.awt.Label label3;
  java.awt.Label label4;
  java.awt.Label label5;
  java.awt.Label label6;
  java.awt.Button button1;

  java.awt.Label[][] bs;
  java.awt.Label[][][] wsbs;
  int nextpage;
  double[][]sswsbs;
  int[][] dfwsbs;
  String[][] labelwsbs;


  public void setDataBS(double[] ss, int[] df, String[] label, int startH)
  {
    bs = new java.awt.Label[ss.length][6];
    double mse = ss[ss.length-1]/(double)df[df.length-1];

    for (int i=0; i<ss.length; i++)
    {
      bs[i][0] = new java.awt.Label(label[i], Label.CENTER); //df
      bs[i][0].setBounds(32,startH+18*i,103,18);
      bs[i][0].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(bs[i][0]);

      bs[i][1] = new java.awt.Label(""+df[i], Label.RIGHT); //df
      bs[i][1].setBounds(145,startH+18*i,46,18);
      bs[i][1].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(bs[i][1]);

      bs[i][2] = new java.awt.Label(Utility.format(ss[i], 4), Label.RIGHT); //ss
      bs[i][2].setBounds(208,startH+18*i,90,18);
      bs[i][2].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(bs[i][2]);

      double ms = ss[i]/(double)df[i];
      bs[i][3] = new java.awt.Label(Utility.format(ms, 4), Label.RIGHT);//ms
      bs[i][3].setBounds(312,startH+18*i,100,18);
      bs[i][3].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(bs[i][3]);

      if (i<ss.length-1) //exclude the error term
      {
        bs[i][4] = new java.awt.Label(Utility.format(ms/mse, 4), Label.RIGHT);//F
        bs[i][4].setBounds(433,startH+18*i,78,18);
        bs[i][4].setFont(new Font("Monospaced", Font.PLAIN, 12));
        add(bs[i][4]);
        double p = 1.0-Statistics.FCdf(ms/mse, df[i], df[df.length-1]);
        bs[i][5] = new java.awt.Label(Utility.format(p, 4), Label.RIGHT);
        bs[i][5].setBounds(524,startH+18*i,78,18);
        bs[i][5].setFont(new Font("Monospaced", Font.PLAIN, 12));
        //message m = new message("p="+p+", i="+i+", mse="+mse+", ss.length="+ss.length+", df.length="+df.length); m.show();
        if (p<=0.05) bs[i][5].setForeground(Color.red);
        add(bs[i][5]);
      }
    }   //end of for
  }

  public void setDataWS(double[] ss, int[] df, String[] label, int startH, int wsIndex)
  {
    wsbs[wsIndex] = new java.awt.Label[ss.length][6];
    double mse = ss[ss.length-1]/(double)df[df.length-1];

    for (int i=0; i<ss.length; i++)
    {
      wsbs[wsIndex][i][0] = new java.awt.Label(label[i], Label.CENTER); //df
      wsbs[wsIndex][i][0].setBounds(32,startH+18*i,103,18);
      wsbs[wsIndex][i][0].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(wsbs[wsIndex][i][0]);

      wsbs[wsIndex][i][1] = new java.awt.Label(""+df[i], Label.RIGHT); //df
      wsbs[wsIndex][i][1].setBounds(145,startH+18*i,46,18);
      wsbs[wsIndex][i][1].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(wsbs[wsIndex][i][1]);

      wsbs[wsIndex][i][2] = new java.awt.Label(Utility.format(ss[i], 4), Label.RIGHT); //ss
      wsbs[wsIndex][i][2].setBounds(208,startH+18*i,90,18);
      wsbs[wsIndex][i][2].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(wsbs[wsIndex][i][2]);

      double ms = ss[i]/(double)df[i];
      wsbs[wsIndex][i][3] = new java.awt.Label(Utility.format(ms, 4), Label.RIGHT);//ms
      wsbs[wsIndex][i][3].setBounds(312,startH+18*i,100,18);
      wsbs[wsIndex][i][3].setFont(new Font("Monospaced", Font.PLAIN, 12));
      add(wsbs[wsIndex][i][3]);

      if (i<ss.length-1)
      {
        wsbs[wsIndex][i][4] = new java.awt.Label(Utility.format(ms/mse, 4), Label.RIGHT);//F
        wsbs[wsIndex][i][4].setBounds(433,startH+18*i,78,18);
        wsbs[wsIndex][i][4].setFont(new Font("Monospaced", Font.PLAIN, 12));
        add(wsbs[wsIndex][i][4]);
        double p = 1.0-Statistics.FCdf(ms/mse, df[i], df[df.length-1]);
        wsbs[wsIndex][i][5] = new java.awt.Label(Utility.format(p, 4), Label.RIGHT);
        wsbs[wsIndex][i][5].setBounds(524,startH+18*i,78,18);
        wsbs[wsIndex][i][5].setFont(new Font("Monospaced", Font.PLAIN, 12));
        if (p<=0.05) wsbs[wsIndex][i][5].setForeground(Color.red);
        add(wsbs[wsIndex][i][5]);
      }
    }   //end of for
  }

  public void setData(double[] ssbw, int[] dfbs, String[] labelbs, double[][]sswsbs, int[][] dfwsbs, String[][] labelwsbs)
  {
    this.sswsbs = sswsbs;
    this.dfwsbs = dfwsbs;
    this.labelwsbs = labelwsbs;
    int h, hbs;
    if (ssbw!=null)
    {
      h  = 80+18*ssbw.length;
      hbs = h;
    }
    else
    {
      h = 60;
      hbs = h;
    }
    nextpage=sswsbs.length;
    for (int i=0; i<sswsbs.length; i++)
    {
      h = h+ 18*(sswsbs[0].length+1);//+1 for an empty line for each within subject factor
      if (h>700)
      {
        nextpage=i;  break;
      }
    }

    if (nextpage<sswsbs.length)  this.setSize(677, h-18*sswsbs[0].length+20); //shrink vertical
    else  this.setSize(677, h+10);

    if (ssbw!=null) setDataBS(ssbw, dfbs, labelbs, 60);
    wsbs = new java.awt.Label[nextpage][][];
    for (int i=0; i<nextpage; i++) //# of within subjects
    {
      h = hbs + 18*i*(sswsbs[0].length+1);
      setDataWS(sswsbs[i], dfwsbs[i], labelwsbs[i], h, i);
    }

    if (nextpage<sswsbs.length)
    {
      button1 = new java.awt.Button();
      button1.setLabel("Next");
      button1.setBounds(270, getSize().height-50,137, 20);
      this.add(button1);
      setTitle("Advanced ANOVA Result  Page 1");
      button1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
              button1_actionPerformed(e);
            }
          });
    }
  }

  public void setData(double[] ssbw, int[] dfbs, String[] labelbs)
  {
    int h = 90+18*ssbw.length;
    this.setSize(677, h);

    setDataBS(ssbw, dfbs, labelbs, 60);
  }
  public void setData(double[][]sswsbs, int[][] dfwsbs, String[][] labelwsbs)
  {
    this.sswsbs = sswsbs;
    this.dfwsbs = dfwsbs;
    this.labelwsbs = labelwsbs;
    nextpage=sswsbs.length;
    int h=60;
    //boolean next=false;
    for (int i=0; i<sswsbs.length; i++)
    {
      //next=true;
      h = h+ 18*(sswsbs[0].length+1);//+1 for an empty line for each within subject factor
      if (h>700)
      {
        nextpage=i;  break;
      }
    }


    if (nextpage<sswsbs.length) this.setSize(677, h-18*sswsbs[0].length+20); //shrink vertical
    else this.setSize(677, h+10);

    wsbs = new java.awt.Label[nextpage][][];
    for (int i=0; i<nextpage; i++) //# of within subjects
    {
      h = 60 + 18*i*(sswsbs[0].length+1);
      setDataWS(sswsbs[i], dfwsbs[i], labelwsbs[i], h, i);
    }

    if (nextpage<sswsbs.length)
    {
      button1 = new java.awt.Button();
      button1.setLabel("Next");
      button1.setBounds(270, getSize().height-50,137, 18);
      this.add(button1);
      button1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
              button1_actionPerformed(e);
            }
          });
    }
  }

    void button1_actionPerformed(ActionEvent e)
    {
      multianovaFrame mm = new multianovaFrame();
      double[][] sswsbsn = new double[sswsbs.length-nextpage][sswsbs[0].length];
      int[][] dfwsbsn = new int[sswsbs.length-nextpage][sswsbs[0].length];
      String[][] labelwsbsn = new String[sswsbs.length-nextpage][sswsbs[0].length];
      String s = this.getTitle();
      int pagenum = Integer.valueOf( s.substring( s.lastIndexOf(" ")+1, s.length()).trim() ).intValue();

      for (int i=nextpage; i<sswsbs.length; i++)
      {
        sswsbsn[i-nextpage] = sswsbs[i];
        dfwsbs[i-nextpage] = dfwsbs[i];
        labelwsbs[i-nextpage] = labelwsbs[i];
      }
      mm.setData(sswsbsn, dfwsbs, labelwsbs);
      mm.setTitle("Advanced ANOVA Result  Page "+(pagenum+1));
      mm.setLocation(0, (pagenum+1)*18);
      mm.show();
    }


}