package analysis;

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.util.*;
import VisualNumerics.math.Statistics;
import RVLS.*;

public class qqFrame extends closeableFrame {
  public  qqFrame(double[] rawData)
  {
    setSize(380,450);
    setLayout(null);
    setBackground(Color.white);

    label2 = new java.awt.Label("Raw scores", Label.CENTER);
    //label2.setFont(new Font(getFont().getName(), Font.PLAIN, 11));
    label2.setBounds(2,34,70,16);
    add(label2);
    label4 = new java.awt.Label("Normal Quantiles", Label.CENTER);
    label4.setBounds(70,360,260,20);
    add(label4);
    label5 = new java.awt.Label("____", Label.CENTER);
    label5.setForeground(Color.red);
    label5.setBounds(40,375,40,20);
    add(label5);
    label6 = new java.awt.Label("Estimated normal reference line from raw scores.", Label.LEFT);
    label6.setBounds(80,380,310,20);
    add(label6);
    label7 = new java.awt.Label("____", Label.CENTER);
    label7.setForeground(Color.blue);
    label7.setBounds(40,395,40,20);
    add(label7);
    label8 = new java.awt.Label("Raw scores' quantiles mapping the normal quantiles.", Label.LEFT);
    label8.setBounds(80,400,310,20);
    add(label8);

    quantile = getNormalquantile(rawData);
    normalX = getNormalX(quantile);

    reference = getReference(quantile);

    qqplot1 = new qqplot();
    qqplot1.setBounds(2,50,335,310);
    add(qqplot1);
    qqplot1.setData(normalX, quantile, reference);
  }

  java.awt.Label label2;
  java.awt.Label label4;
  java.awt.Label label5;
  java.awt.Label label6;
  java.awt.Label label7;
  java.awt.Label label8;
  qqplot qqplot1;
  double[]  normalX, quantile, reference;
  double mean, sd, num;

  public double[] getNormalquantile(double[] rawdata)
   {
     desc d = new desc(rawdata);
     mean = d.mean;
     sd = d.sd;

     num = (double)rawdata.length;

     double[] q = new double[(int)num-1];

     for (int i=0; i<(int)(num-1); i++)
     {
       q[i] = d.percentile(((double)(i+1))/num, rawdata);
     }
     return(q);
   }

   public double[] getNormalX(double[] quantile)
   {
     double[] normalX = new double[quantile.length];

     for (int i=0; i<normalX.length; i++)
     {
       normalX[i] = Statistics.inverseNormalCdf(((double)(i+1))/num);
     }

     return(normalX);
   }

   public double[] getReference(double[] quantile)
   {
     double[]  reference = new double[quantile.length];
     for (int i=0; i<quantile.length; i++)
     {
       reference[i] = Statistics.inverseNormalCdf(((double)(i+1))/num)*sd+mean;
     }
     return(reference);
  }
}