package analysis;

import java.awt.*;
import java.applet.Applet;
import RVLS.*;
import java.beans.Beans;

public class qqplot extends Canvas {

  public static final int RECT=0;
  public static final int CIRCLE =1;
  public int  N, shape, ndecx, ndecy, px0,py0,pxf,pyf;
  public int [] X,Y, YNormal;
  public boolean filled, reference=false;
  public LT Lx, Ly;
  public double [] XX,YY, YYNormal;
  public double minX,maxX,minY,maxY;

//double minY,maxY; change to public according to Dr. Lane's suggestion 11/15/99
  double x0,xf,y0,yf,xinc,yinc;
  double b,A,r;
  Graphics g;
  Color c=Color.blue, regColor=Color.black;
  boolean doreg,drawError=false;
  Point reg0,regf;
  Font font;
  reg reg1;

  public qqplot () {
  }

  public void setData (double[] X, double [] Y, double [] YY) {
    int N=X.length;
    setData(X,Y, YY,N);
  }

  public void setData (double[] X, double [] Y, double[] YY, int N) {
    minX= X[0];
    maxX = X[0];
    minY = Y[0];
    maxY = Y[0];
    for (int i= 1;i<N;i++) {
      minX = Math.min(minX,X[i]);
      minY = Math.min(minY,Y[i]);
      minY = Math.min(minY,YY[i]);
      maxX = Math.max(maxX,X[i]);
      maxY = Math.max(maxY,Y[i]);
      maxY = Math.max(maxY,YY[i]);
    }
    setData(X,Y,YY,minX,maxX,minY,maxY,N);
  }


  public void setData (double[] X, double [] Y, double [] YY, double _minX, double _maxX,
                       double _minY, double _maxY, int _N) {
    int [] location = new int[4];
    Dimension d = getSize();
    //location[0]=50;
    location[0]=50;
    location[1]=d.width-20;
    location[2]=10;
    location[3]=d.height-25;
    minX= _minX;
    maxX = _maxX;
    minY = _minY;
    maxY = _maxY;
    int N=_N;
    double [] XL = new double[3];
//minX=0;maxX=100;
    int numLabs;
    numLabs =10;
    if (d.width < 150) {
      numLabs = 5;
    }

    XL = graphUtilities.intlabels(minX,maxX,numLabs);
    int stepsX = (int) Math.rint((XL[2]-XL[1])/XL[0]);
    double x0=XL[1];
    double xf = XL[2];

    double [] YL = new double[3];
    numLabs =10;
    if (d.height < 150) {
      numLabs = 5;
    }

    YL = graphUtilities.intlabels(minY,maxY,numLabs);

    int stepsY = (int) Math.rint((YL[2]-YL[1])/YL[0]);
// label info is specified
    int decX;
    if (XL[0] >= 1) decX = 0;
    else if (XL[0] >= .1) decX=1;
    else if (XL[0] > .01) decX=2;
    else decX=3;

    int decY;
    if (YL[0] >= 1) decY = 0;
    else if (YL[0] >= .1) decY=1;
    else if (YL[0] > .01) decY=2;
    else decY=3;

    initialize(X,Y,YY, XL[1],XL[2], YL[1],YL[2],stepsX,stepsY, location,true,
               CIRCLE,c,decX,decY,N);
    repaint();
  }

  public void setShape(int _shape) {
    shape=_shape;
  }

  public void setFilled(boolean _filled) {
    filled=_filled;
  }

  void initialize(double[] _X, double [] _Y,double[] _YY,
                  double _x0, double _xf, double _y0, double _yf, int xticks, int yticks,
    int[] _location, boolean  _filled,int _shape, Color _c, int _ndecx, int _ndecy, int _N)
  {
    N=_N;
    XX = new double[N];
    XX=_X;
    YY = new double[N];
    YY=_Y;
    if (N == 1) {
      b=0;
      A=YY[0];
      r=0;
      _x0 =  (int) (XX[0] -1);
      _xf = (int) (XX[0] + 1);
      _y0 =(int) (YY[0] -1);
      _yf=  (int) (YY[0] +1);
      xticks = 5;
      yticks=5;
    }
    else {
      reg1 = new reg(XX,YY,N);
      b = reg1.getSlope();
      A = reg1.getIntercept();
      r=reg1.getr();
    }

    filled=_filled;

    x0=_x0;y0=_y0;xf=_xf;yf=_yf;
    ndecx=_ndecx;
    ndecy=_ndecy;

    if (y0 < yf) {
      double temp = y0;
      y0=yf;
      yf=temp;
    }

    xinc = (_xf-_x0)/(xticks); // increment for X ticks
    yinc = (y0-yf)/(yticks);   // increment for y ticks

    shape=_shape;

    X = new int[N];
    Y = new int[N];
    Lx = new LT(x0,xf,_location[0],_location[1]);	 // for transforming from X values to pixels
    Ly = new LT(y0,yf,_location[2],_location[3]);  // for transforming from Y values to pixels
    Y = Ly.ItransformArray(_Y); // Y has pixes for Y values
    YNormal = Ly.ItransformArray(_YY);
    X = Lx.ItransformArray(_X);	// X has pixels for X values

    reference = true;

    c = _c;
    font = new Font("TimesRoman",Font.PLAIN,10);

    double xOrigin = _x0-xinc/4;	// Draw Y axis a little to left of lowest tick
    px0 = (int) Math.rint(Lx.transform(xOrigin));
    double xEnd = _xf + xinc/4;	//draw x-axis a little past highest tick
    pxf = (int) Math.rint(Lx.transform(xEnd));
    py0 = (int) Math.rint(Ly.transform(y0+yinc/8)); //same fo r y axis
    pyf = (int) Math.rint(Ly.transform(yf-yinc/8));

    double yv1 = b*xOrigin + A;
    double yv2 = b*xEnd + A;

    int x1 = (int) Math.rint(Lx.transform(xOrigin));
    int x2 = (int) Math.rint(Lx.transform(xEnd));
    int y1 = (int) Math.rint(Ly.transform(yv1));
    int y2 = (int) Math.rint(Ly.transform(yv2));
    reg0 = new Point(x1,y1);
    regf = new Point(x2,y2);

  }
  /**
   * Displays the points as rectangles or circles. Can be filled or unfilled.
   *
   * @param g		graphics object
   */

  public void drawPoints(Graphics g) {
    g.setColor(c);
    for (int i=0;i<N;i++) {
      switch (shape) {

      case RECT:
        if (filled)
          g.fillRect(X[i],Y[i],1,1);
        else
          g.drawRect(X[i],Y[i],1,1);
        break;
      case CIRCLE:
        if (filled)
        {
          g.drawOval(X[i],Y[i],1,1);
          //System.out.println("XX["+i+"]="+XX[i]+", X["+i+"]="+X[i]+",   YY["+i+"]="+YY[i]+", Y["+i+"]="+Y[i]);
        }
        else
          g.drawOval(X[i],Y[i],1,1);
    }
    }
  }



  public void paint (Graphics g) {
    if ((N==0) || (java.beans.Beans.isDesignTime())) {
      Dimension d = getSize();
      g.drawRect(50,10,d.width-51,d.height-11);
      g.drawRect(0,0,d.width-1,d.height-1);
    }
    else {
      if (reference)
      {
        g.setColor(Color.red);
        //System.out.println("py0="+py0+", pyf="+pyf);
        for (int i=0;i<N;i++)
        {
          if ((YNormal[i] > py0) && (YNormal[i] < pyf))
          g.drawOval(X[i],YNormal[i],1,1);
        }
      }
      drawPoints(g);
      if(drawError) {
        g.setColor(Color.red);
        for (int i=0;i<N;i++) {

          double yp=b*XX[i]+A;
          int ypi = (int) Ly.transform(yp);
          g.drawLine(X[i],Y[i],X[i],ypi);
        }
      }
      g.setColor(Color.black);
      graphUtilities.plotAxes(g,px0,pxf,py0,pyf,x0,xf,y0,yf,font,Lx,Ly,xinc,yinc,ndecx,ndecy,false);
      if (doreg) {
        g.setColor(regColor);
        g.clipRect(px0,py0,pxf-px0,pyf-py0);
        g.drawLine(reg0.x,reg0.y,regf.x,regf.y);
      }

    }

  }
  public void upDateStats() {
//reg  reg1 = new reg(XX,YY);
    reg1 = new reg(XX,YY);
    b = reg1.getSlope();
    A = reg1.getIntercept();
    r=reg1.getr();
  }


  public void setY(double[] _YY) {
    for (int i=0;i<Y.length;i++) {
      YY[i] = _YY[i];
    }
    Y = Ly.ItransformArray(YY); // Y has pixes for Y values
  }
  public void setX(double[] _XX) {
    for (int i=0;i<X.length;i++) {
      XX[i] = _XX[i];
    }
    X = Lx.ItransformArray(XX); // Y has pixes for Y values
  }
  public void setSlope(double b) {
    double yv1 = b*x0+A;
    double yv2 = b*xf+A;
    int x1 = (int) Math.rint(Lx.transform(x0));
    int x2 = (int) Math.rint(Lx.transform(xf));
    int y1 = (int) Math.rint(Ly.transform(yv1));
    int y2 = (int) Math.rint(Ly.transform(yv2));
    reg0 = new Point(x1,y1);
    regf = new Point(x2,y2);
  }

  public void update(Graphics g) {
    Dimension dim = getSize();
    Image osi=createImage(dim.width,dim.height);
    Graphics osg=osi.getGraphics();
    osg.setColor(getBackground());
    osg.fillRect(0,0,dim.width,dim.height);
    osg.setColor(g.getColor());
    paint(osg);
    g.drawImage(osi,0,0,this);
  }


  public Point getUpperLeft() {
    Point p = new Point(px0,py0);
    return p;
  }
  public Point getLowerRight() {
    Point p = new Point(pxf,pyf);
    return p;
  }

}