package analysis;
import VisualNumerics.math.Statistics;
//import VisualNumerics.math.DoubleMatrix;

public class repeatanova {
	public int dfsubject,dftrial, dferror,dftotal, n,k; //k trials, n subjects
	double [] meansub, meantrial;

	public double sserror,sssubject,sstrial,Fsubject,Ftrial,mssubject,mstrial, mse, sstotal, grandmean, psubject, ptrial;

	public repeatanova() {
	}

	public void setData(double [][] X) {
		sserror=0;
		sssubject=0;
		sstrial=0;
		sstotal=0;
		grandmean=0;

		k = X.length; //k trials
		n = X[0].length; //n subjects
                meansub = new double[n];
                meantrial = new double[k];
                for (int j=0; j<k; j++)
                {
                 for (int i=0; i<n; i++)
                 {
                    meantrial[j] = meantrial[j] + X[j][i];
                    meansub[i] = meansub[i] + X[j][i];
                    grandmean = grandmean+X[j][i];
                 }
                }

                for (int j=0; j<k; j++) meantrial[j] = meantrial[j]/(double)n;
                for (int i=0; i<n; i++) meansub[i] = meansub[i]/(double)k;
                grandmean = grandmean/(double)(n*k);

                for (int j=0; j<k; j++)
                {
                 for (int i=0; i<n; i++)
                 {
                  sstotal = sstotal + Math.pow(X[j][i]-grandmean, 2.0);
                 }
                }

                for (int  i=0; i<n; i++)
                {
                  sssubject = sssubject+(double)k*Math.pow(meansub[i]-grandmean, 2.0);
                }

                for (int  j=0; j<k; j++)
                {
                  sstrial = sstrial+(double)n*Math.pow(meantrial[j]-grandmean, 2.0);
                }

		        sserror = sstotal - sssubject - sstrial;

                dftotal = n*k -1;
                dfsubject = n-1;
                dftrial = k-1;
                dferror = dftotal - dfsubject - dftrial;
                mssubject = sssubject/(double)dfsubject;
                mstrial = sstrial/(double)dftrial;
                mse = sserror/(double)dferror;
                if (mse > 0.0001)
                {
                	Fsubject = mssubject/mse;
                	Ftrial = mstrial/mse;
	       			psubject = 1.0-Statistics.FCdf(Fsubject, dfsubject, dferror);
	       			ptrial = 1.0-Statistics.FCdf(Ftrial, dftrial, dferror);
	       	    }
	       	    else
	       	    {
	       	    	Fsubject = -1.0;
                	Ftrial = -1.0;
	       			psubject = -1.0;
	       			ptrial = -1.0;
	       		}
	}


}