package analysis;

import java.awt.*;
import RVLS.*;
import VisualNumerics.math.Statistics;
public class ttestFrame extends closeableFrame {
	public ttestFrame(desc [] d) {
			//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(371,409);
		//setBackground(new Color(-3150081));
		textArea1 = new java.awt.TextArea();
		textArea1.setBounds(25,25,316,347);
		textArea1.setFont(new Font("Monospaced", Font.PLAIN, 12));
		textArea1.setBackground(new Color(16777215));
		add(textArea1);
		//}}
		//{{INIT_MENUS
		//}}
		setTitle ("t-tests");
		String s="";
		double sed,t;
		for (int i=0;i<d.length-1;i++) {

				for (int j=i+1;j<d.length;j++) {
					double ss1=Math.pow(d[i].sd,2)*(d[i].n-1);
					//System.out.println("ss1= " + ss1);
					double ss2=Math.pow(d[j].sd,2)*(d[j].n-1);
					//System.out.println("ss2= " + ss2);
					double nh = 2.0/(1.0/d[i].n + 1.0/d[j].n);
					//System.out.println("nh= " + nh);
					int df = d[i].n+d[j].n-2;
					double MSE =(ss1+ss2)/df;

					sed = Math.sqrt(2*MSE/nh);
					double diff = d[i].mean - d[j].mean;
					t = diff/sed;
					double p = Statistics.tCdf(t,(double)df);
                                        if (p>0.5) p=2.0*(1-p);
                                        else p = 2.0*p;
					double ciWidth = sed*Statistics.inverseTCdf(0.975,(double)df);
					//System.out.println(probFandT.Finv(0.05,1,df) + " " + sed);
					double LL = diff - ciWidth;
					double UL = diff + ciWidth;

					/*
					//System.out.println(" i= " + i + " j= " + j + " " + d[i].mean + " " + d[j].mean);
					s+= i + "  " + d[i].n + "   " + graphUtilities.format(d[i].mean,4)
					 + "  " + graphUtilities.format(d[i].sd,4)
					 + "  " + j + "  " + d[j].n + "  " + graphUtilities.format(d[j].mean,4)
					 + "  " + graphUtilities.format(d[j].sd,4)
					 + "  " + graphUtilities.format(t,4)
					 + "  " + graphUtilities.format(p,4) + "\n";
					 */
					 int i1=i+1;
					 int j1=j+1;
					 s += "Mean " + i1 + " = " + graphUtilities.format(d[i].mean,4) + "\n"
					 	+ "Mean " + j1 + " = " + graphUtilities.format(d[j].mean,4) + "\n"
					 	+ "Mean " + i1 + " - Mean " + j1 + " = " + graphUtilities.format(diff,4) + "\n"
					 	+  "t = " + graphUtilities.format(t,4) +"\n"
					 	+  "df = " + df + "\n"
					 	+  "p = " +  graphUtilities.format(p,4) + "\n"
					 	+ "\n95% Confidence Interval: \n  " +graphUtilities.format(LL,4) + " to " + graphUtilities.format(UL,4) + "\n"
					 	+ "\n------------------------------------" + "\n\n";


				}
			}
		textArea1.setText(s);
}
	//{{DECLARE_CONTROLS
	java.awt.TextArea textArea1;
	//}}
	//{{DECLARE_MENUS
	//}}
}
