package component_r;

import java.awt.*;
import RVLS.*;


	public class drawScatter {
		static final int RECT=0;
		static final int CIRCLE =1;
		int [] X,Y;
		double [] XX,YY;
		int N,px0,py0,pxf,pyf,shape, ndecx, ndecy;
		double x0,xf,y0,yf,xinc,yinc;
		double b,A,r;
		Color c;
		boolean filled,doreg,drawError=false;
		Point reg0,regf;
		//graphUtilities gu;
		Font font;
		LT Lx,Ly;
		reg reg1;
	public drawScatter(double[] _X, double [] _Y,
	         double _x0, double _xf, double _y0, double _yf, int xticks, int yticks,
	         int[] _location, boolean  _filled,int _shape, Color _c, int _ndecx, int _ndecy)
	     {
	     	int N=_X.length;
	     	initialize(_X,_Y,_x0,_xf,_y0,_yf,xticks,yticks,_location,_filled,_shape,_c,_ndecx,ndecy,N);
	     }

	  public drawScatter(double[] _X, double [] _Y,
	         double _x0, double _xf, double _y0, double _yf, int xticks, int yticks,
	         int[] _location, boolean  _filled,int _shape, Color _c, int _ndecx, int _ndecy,int N) {
	         initialize(_X,_Y,_x0,_xf,_y0,_yf,xticks,yticks,_location,_filled,_shape,_c,_ndecx,ndecy,N);
	         }

	  public void initialize(double[] _X, double [] _Y,
	         double _x0, double _xf, double _y0, double _yf, int xticks, int yticks,
	         int[] _location, boolean  _filled,int _shape, Color _c, int _ndecx, int _ndecy, int _N)
	               {
	               	N=_N;
	               	XX = new double[N];
	               	XX=_X;
	               	YY = new double[N];
	               	YY=_Y;
	               	//long t1 = new java.util.Date().getTime();
	               	reg1 = new reg(XX,YY);
	               	b = reg1.getSlope();
	               	A = reg1.getIntercept();
	               	r=reg1.getr();
	               	filled=_filled;
	               	//long t2 = new java.util.Date().getTime();
	               //	System.out.println(t2-t1);

		/*
		X:   array of X values
		Y:   array of Y values
		_x0:first   X tick
		_xf: final X tick
		_y0: first Y tick
		_yf: final Y tick
		xticks: number of ticks on X axis
		ytincks: number of ticks on Y axis
		location[]:  array containing lowest x, highest x, lowest y, highest y coordinates for plotting.
			 Extra room needed for axis labels.
		filled: true for filled, false for outline
		_shape:  0 for rect, 1 for circle
		_c: color of plotted points
		ndecx: number of dec placed for X-axis labels
		ndecy: number of dec placed for y-axis labels


		*/

		x0=_x0;y0=_y0;xf=_xf;yf=_yf;
		ndecx=_ndecx;
		ndecy=_ndecy;

		if (y0 < yf) {
			double temp = y0;
			y0=yf;
			yf=temp;
		}

		 xinc = (_xf-_x0)/(xticks); // increment for X ticks
		 yinc = (y0-yf)/(yticks);   // increment for y ticks

		shape=_shape;

		X = new int[N];
		Y = new int[N];
		Lx = new LT(x0,xf,_location[0],_location[1]);	 // for transforming from X values to pixels
		Ly = new LT(y0,yf,_location[2],_location[3]);  // for transforming from Y values to pixels
		Y = Ly.ItransformArray(_Y); // Y has pixes for Y values
		X = Lx.ItransformArray(_X);	// X has pixels for X values
		c = _c;
		//gu = new graphUtilities(); // will be used to draw axes
		font = new Font("TimesRoman",Font.PLAIN,10);

//The following are to figure out info for the axes
		double xOrigin = _x0-xinc/4;	// Draw Y axis a little to left of lowest tick
		px0 = (int) Math.rint(Lx.transform(xOrigin));
		double xEnd = _xf + xinc/4;	//draw x-axis a little past highest tick
		pxf = (int) Math.rint(Lx.transform(xEnd));
		py0 = (int) Math.rint(Ly.transform(y0+yinc/4)); //same fo r y axis
		pyf = (int) Math.rint(Ly.transform(yf-yinc/4));
		doreg=false;

		double yv1 = b*x0+A;
		double yv2 = b*xf+A;
		int x1 = (int) Math.rint(Lx.transform(x0));
		int x2 = (int) Math.rint(Lx.transform(xf));
		int y1 = (int) Math.rint(Ly.transform(yv1));
		int y2 = (int) Math.rint(Ly.transform(yv2));
		reg0 = new Point(x1,y1);
		regf = new Point(x2,y2);



	}

	public void setColor(Color _c) {
		c=_c;
	}
	public void setShape(int _shape) {
		shape=_shape;
	}
	public void setFilled(boolean _filled) {
		filled=_filled;
	}
	public void setRegLine(boolean _doreg) {
		doreg=_doreg;
	}
	public boolean getRegLine() {
		return doreg;
	}
	public double getr() {
		return r;
	}
	public double getSlope() {
		return b;
	}
	public double getIntercept() {
		return A;
	}
	public double computeSSE(double b, double A) {
		double sse=0;
		for (int i=0;i<N;i++) {
			double yp=b*XX[i]+A;
			sse+= Math.pow(YY[i]-yp,2);
		}
		return sse;
	}

	public double getSSE() {
		return computeSSE(b,A);
	}
	public void upDateStats() {
		reg  reg1 = new reg(XX,YY);
	     b = reg1.getSlope();
	     A = reg1.getIntercept();
	     r=reg1.getr();
	}


	public void setY(double[] _YY) {
		for (int i=0;i<Y.length;i++) {
			YY[i] = _YY[i];
		}
		Y = Ly.ItransformArray(YY); // Y has pixes for Y values
	}
	public void setX(double[] _XX) {
		for (int i=0;i<X.length;i++) {
			XX[i] = _XX[i];
		}
		X = Lx.ItransformArray(XX); // Y has pixes for Y values
	}
	/*
	public void setSlope(double b) {
		double yv1 = b*x0+A;
		double yv2 = b*xf+A;
		int x1 = (int) Math.rint(Lx.transform(x0));
		int x2 = (int) Math.rint(Lx.transform(xf));
		int y1 = (int) Math.rint(Ly.transform(yv1));
		int y2 = (int) Math.rint(Ly.transform(yv2));
		reg0 = new Point(x1,y1);
		regf = new Point(x2,y2);
	}
	*/
	public void setSlope(double b) {
		//System.out.println(b);
		double yv1 = b*x0+A;
		double yv2 = b*xf+A;
		int x1 = (int) Math.rint(Lx.transform(x0));
		int x2 = (int) Math.rint(Lx.transform(xf));
		int y1 = (int) Math.rint(Ly.transform(yv1));
		int y2 = (int) Math.rint(Ly.transform(yv2));
		reg0 = new Point(x1,y1);
		regf = new Point(x2,y2);
	}

	public void draw(Graphics g) {



	g.setColor(c);
	for (int i=0;i<N;i++) {
	  	switch (shape) {

  	 	case RECT:
  	 		if (filled)
  	 			g.fillRect(X[i]-2,Y[i]-2,4,4);
  			else
  			    g.drawRect(X[i]-2,Y[i]-2,4,4);
  			    break;
  		case CIRCLE:
  			if (filled)
  	 			g.fillOval(X[i]-2,Y[i]-2,4,4);
  			else
  			    g.drawOval(X[i]-2,Y[i]-2,4,4);
  			}
		}
	if(drawError) {
		for (int i=0;i<N;i++) {
			g.setColor(Color.red);
			double yp=b*XX[i]+A;
			int ypi = (int) Ly.transform(yp);
			g.drawLine(X[i],Y[i],X[i],ypi);
		}
	}
		g.setColor(Color.black);
		//System.out.println(px0 + " " + pxf + " " + py0 + " " + pyf);
		graphUtilities.plotAxes(g,px0,pxf,py0,pyf,x0,xf,y0,yf,font,Lx,Ly,xinc,yinc,ndecx,ndecy,false);
		if (doreg) {
			g.clipRect(px0,py0,pxf-px0,pyf-py0);
			/*
			double yv1 = b*x0+A;
			double yv2 = b*xf+A;
			int x1 = (int) Math.rint(Lx.transform(x0));
			int x2 = (int) Math.rint(Lx.transform(xf));
			int y1 = (int) Math.rint(Ly.transform(yv1));
			int y2 = (int) Math.rint(Ly.transform(yv2));
			*/
			//g.drawLine(x1,y1,x2,y2);
			g.drawLine(reg0.x,reg0.y,regf.x,regf.y);
		}
	}

	public void setDrawError(boolean sde) {
		drawError=sde;
	}
	public boolean getDrawError() {
		return drawError;
	}
	public Point getUpperLeft() {
		Point p = new Point(px0,py0);
		return p;
	}
	public Point getLowerRight() {
		Point p = new Point(pxf,pyf);
		return p;
	}
	public int getN() {
		return N;
	}

	public double getSdx() {
		return reg1.getSdx();
	}

	public double getSdy() {
		return reg1.getSdy();
	}
}