package component_r;

import java.awt.*;
import java.applet.Applet;
import RVLS.*;
//import drawScatter;
//import LT;
//import reg;

public class scatter extends Canvas {
		drawScatter ds;
		 double minX,maxX,minY,maxY;

		//int currline;

		Graphics g;

	public scatter () {
		ds=null;

	}

	public void setY(double [] Y) {
		if(ds!=null) {
			ds.setY(Y);
			repaint();
		}
	}
	public void setX(double [] X) {
		if(ds!=null) {
			ds.setX(X);
			repaint();
		}
	}
/*
	public void setSlope(Double s) {
		if(ds!=null) {
			ds.setSlope(s);
		}
	}
	*/
	public void setSlope(double s) {
		if(ds != null) {
			ds.setSlope(s);
			repaint();
		}
	}
	public double getSlope() {
		if(ds != null) {
			return ds.getSlope();
		}
		return 0;
	}
	 public void setData (double[] X, double [] Y) {
		 //The following are for labeling the X and y axes
		int N=X.length;
		setData(X,Y,N);
	}
	public void setData (double[] X, double [] Y, int N) {
		minX= X[0];
	    maxX = X[0];
	    minY = Y[0];
	    maxY = Y[0];
	   for (int i= 1;i<X.length;i++) {
	   		minX = Math.min(minX,X[i]);
	   		minY = Math.min(minY,Y[i]);
	   		maxX = Math.max(maxX,X[i]);
	   		maxY = Math.max(maxY,Y[i]);
	   	}
		setData(X,Y,minX,maxX,minY,maxY,N);
	}
	public void setData (double[] X, double [] Y, double minX, double maxX,
		double minY, double maxY) {
		int N = X.length;
		setData(X,Y,minX,maxX,minY,maxY,N);
	}


	public void setData (double[] X, double [] Y, double _minX, double _maxX,
		double _minY, double _maxY, int _N) {
	   //location specifies where the drawing is to take place
	   		int [] location = new int[4];
	   	Dimension d = getSize();
	   	location[0]=50;
	   	location[1]=d.width-20;
	   	location[2]=10;
	   	location[3]=d.height-25;
	    minX= _minX;
	    maxX = _maxX;
	    minY = _minY;
	    maxY = _maxY;
	   int N=_N;
	   double [] XL = new double[3];
	   //minX=0;maxX=100;
	   int numLabs;
	   numLabs =10;
	   if (d.width < 150) {
	   	numLabs = 5;
	   }

	   XL = graphUtilities.intlabels(minX,maxX,numLabs);
	   //System.out.println(XL[0] + " " + XL[1] + " " + XL[2]);
	   int stepsX = (int) Math.rint((XL[2]-XL[1])/XL[0]);
	  // double x0=XL[1];
	   //double xf = XL[2];

	   	double [] YL = new double[3];
	   	numLabs =10;
	   if (d.height < 150) {
	   	numLabs = 5;
	   }

	   YL = graphUtilities.intlabels(minY,maxY,numLabs);

	   int stepsY = (int) Math.rint((YL[2]-YL[1])/YL[0]);
	   // label info is specified
		int decX;
		if (XL[0] >= 1) decX = 0;
		else if (XL[0] >= .1) decX=1;
		else if (XL[0] > .01) decX=2;
		else decX=3;

		int decY;
		if (YL[0] >= 1) decY = 0;
		else if (YL[0] >= .1) decY=1;
		else if (YL[0] > .01) decY=2;
		else decY=3;


		ds = new drawScatter(X,Y,XL[1],XL[2], YL[1],YL[2],stepsX,stepsY, location,false,
		drawScatter.CIRCLE,Color.blue,decX,decY,N);
		//ds is the scatterplot
		repaint();
	}



public void paint (Graphics g) {
	//System.out.println("Painting");
	//if (!dragging) ds.draw(g);
	if (ds !=null) {
		ds.draw(g);
		/*
		System.out.println(ds.getUpperLeft());
		System.out.println(ds.getLowerRight());
		Point p1 = ds.getUpperLeft();
		Point p2 = ds.getLowerRight();
		System.out.println(p1.x+ " " + p1.y + " " + p2.x +  " " + p2.y);
		g.drawLine(p1.x,p1.y,p2.x,p2.y);
		*/

	}
	else {
		Dimension d= getSize();
		g.drawRect(1,1,d.width-2,d.height-2);
		g.setColor(Color.blue);
		//g.drawString("Scatter Plot",5,15);
		for (int i=0;i<25;i++) {
			int X = (int) (Math.random() * (d.width-6));
			int Y = (int)(Math.random()*(d.height-6));
			g.drawRect(X,Y,4,4);
		}
	}

}
	public Point getUpperLeft() {
		if(ds != null)
			return ds.getUpperLeft();
		else
			return new Point(0,0);
	}
	public Point getLowerRight() {
		if(ds != null)
			return ds.getLowerRight();
		else
			return new Point(20,150);
	}
public void update(Graphics g) {
	Dimension dim = getSize();
	Image osi=createImage(dim.width,dim.height);
	Graphics osg=osi.getGraphics();
	osg.setColor(getBackground());
	osg.fillRect(0,0,dim.width,dim.height);
	osg.setColor(g.getColor());
	paint(osg);
	g.drawImage(osi,0,0,this);
}

	public void setColor(Color c) {
		if(ds != null) {
			ds.setColor(c);
			repaint();
		}
	}
	public void setRegLine(boolean doreg) {
		if(ds != null) {
			ds.setRegLine(doreg);
			repaint();
		}
	}

	public double getr() {
		if(ds!=null)
			return ds.getr();
		else return 0;
	}

	public double getSSE() {
		return ds.getSSE();
	}

	public void upDateStats() {
			if(ds != null) {
			ds.upDateStats();
		}
	}

	public boolean getRegLine() {
		if(ds!=null)
			return ds.getRegLine();
		else return false;

	}
	public int getN() {
		if(ds!=null)
			return ds.getN();
		else return 0;

	}
	public double getSdx() {
		if(ds!=null)
			return ds.getSdx();
		else return 0;

	}
}