package conf;

import java.awt.*;
import java.util.*;
import RVLS.*;
import java.applet.*;

public class ConfidePlot extends Canvas {
	ciFrame aa;

	int w,h,cumulM,outt1Mean,outt2Mean;
	double X,t1Proport,t2proport;
	final int M = 100; // number of samples
	double[] Xmint1 = new double[M];
	double[] Xmaxt1 = new double[M];
	double[] Xmint2 = new double[M];
	double[] Xmaxt2 = new double[M];

	double gMin=30; //Assumed to be the smallest possible value for X
	double gMax=70; //Assumed to be the largest possible value for X
	double t1 = 0; // t for 95% Confidence Interval
	double t2 = 0; // t for 95% Confidence Interval
	LT Lx;
	Color Xt1Color = Color.red;
	Color Xt2Color = Color.blue;

	Random rg = new Random();
	public void setBounds(int a, int b, int x, int y) {
		w = x;
		h=y; //do we need h??
		super.setBounds(a,b,x,y); //set Canvas size = ConfidePlot size
	}
	//public void setverMarg(int verMarg) {
		//this.verMarg = verMarg;
	//}

	public void setLx() {
		Lx = new LT(gMin,gMax,0,w);
		repaint();
	}
	public void setData(int N,double mean,double sd) {

		for (int i=0;i<M;i++) {
			double Xbar = 0;
			double s = 0;
			for (int ii=0;ii<N;ii++) {
				X = sd*rg.nextGaussian() + mean;
				Xbar+=X;
				s+=X*X;
			}
		s = Math.sqrt((s-Xbar*Xbar/N)/(N-1));
		Xbar/=N;
		switch(N) {
			case 10:
			t1 = 3.250;
			t2 = 2.262;
			break;
			case 15:
			t1 = 2.977;
			t2 = 2.145;
			break;
			case 20:
			t1 = 2.861;
			t2 = 2.093;
			break;
		}
		Xmint1[i] = Xbar - t1*s/Math.sqrt(N);
		Xmaxt1[i] = Xbar + t1*s/Math.sqrt(N);
		if (Xmint1[i]>mean)
			outt1Mean++;
		else {
			if (Xmaxt1[i]<mean)
			outt1Mean++;
		}

		Xmint2[i] = Xbar - t2*s/Math.sqrt(N);
		Xmaxt2[i] = Xbar + t2*s/Math.sqrt(N);
		if (Xmint2[i]>mean)
			outt2Mean++;
		else {
			if (Xmaxt2[i]<mean)
			outt2Mean++;
		}
		}

	cumulM += M;
	repaint();
}
	public void clearGraph() {
		for (int i=0;i<M;i++) {
		Xmint1[i] = 0.0;
		Xmaxt1[i] = 0.0;
		Xmint2[i] = 0.0;
		Xmaxt2[i] = 0.0;
		}
		repaint();
	}
	public void clearDisplay() {
		outt1Mean = 0;
		outt2Mean = 0;
		cumulM = 0;
		clearGraph();
	}

	public void paint(Graphics g) {
		g.setFont(new Font("Monospaced", Font.PLAIN, 12));
		Font f = g.getFont();
		FontMetrics fm = g.getFontMetrics(f);
		//int w30 = fm.stringWidth("30");
		int w50 = fm.stringWidth("50")/2;
		int w70 = fm.stringWidth("70");
		int verMarg = fm.getHeight();
		//int v50 = Lx.Itransform(50);
		int xMiddle = (int) Math.rint(.5*w);
		g.drawString("30",0,verMarg-3);
		g.drawString("50",xMiddle-w50,verMarg-3);
		g.drawString("70",w-w70,verMarg-3);

		for (int i=0;i<M;i++) {

			int Xminpix = Lx.Itransform(Xmint1[i]);
			int Xmaxpix = Lx.Itransform(Xmaxt1[i]);
			if ((Xmint1[i] > 50) || (Xmaxt1[i] < 50))
				g.setColor(Color.white);
			else
				g.setColor(Color.blue);
			g.drawLine(Xminpix,verMarg+4*i,Xmaxpix,verMarg+4*i);
			g.drawLine(Xminpix,verMarg+4*i+1,Xmaxpix,verMarg+4*i+1);//add joan

			Xminpix = Lx.Itransform(Xmint2[i]);
			Xmaxpix = Lx.Itransform(Xmaxt2[i]);
			if ((Xmint2[i] > 50) || (Xmaxt2[i] < 50))
				g.setColor(Color.red);
			else
				g.setColor(Color.orange);
			g.drawLine(Xminpix,verMarg+4*i,Xmaxpix,verMarg+4*i);
			g.drawLine(Xminpix,verMarg+4*i+1,Xmaxpix,verMarg+4*i+1);//add joan

			g.setColor(Color.black);
			g.drawLine(xMiddle,verMarg,xMiddle,verMarg+4*i);
			//g.drawLine(xMiddle,verMarg,xMiddle,verMarg+4*i);
			 //Draw vertical line thru pop mean
		}

		aa.textField1.setText((cumulM-outt1Mean) + "");
		aa.textField2.setText(outt1Mean + "");
		aa.textField3.setText(graphUtilities.format((double)(cumulM-outt1Mean)/
		                        (double)cumulM,3) + "");

		aa.textField4.setText((cumulM-outt2Mean) + "");
		aa.textField5.setText(outt2Mean + "");
		aa.textField6.setText(graphUtilities.format((double)(cumulM-outt2Mean)/
		                        (double)cumulM,3) + "");
	}
	public void setApp(ciFrame appl) {
		aa=appl;
	}

}