package desc;
import java.awt.*;

public class histNorm extends hist {
	/**
	 * If it sets up to fit normal distribution and total samples >2,
	 * it will draw normal distribution line
	 */
	public void paint(Graphics g) {
		super.paint(g);
		if (norm && (numSamples > 2)){
				fitNormal(g);
		}
	}

	/**
	 * Set up the normal distribution fitting switch
	 */
	public void setNorm(boolean norm) {
		this.norm = norm;
		repaint();
	}

	public boolean isNorm() {
		return norm;
	}

	/**
	 * This is private function. If normal distribution fitting is set up, it
	 * will automatically draw normal distribution line on histogram in the paint
	 * rountine.
	 */
	private void fitNormal(Graphics g) {
		int x1,height,npix,N;
		int maxHeight = rHeight+yoffset2;
		//Graphics g=getGraphics();
		float M,s,inc,Y;
		double temp,X,z,p;
		float[] R = new float[3];
		float step = xdata[1]-xdata[0];
		int done = (width+gap)*numInt;
		//N=0;
		height=0;
		R=MeanSd();
		npix=5;
		M=R[1];
		s=R[2];
		inc = step/width; // units/pixel
		inc = inc/= s;  //sd's per pixel

		z=step/2/s;	//sd's below mean of cutoff of middle bin
		p=(0.5-zprob(z))*2.0;
		/*
		p*=numSamples;	//total samples within the cutoff range
		temp =   Math.sqrt(1.0/(2.0*Math.PI));
		temp =temp *p/.3989;  //why .3989?
		*/

		temp = p*numSamples; //Normal point probability function p = exp(-sqr(x)/2); rescale the total samples covered, not necessary using density function


		X=(xdata[0] - step/2 - M)/s; //z score of first point

		 Y= (float) (temp* Math.exp(-X*X/2));  //convert to frequency number
		 //double Y2 = Math.sqrt(1/(2*Math.pi*s*s))*Math.exp(-((X
		 x1=xoffset + gap/2;

		int Lastheight = (int) Math.min((sv2p*Y+inter +yoffset2),maxHeight);


		if (s>0.0){
		for (int i = 0;i<done;i+=npix){
			X+= npix*inc; //number of standard x
			 Y= (float) (temp* Math.exp(-X*X/2));
			 height = (int) Math.min((sv2p*Y+inter +yoffset2),maxHeight); //convert frequency number to Y pixel
			 g.drawLine(x1,Lastheight,x1+npix,height);
			 x1+=npix;
			 Lastheight=height;
		}
		}
	}

	/**
	 * return normal distribution p(x>z) probability
	 */
	public	double zprob(double z)
	{
	 double b,s,a,tex1,HH,p;
	boolean flag;
	if (z<-7) {return 0.0;}
	if (z>7) {return 1.0;}


	if (z<0.0) {flag= true;}
		else
		{flag = false;}

	z = Math.abs(z);
	b=0.0;
	s=Math.sqrt(2)/3*z;
	HH=.5;
	for (int i=0;i<12;i++) {
		a = Math.exp(-HH*HH/9)*Math.sin(HH*s)/HH;
		b=b+a;
		HH=HH+1.0;
	}
	p= .5-b/Math.PI;
	if (flag) {p=1.0-p;}
		return p;
}

/**
 * This is a private method, return histogram data set's total sample size,
 * mean and standard deviation
 */
	float[] MeanSd(){
			//N returned in R[0], Mean in R[1], and sd in R[2]
			float[] R = new float[3];
			float s,ssq;
			int N=0;
			s=0;
			ssq=0;
				for (int i = 0;i<numInt;i++){
					N+=fdata[i];
					s+=xdata[i]*fdata[i];
					ssq+=xdata[i]*xdata[i]*fdata[i];
				}
			R[0] = (float) N;
			R[1] = s/R[0];
			R[2] = (float) Math.sqrt((ssq-s*s/R[0])/R[0]);
			return R;
		}
		protected boolean norm;
}