package desc;
import java.awt.*;

public class histStat extends histNorm {
	double sum=0,ssq=0;
	double s=0,sq=0,med=0,range=0,skew=0,MAD=0,kurt=0;
	modes mode;
	int N=0;

	public histStat() {
		super();
		xoffset = 120;
		computeStats();
		/*stats = new boolean[8];
		stats[0]=true;
		for (int i=1;i<8;i++){
			stats[i]=false;
		}
		*/

	}
	public double getMean() {
		return s;
	}
	public double getSd() {
		return sq;
	}
	public double getMedian() {
		return med;
	}
	public double getRange() {
		return range;
	}
	public double getSkew() {
		return skew;
	}
	public double getMad() {
		return MAD;
	}
	public modes getMode() {
		return mode;
	}

	/**
	 * Compare with initDataLoop in hist(), it adds calculating summation and
	 * the sum of the squares
	 */
	boolean initDataLoop(int nn, int [] data, float[] xxdata) {
		sum=0;
		ssq=0;
		boolean theSame=true;
		for (int i=0;i<nn;i++){
			fdata[i]=data[i];
			xdata[i] = xxdata[i];
			fmin = Math.min(fmin,fdata[i]);
			fmax =  Math.max(fmax,fdata[i]);
			sum+=xdata[i]*fdata[i];
			ssq+=xdata[i]*xdata[i]*fdata[i];
			numSamples+=fdata[i];
			if (fdata[i] != fdata[0]) {theSame=false;}
		}
		return theSame;
	}


	/**
	 * Compare with hist_MouseReleased in hist(), it adds calculating summation and
	 * the sum of the squares, and call computeStats() to recalculate all the statistics
	 */
	public void hist_MouseReleased(java.awt.event.MouseEvent event)
	{
		sum=0;
		ssq=0;
		numSamples=0;
		for (int i=0;i<numInt;i++) {
			sum+=xdata[i]*fdata[i];
			ssq+=xdata[i]*xdata[i]*fdata[i];
			numSamples+=fdata[i];
		}
		float theMean = (float) (sum/numSamples);
		computeStats();
		repaint();
	}

	/**
	 * Compare with setData(int[] data, int nn, boolean add) in hist(), it adds calculating summation and
	 * the sum of the squares, and call computeStats() to recalculate all the statistics
	 */
	public void setData(int[] data, int nn, boolean add, double _sum, double _ssq){
		 if (numInt != nn) newNumInt(nn);

		fmax=yintervals;
		int tmax=0;
		if (add) {
			sum+=_sum;
			ssq+=_ssq;
		}
		else {
			sum=_sum;
			ssq=_ssq;
		}

		for (int i=0;i<nn;i++){
			if (add){
				fdata[i]+=data[i];
			}
			else {
				fdata[i]=data[i];
			}
			if (fdata[i] > tmax){tmax=fdata[i];}
		}

		if (tmax>fmax) {
			fmax = Math.floor(tmax/yintervals)*yintervals+yintervals;
		}
		setSlopes();
		for (int i = 0;i<numInt;i++)
		{
			f[i] = (int) Math.round(sv2p*fdata[i]+iv2p);
		}
		computeStats();
		if (autoRepaint) repaint();
	}

	/**
	 * This paint will plot the statistics of the data on the histogram's upper left corner
	 * if showStat is set to be true
	 */
	public void paint(Graphics g) {
		super.paint(g);
		if (showStat) {
			plotStats(g);
		}
	}

	public void setStats(boolean stats) {
		showStat=stats;
		repaint();
	}

	public boolean isStats() {
		return showStat;
	}

	public void setAllStats(boolean[] s){
		for (int i=0;i< stats.length; i++) {
			stats[i]=s[i];
		}
		computeStats();
		repaint();
	}

	/**
	 * Compare with setFreq(int[] f) in hist(), it adds calculating summation and
	 * the sum of the squares, then call setData(_f,_f.length,false,sum,ssq);
	 */
	public void setFreq(int [] _f) {
		double s=0;
		double ssq=0;
		for (int i=0;i<_f.length;i++) {
			s+=xdata[i]* (double) _f[i];
			ssq+=xdata[i]*xdata[i]*(double) _f[i];
		}
		setData(_f,_f.length,false,s,ssq);
	}

	/**
	 * Computes eight statistics, 0:mean,1:median,2:sd,3:range,4:skewness,5:Mad,7:kurtosis,8:mode
	 */
	public void computeStats() {
		s=0;N=0;sq=0;
		for (int i = 0;i<numInt;i++){
			N+=fdata[i];
		}

			s=sum/numSamples;

		if (stats[1]) {
			if ((stats[0]) && (N <= 2)) {
				med=s;
			}
			else {
				med = ComputeGroupedMedian(fdata,numInt,N);
			}
		}

		if (stats[2]) {
			if (numSamples==1) {
				sq=0;
			}
			else {
				sq= Math.sqrt((ssq-sum*sum/numSamples)/numSamples);
			}
		}

		if (stats[3]) {
			range= ComputeGroupedRange(fdata,xdata,numInt);
		}

		if(stats[4]) {
			skew= ComputeSkew(fdata,xdata,numInt,s);
		}

		if (stats[5]) {
			MAD= ComputeMAD(fdata,xdata,numInt);
		}
		// 6 is variance, skip
		if(stats[7]) {
			kurt= ComputeKurt(fdata,xdata,numInt,s);
		}
		if(stats[8]) {
			mode = ComputeGroupedMode(fdata,xdata,numInt);

		}

	}

	/**
	 * Computes the proper positions to draw statistics, by calling procedure printStat
	 */
	public void plotStats(Graphics g){

		String tstring;
		int x,L,Y,x2,xmn,xsd,xmed;
		float xstep,pixstep;
		FontMetrics met;
		g.setFont(font);
		met=g.getFontMetrics(font);
		int maxA = met.getMaxAscent() + 4;



		xstep = xdata[1]-xdata[0];
		pixstep = (width+gap)/xstep;

		//s=Math.round(100*s);
		//s/=100;

		//sq = format(sq,2);
		//L=xoffset;
		L= 10;//joan change from 12 to 10
		int in=0;
		Y=rHeight+yoffset2;
		int Y1=Y+10;
		int Y2= Y1+8;
		//Y=rHeight+yoffset2;
		xmn = xoffset + (int) Math.round((s-xdata[0]+xstep/2.0)*pixstep);
		 if (drawYaxis) {
			String fstr = "" + numSamples;
			int LL =88 - met.stringWidth(fstr); //joan change from 80 to 88
			g.drawString("N=", 4,L);
			g.drawString(fstr,LL,L);
			L+=maxA;
		}
		if (numSamples > 0) {
			if (stats[in]){
				printStat(s,true,xstep, pixstep,L,in, Y1,Y2, "mean=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {


				int Yx;
				if ((int) Math.round((med+xstep/2.0)*pixstep) == (int) Math.round((s+xstep/2.0)*pixstep) && (stats[0])) {

					Yx=Y1+4;
				}
				else {
					Yx=Y1;
				}


				printStat(med,true,xstep, pixstep,L,in, Yx,Y2, "median=", g, met);
				L+= maxA;
			}
			in++;
			//if ((stats[in]) && (sq >.01)){
			if (stats[in]){
				boolean drawLine;
				drawLine = !stats[0];

				xsd = (int) Math.round(sq*pixstep);
				g.setColor(colors[in]);
				if (sq > 0) {

					g.drawLine(xmn-xsd,Y+10,xmn+xsd,Y+10);
					g.drawLine(xmn-xsd,Y,xmn-xsd,Y+10);
					g.drawLine(xmn+xsd,Y,xmn+xsd,Y+10);
				}
				else
				{
					drawLine = false;
				}
				printStat(sq,drawLine,xstep, pixstep,L,in, Y1,Y2, "sd=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				printStat(range,false,xstep, pixstep,L,in, Y1,Y2, "range=", g, met);
				L+= maxA;
			}
			in++;
			//if ((stats[in]) && (sq >.01)){
			if (stats[in]) {
				printStat(skew,false,xstep, pixstep,L,in, Y1,Y2, "skew=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
								printStat(MAD,false,xstep, pixstep,L,in, Y1,Y2, "MAD=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				double vv= sq*sq;
				printStat(vv,false,xstep, pixstep,L,in, Y1,Y2, "variance=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				printStat(kurt,false,xstep, pixstep,L,in, Y1,Y2, "kurtosis=", g, met);
				L+= maxA;
			}
			in++;

			if (stats[in]) {
				//if (mode.number == 1){
				int yx=Y1;
				int xx = (int) Math.round((mode.mode+xstep/2.0)*pixstep);
				if ( (xx == (int) Math.round((s+xstep/2.0)*pixstep) && (stats[0]))) yx=Y1+6;
				if ( (xx == (int) Math.round((med+xstep/2.0)*pixstep) && (stats[1]))) yx=Y1+6;
					printStat(mode.mode,true,xstep, pixstep,L,in, yx,Y2, "mode=", g, met);
				//}
				//
				L+= maxA;
			}

			g.setColor(Color.darkGray);
		}
	}

	/**
	 * draw the stat string information on the upper left corner, and also draw color
	 * lines on the histogram to identify these statistics' positions if drawline is
	 * set to true
	 */
	public void printStat(double stat,boolean drawLine, float xstep, float pixstep, int L, int in, int Y1, int Y2, String tstring, Graphics g, FontMetrics met) {
		String statStr, fstr;
		int x,LL;
		g.setColor(colors[in]);
		x=xoffset + (int) Math.round((stat-xdata[0]+xstep/2.0)*pixstep);
		if (in == 8) {
			if(mode.number ==1)
				fstr = format(stat,2);
			else if (mode.number == 2)
				fstr="bimodal";
			else
				fstr = "multi";

		}
		else
			fstr = format(stat,2);

		statStr = tstring + fstr;
		if (drawLine){
			//Dimension d = getSize();
			g.drawLine(x,Y1,x,Y2);
		}
		LL = 88 - met.stringWidth(fstr); //joan change from 80 to 88
		g.drawString(tstring, 4,L);

		g.drawString(fstr, LL,L);

	}

public double ComputeGroupedRange(int[] freq,float[] xdata, int k){
		double r;
		int min,max,count,in;
		min=0;
		max=0;
		count=0;
		in=-1;
			//for (int i=0;i<k;i++){
			//System.out.println(i + " " + freq[i]);
		//}
		while ((count==0) && (in<k-1)){
			in++;
			count=freq[in];
		}
		min=in;
		//System.out.println("min = " + min);

		count=freq[k-1];
		//System.out.println("initial count = " + count);
		in=k-1;
		while ((count <= 0) && (in>0)){
			in--;
			count=freq[in];
		}
		max=in;

		r = xdata[max]-xdata[min];
		return r;
}
	public double ComputeGroupedMean(int[] freq,float[] xdata, int k){
		double s;
		int N;
		s=0;N=0;
		for (int i = 0;i<k;i++){
			s+= xdata[i]*freq[i];
			N+=freq[i];
		}

		if (N>0) {
			s=s/N;
		}
		return s;
	}
	public modes ComputeGroupedMode(int[] freq,float[] xdata, int k){
		double mode = xdata[0];
		int maxFreq=freq[0];
		boolean [] modeF = new boolean[k];
		setFalse(modeF);
		int nModes=1;
		modeF[0]=true;

		for(int i=1;i<k;i++) {
			if(freq[i] == maxFreq){
				nModes++;
				modeF[i]=true;
			}
			else if (freq[i] > maxFreq) {
				setFalse(modeF);
				nModes=1;
				modeF[i]=true;
				maxFreq=freq[i];
				mode=xdata[i];
			}
		}
		return new modes(mode,nModes,modeF);
	}


		void setFalse(boolean [] modeF) {
			for (int i=0;i<modeF.length;i++) {
				modeF[i]=false;
			}
		}

	public double ComputeGroupedsd(int[] freq,float[] xdata, int k){
		double s,sq;
		int N;
		s=0;sq=0;N=0;
		for (int i = 0;i<k;i++){
			s+= xdata[i]*freq[i];
			sq+=xdata[i]*xdata[i]*freq[i];
			N+=freq[i];
		}
		//System.out.println("s = " + s + " sq= " + sq);
		sq = Math.sqrt((sq-s*s/N)/N);
		return sq;
	}
		public double ComputeSkew(int[] freq,float[] xdata, int k, double m){
		double s,sq;
		int N;
		double sd = ComputeGroupedsd(freq,xdata,k);
		sq=0;N=0;
		for (int i = 0;i<k;i++){
			//s+= xdata[i]*freq[i];
			sq+=Math.pow((xdata[i]-m),3)*freq[i];
			N+=freq[i];
		}
		if ( (sd==0) || (N<2)) {
			 sq = 0;
		}
		else {
			sq = (sq/N)/Math.pow(sd,3);
		}
		return sq;
	}
		public double ComputeKurt(int[] freq,float[] xdata, int k, double m){
		double s,sq;
		int N;
		double sd = ComputeGroupedsd(freq,xdata,k);
		sq=0;N=0;
		for (int i = 0;i<k;i++){
			//s+= xdata[i]*freq[i];
			sq+=Math.pow((xdata[i]-m),4)*freq[i];
			N+=freq[i];
		}
		if ( (sd==0) || (N<2)) {
			 sq = 0;
		}
		else {
			sq = (sq/N)/Math.pow(sd,4)-3;
		}

		return sq;
	}
	public double ComputeMAD(int[] freq,float[] xdata, int k){
		double MAD,m;
		int N=0;
		m=0;
		MAD=0;
		for (int i = 0;i<k;i++){
			N+=freq[i];
			m+=xdata[i]*freq[i];
		}
		m/=N;
		for (int i = 0;i<k;i++){
			//s+= xdata[i]*freq[i];
			MAD+=Math.abs(xdata[i]-m)*freq[i];

		}

		MAD/=N;
		return MAD;
	}
public double ComputeGroupedMedian(int[] fd,int k,int N){

		double med=0;
		boolean even;
		int nc, h,j,jj;
		nc=0;
		h=N/2;


		if (h * 2 == N) {
		//System.out.println("even " + N);
			even = true;

		}
		else {
			//System.out.println("odd " + N);
			even = false;
			h++;
		}

		nc=0;
		j=0;

		for (int i = 0; i<k;i++){
			nc+=fd[i];
			if (nc >= h) {
				j=i;
				break;
			}
		}
	if (even){

		if (nc==h) {
			jj=j+1;
			for (int i= jj;i<k;i++){
				if (fd[i] != 0) {
					jj=i;
					break;
				}
			}
			med = (double) (xdata[j] +xdata[jj])/2;
		}
		else {
			med = xdata[j];
		}
	}
	else {
		med = xdata[j];
	}


		return med;

}
	protected boolean[] stats = {true,true,true,false,false,false,false,false,false};
	protected boolean showStat=true;
	protected	Color[]  colors = {Color.blue,Color.magenta,Color.red,Color.orange,Color.black,
		Color.cyan, Color.darkGray, Color.lightGray, Color.green};

}

/**
 * private class, keep the # of the modes and the modes values in this class
 */
class modes {
	public double mode;
	public boolean [] which;
	public int number;
	public modes(double mode, int number, boolean [] which) {
		this.mode=mode;
		this.number=number;
		this.which=which;
	}
	public String toString() {
		return "Mode = " + mode + " number = " + number;
	}

}