package hist;

import java.awt.Color;
import java.awt.*;
import RVLS.*;
/**
 * hist is a class of histograms
 *
 * @author		David Lane
 * @version		1.1
 */

 /**
  * class constructor
  * xxdata: observations on x axis
  * data: frequency to the observations
  * yintervals: # of observations for each Y interval
  * clickable: set to true if user can draw the histgram
  * gaps: the gap space between bars
  */
public class hist extends Canvas
{
        public	boolean frame=true;
        protected int gap;
        protected boolean clickable,drawYaxis=true;

        protected String title;
        protected int numSamples;
        protected double fmax;
        protected java.awt.Color color;
        public int[] f;
        int yinc;
        //int lastHeight = -1;
        final int yoffset = 30; //at the bottom
        public final int yoffset2=16; // at the top
        public int xoffset = 25, offset2=0, rightMargin = 10;
        int[] fdata;
        int[] mRect;
        int yintervals,xaxisDec=0;
        int rWidth,theBin;
        public int width,numInt,rHeight, inter;
        public double fmin,sp2v,sv2p,ip2v,iv2p;
        //double sum,ssq;
        float[] xdata;
        boolean top,labelXaxis,endsOnly,autoRepaint=true;

        Font font,fontN;
        Label testlabel;
        public hist()
        {
                int nn=5;
                float [] xxdata = {1,2,3,4,5};
                int [] data = {1,2,3,2,1};
                String _title = "";
                int _yintervals=5;
                boolean yticks=true;
                endsOnly = false;
                int _rWidth= 200;
                int _rHeight=100;
                boolean _clickable=false;
                boolean _labelXaxis=true;
                int _gap=0;
                color=Color.black;
                initialize(_title,xxdata,data,nn,yticks,_rWidth,_rHeight,_yintervals,_clickable,_labelXaxis,_gap);

                //{{REGISTER_LISTENERS
                /*SymMouseMotion aSymMouseMotion = new SymMouseMotion();
                this.addMouseMotionListener(aSymMouseMotion);
                SymMouse aSymMouse = new SymMouse();
                this.addMouseListener(aSymMouse);*/
                //}}
        }
        public void setClickable(boolean clickable) {

                this.clickable = clickable;
        }
        public boolean isClickable() {
                return clickable;
        }
        public void setGap(int gap) {
                //number of pixels between bars
                this.gap = gap;
                if (autoRepaint) repaint();
        }

        /**
         * get gap between bars
         */
        public int getGap() {
                return gap;
        }
        public void setEndsOnly (boolean endsOnly) {
                this.endsOnly=endsOnly;
        }

        public boolean getEndsOnly() {
                return endsOnly;
        }
        public void setXaxisDec (int xaxisDec) {
                this.xaxisDec = xaxisDec;
        }

        public int getXaxisDec() {
                return xaxisDec;
        }
        public void setTitle(String title) {
                this.title = title;
                if (autoRepaint) repaint();
        }

        public String getTitle() {
                return title;
        }

        public void setNumSamples(int numSamples) {
                this.numSamples = numSamples;
        }

        public int getNumSamples() {
                return numSamples;
        }

        public void setColor(java.awt.Color color) {
                this.color = color;
        }

        public java.awt.Color getColor() {
                return color;
        }
        public void setAutoRepaint(boolean autoRepaint) {

                this.autoRepaint = autoRepaint;
        }

        public boolean getAutoRepaint() {
                return autoRepaint;
        }

        public boolean getDrawYaxis() {
                return drawYaxis;
        }
        /**
         * when set true, it will draw Y axis
         */
        public void setDrawYaxis(boolean drawYaxis) {
                this.drawYaxis = drawYaxis;
        }


        public void setFrame(boolean frame) {
                this.frame=frame;
        }
        public boolean getFrame() {
                return frame;
        }
        public void setFreq(int [] _f) {
                setData(_f,_f.length,false);
        }
        public int [] getFreq() {
                return fdata;
        }
        public void setFmax(double fmax) {
                this.fmax = fmax;
                yintervals = (int) fmax;
                setSlopes();
                if (autoRepaint) repaint();
        }
        public void clear (){
                for (int i=0;i<numInt;i++){
                        fdata[i]=0;
                }
                setData(fdata,numInt,false);
                numSamples=0;
        }
        public void setFmaxClear(int Fmax)
        {
                for (int i=0;i<numInt;i++)
                {
                        fdata[i]=0;
                }
                for (int i = 0;i<numInt;i++)
                {
                        f[i] = (int) Math.round(sv2p*fdata[i]+iv2p);
                }
                fmax = Fmax;
                fmin = 0;
                setSlopes();
                repaint();
        }
        public double getFmax() {
                return fmax;
        }
        public void setData(float[] _xdata) {
                setMidPoints(_xdata);
        }

        public void setData(int[] data, int nn, boolean add)
        {
         if (numInt != nn) newNumInt(nn);

                fmax=yintervals;
                int tmax=0;
                for (int i=0;i<nn;i++){
                        if (add){
                                fdata[i]+=data[i];
                        }
                        else {
                                fdata[i]=data[i];
                        }
                        if (fdata[i] > tmax){tmax=fdata[i];}
                }

                if (tmax>fmax) {
                        fmax = Math.floor(tmax/yintervals)*yintervals+yintervals;

                }
                setSlopes();
                for (int i = 0;i<numInt;i++)
                {
                        f[i] = (int) Math.round(sv2p*fdata[i]+iv2p);
                }
                if (autoRepaint) repaint();
        }

        public void setMidPoints(float[] _xdata){
                int nn = _xdata.length;
                if (numInt != nn) newNumInt(nn);
                //xdata = new float[numInt];
                for (int i=0;i<numInt;i++){
                        xdata[i]=_xdata[i];
                }
                if (autoRepaint) repaint();
        }


        public void setFreqAndMidPoints(int [] _f, float [] _xdata) {
                        boolean b = autoRepaint;
                        autoRepaint=false;
                        setMidPoints(_xdata);
                        setFreq(_f);

                        autoRepaint=b;
                        repaint();

        }
        void newNumInt(int nn) {
                        numInt=nn;
                        fdata = new int[nn];
                         f = new int[nn];
                         xdata = new float[nn];
                         numInt = nn;
                         Dimension d = getSize();

                         rHeight = d.height - yoffset2 -yoffset; //height of histogram itself
                        width = (d.width -xoffset + offset2-rightMargin)/numInt;
                        setSlopes();
        }
        void initialize(String _title,float[] xxdata,int[] data,int nn, boolean yticks,int _rWidth, int _rHeight, int _yintervals, boolean _clickable, boolean _labelXaxis,int _gap) {

                font = new Font("TimesRoman",Font.PLAIN,12);
                fontN = new Font("TimesRoman",Font.PLAIN,9);
                title=_title;
                labelXaxis=_labelXaxis;
                xaxisDec=0;
                clickable=_clickable;
                yintervals = _yintervals;

                numSamples=0;


                top= yticks;
                gap=_gap;
                numInt = nn;
                f = new int[nn];
                mRect = new int[4];
                mRect[0]=0;mRect[1]=0;mRect[2]=width;mRect[3]=0;



                fdata = new int[nn];
                xdata = new float[nn];
                fmin=0;
                fmax=0;
                boolean theSame=initDataLoop(nn,data,xxdata);


                if (fmax == 0){
                        fmax = yintervals;
                }
                else if (theSame) {
                        fmax+=5;
                }

                if (fmax < yintervals){
                        fmax=yintervals;
                }
                //fmax is the highest tick mark

                rWidth=_rWidth;
                width = (rWidth-xoffset + offset2-rightMargin)/numInt;
                rHeight = _rHeight - yoffset2 -yoffset; //height of histogram itself

                setSlopes();
        }

        boolean initDataLoop(int nn, int [] data, float[] xxdata) {

                boolean theSame=true;
                for (int i=0;i<nn;i++){
                        fdata[i]=data[i];
                        xdata[i] = xxdata[i];
                        fmin = Math.min(fmin,fdata[i]);
                        fmax =  Math.max(fmax,fdata[i]);
                        numSamples+=fdata[i];
                        if (fdata[i] != fdata[0]) {theSame=false;}
                }
                return theSame;
        }
        public  void setBounds (int x, int y, int w, int h) {
                super.setBounds(x,y,w,h);
                rHeight = h - yoffset2 -yoffset; //height of histogram itself
                width = (w -xoffset + offset2-rightMargin)/numInt;
                setSlopes();

        }
        void setSlopes() {

                sp2v = (fmax-fmin)/(0-rHeight);
                ip2v = (fmax+fmin)/2 - sp2v * (0+rHeight)/2;
                sv2p = 1/sp2v;    //slope
                iv2p = (0+rHeight)/2 - sv2p * (fmax+fmin)/2; //intercept
                //if (Math.abs(sv2p)>.5){
                        //sv2p = Math.round(sv2p);
                //}

                yinc = (int) Math.round(sv2p);

                yinc = -yinc;
                inter = (int) Math.round(iv2p)+1;
                numSamples=0;
                for (int i = 0;i<numInt;i++)
                {
                        numSamples+=fdata[i];
                        f[i] = (int) (sv2p*fdata[i]+inter) ;
                }
        }


        /**
         * Draws frame around histogram.
         *
         * @param frame		draws frame if true
         */
        public void paint(Graphics g)
        {
                //message m = new message("in paint g="+g);
                //m.show();
                g.setFont(font);
                int x1,xadd;
                x1=xoffset + offset2 + gap/2;
                xadd = width+gap;

                g.setColor(Color.black);
                g.drawString(title,xoffset+4,yoffset2-4);
                g.setColor(color);
                for (int i=0;i<numInt;i++)
                {
                        g.fillRect(x1,f[i]+yoffset2 ,width, rHeight-f[i]);
                        x1+=xadd;
                }
                //message m = new message("x1="+x1+", f[4]+yoffset2="+(f[4]+yoffset2)+", width="+width+", rHeight-f[4]="+(rHeight-f[4]));
                //m.show();
                drawAxes(g);




                if(frame)
                g.drawRect(0,0,getBounds().width-1,getBounds().height-1);
        }

        public void drawAxes(Graphics g){
                int h;
                g.setColor(Color.black);
                FontMetrics met,metN;
                g.setFont(font);
                met=g.getFontMetrics(font);
                metN=g.getFontMetrics(fontN);
                h = met.getAscent();
                h/=2;
                String yLabel;
                int x1 = xoffset-gap/2;
                int x2 = x1-4;
                int xa, SL,topline;
                g.drawLine(x1-1,rHeight+yoffset2,x1-1,yoffset2-5);
                if (drawYaxis) {

                        int iadd = (int) Math.round(fmax/yintervals);
                        double fadd = fmax/yintervals;
                        topline = yintervals*iadd;
                        int y=rHeight+yoffset2;
                        int tickDiff = (int) Math.rint(sv2p*fadd);
                        boolean doAll=true;

                        if(Math.abs(tickDiff)-4 > met.getMaxAscent()) doAll = true;
                        else doAll = false;
                        if (top == true) {
                                for (int i=0;i<=yintervals; i++){
                                        y= (int) Math.round(i*sv2p*fadd +rHeight+yoffset2);
                                        g.setColor(Color.lightGray);
                                        g.drawLine(x1-2,y,x2,y);
                                        g.setColor(Color.black);
                                        yLabel = i * iadd +" ";
                                        if(doAll || (i%2==0)) {
                                                SL = met.stringWidth(yLabel) + 3;
                                                g.drawString(yLabel, x1-SL,y+h);
                                        }

                                }
                        }
                }

                xa=xoffset+offset2 +gap/2;
                //xa=xoffset;
                int xinc = width+gap;
                xa-=xinc;
                int xx = rHeight+yoffset2+4;
                int xx2=xx+6;
                g.setFont(fontN);
                int lastXpixel=0;
                for (int i=0;i<numInt;i++){
                        xa+=xinc;

                        //if (labelXaxis || (endsOnly && (i==0 || i== numInt-1))) {
                        if (labelXaxis && (!endsOnly || (i==0 || i== numInt-1))) {

                                //String num = Float.toString(xdata[i]);
                                double xd = (double) xdata[i];
                                String num = format(xd,xaxisDec);
                                SL = metN.stringWidth(num);
                                int adj = (xinc-SL)/2+1;
                                if(xa+adj -3 > lastXpixel) {
                                        g.drawString(num, xa+adj,xx2);
                                        lastXpixel = xa+adj+SL;
                                }
                        }
                        g.setColor(Color.lightGray);
                        g.drawLine(xa,rHeight+yoffset2,xa,xx);
                        g.setColor(Color.black);
                }
                xa+=xinc;
                g.setColor(Color.lightGray);
                g.drawLine(xa,rHeight+yoffset2,xa,xx);
                g.setColor(Color.black);
                g.drawLine(x1-1,rHeight+yoffset2,xa,rHeight+yoffset2);
        }

        public static String format( double X, int nd){
                //double R;
                String sign;
                if(X<0) sign="-"; else sign="";

                int RR;
                String Rstr;
                int off;
                if (nd==0)
                {
                        RR = (int) Math.rint(X);
                        Rstr = RR+"";
                }
                else
                {
                        double xx=Math.pow(10,nd);
                        RR = (int) Math.rint(xx*Math.abs(X));
                        if (RR==0)
                        {
                                Rstr="0.";
                                for (int i=0;i<nd;i++) Rstr+="0";
                        }
                        else
                        {
                                Rstr = RR+"";

                                int L = Rstr.length();
                                if (L<nd)
                                {
                                        Rstr=".";
                                        for (int i=0;i<nd-L;i++) Rstr+="0";
                                        Rstr+=RR;
                                }
                                else
                                {
                                        String sa = Rstr.substring(0,L-nd);
                                        String sb = Rstr.substring(L-nd);
                                        Rstr = sa + "." + sb;
                                }
                        }
                }
                if (Rstr.indexOf(".") ==0) Rstr="0"+Rstr;
                Rstr = sign+Rstr;
                return Rstr;
        }

        public void changeDist (int x, int y){
                Graphics g;

                        int theBin,ff;
                        int xadd = width+gap;
                        g=getGraphics();
                        //message m = new message("changeDist getGraphics()="+getGraphics());
                        //m.show();
                        g.setColor(color);
                        //g.setColor(Color.yellow);
                        theBin = (x-xoffset + offset2-gap/2)/width;
                        if ((theBin >=0)  && (theBin <numInt)){
                                y=Math.max(y,yoffset2);
                                //f[theBin]=y-yoffset2;
                                ff=y-yoffset2+5;
                        //	fdata[theBin] = Math.max(0,(int) Math.round(sp2v*ff+ip2v));
                                fdata[theBin] = Math.max(0,(int) Math.ceil(sp2v*ff+ip2v));
                                f[theBin]=(int) (fdata[theBin] * sv2p + inter);
                                int x1= xoffset + offset2+gap/2+theBin*xadd;

                                g.fillRect( x1,f[theBin]+yoffset2,width,rHeight-f[theBin]);
                                g.clearRect(x1,yoffset2,width,Math.min(f[theBin],rHeight));
                        }
        }
        public int PrepAdd (double s){
                float step = xdata[1]-xdata[0];
                float x0 = xdata[0] - step/2;
                int x1,y;
                theBin = (int) Math.floor((s-x0)/step);
                x1 = xoffset + offset2 +theBin*width + gap/2;
                mRect[0]=x1;
                mRect[2]=width;
                mRect[3] = yinc;
                mRect[1]= yoffset2-mRect[3];
                int b = f[theBin]-yinc;
                return b;
        }
        public void AdRect(int inc, Graphics g){

                g.clearRect(mRect[0],mRect[1],mRect[2],mRect[3]);
                mRect[1]+=inc;
                g.fillRect(mRect[0],mRect[1],mRect[2],mRect[3]);
        }
        /*public int getWidth() {
                return width;
        }
        public void setWidth(int width) {
                this.width = width;
                setSlopes();
        }	*/
        /*class SymMouseMotion extends java.awt.event.MouseMotionAdapter
        {
                public void mouseDragged(java.awt.event.MouseEvent event)
                {
                        Object object = event.getSource();
                        if (object == hist.this)
                                hist_MouseDragged(event);
                }
        }

        void hist_MouseDragged(java.awt.event.MouseEvent event)
        {
                if (clickable)
                        changeDist(event.getX(),event.getY());
        }

        class SymMouse extends java.awt.event.MouseAdapter
        {
                public void mouseReleased(java.awt.event.MouseEvent event)
                {
                        Object object = event.getSource();
                        if (object == hist.this)
                                hist_MouseReleased(event);
                }

                public void mousePressed(java.awt.event.MouseEvent event)
                {
                        Object object = event.getSource();
                        if (object == hist.this)
                                hist_MousePressed(event);
                }
        }

        void hist_MousePressed(java.awt.event.MouseEvent event)
        {
                if (clickable)
                        changeDist(event.getX(),event.getY());
        }

        void hist_MouseReleased(java.awt.event.MouseEvent event)
        {
                if (clickable)
                {
                        numSamples=0;
                        for (int i=0;i<numInt;i++) {
                                numSamples+=fdata[i];
                        }
                        repaint();
                }
        }*/
        public void update(Graphics g) {
                Dimension dim = getSize();
                Image osi=createImage(dim.width,dim.height);
                Graphics osg=osi.getGraphics();
                osg.setColor(getBackground());
                osg.fillRect(0,0,dim.width,dim.height);
                osg.setColor(g.getColor());
                paint(osg);
                g.drawImage(osi,0,0,this);
        }
        /*public void setWidth(int width) {
                this.width = width;
                setSlopes();
	}
        public int getWidth() {
                return width;
	}*/
        public void setRightMargin(int rightMargin) {
                this.rightMargin = rightMargin;
                Rectangle r = getBounds();
                width = (r.width -xoffset + offset2-rightMargin)/numInt;
                setSlopes();
	}
}
