package regtomean;

import RVLS.*;
import java.awt.*;
import java.applet.*;

public class regMeanScatter extends scatter {
	boolean inRect1,inRect2,first=true;
	int currxcoor,lastxcoor1,xadj1,lastxcoor2,xadj2,top,height,j;
	int lastycoor1, lastycoor2, width, edge, yadj1, yadj2, currycoor;
	final int BARWIDTH=3;
	double LowerLim,UpperLim;
	Color [] yStats =new Color [1000];
	int i=0;

	Color ltBlue = new Color(3708415);
	Color cyan = new Color(6947071);
	Color magenta2 = new Color(-3536129);
	Color orange = new Color(16747778);

	scatter scatter1;
	rangeFrame range=null;

	/**
	 *class constructor, calls super class constructor.
	 */
	public regMeanScatter() {
		super();

		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
		//}}
	}
	public void setScatter(scatter _scatter1) {
		scatter1=_scatter1;
	}

	/**
	 *Set up the owner of this rrscatter, to send notify messages.
	 */
	public void setApplet(rangeFrame range) {
		this.range= range; //casting to type Range
	}

	/**
	 *Set up first for regMeanScatter. If first=true, cut off test score set to 0
	 */
	public void setData(double [] X, double [] Y, int N) {
		first=true;
		super.setData(X,Y,N);
	}

	/**
	 * Before it calls super setData, it calculates all the statistics first.
	 */
	public void setData(double [] X, double [] Y, double minX, double maxX, double minY, double maxY, int N) {
		first=true;
		cal_Color(X, Y, N);
		super.setData(X,Y,minX, maxX, minY, maxY, N);
	}

	/**
	 *Calculate all the statistics, lucky vs. unlucky; selected vs. unselected, etc.
	 */
	public void cal_Color(double[] XX, double[] YY, int N)
	{
		int upper_error=0, lower_error=0;
		double meanT=0, meanA=0, magentaT=0, magentaA=0, magenta2T=0, magenta2A=0, dkblueT=0, dkblueA=0, ltblueT=0, ltblueA=0, greenT=0, greenA=0;
		double redT=0, redA=0, orangeT=0, orangeA=0, darkgrayT=0, darkgrayA=0, cyanT=0, cyanA=0, unselectA=0, unselectT=0;
		int meanCount=0, magentaCount=0, magenta2Count=0, dkblueCount=0, ltblueCount=0, greenCount=0, redCount=0, orangeCount=0, cyanCount=0, darkgrayCount=0, unselectCount=0;

		boolean upper=false, lower=false;
		//yStats = new Color[N];

		Point p1 = getUpperLeft();
		Point p2 = getLowerRight();

		if (first==true) UpperLim=0.0;
		else UpperLim=Math.rint(Ly.transformToValue(lastycoor1+BARWIDTH-2));

		for (int i = 0; i<N; i++) {
			meanT += XX[i];
			meanA += YY[i];
			meanCount++;

			if (YY[i]>=UpperLim) {// UpperLim is the required minimum test score to be selected upon
				darkgrayT += XX[i];// darkgray is color for all selected
				darkgrayA += YY[i];
				darkgrayCount++;
				upper_error += YY[i]-XX[i];
				upper=true;
				if ( YY[i] < XX[i] )	{
					yStats[i] = Color.green;//green is for unlucky but selected people
					greenT += XX[i];
					greenA += YY[i];
					greenCount++;
				}
				else if (YY[i] == XX[i] )	{
					yStats[i] = Color.magenta; //magenta is for select people with test score = true score
					magentaT += XX[i];
					magentaA += YY[i];
					magentaCount++;
				}
				else if (XX[i] < UpperLim) {

					yStats[i] = ltBlue;//light blue is for lucky selected people with true score < required score, they should not pass the test but they did
					ltblueT += XX[i];
					ltblueA += YY[i];
					ltblueCount++;
				}
				else 	{

					yStats[i] = Color.blue;//blue is for lucky selected people with true score >= required score
					dkblueT += XX[i];
					dkblueA += YY[i];
					dkblueCount++;
				}
			}


			else {
				unselectT += XX[i];//in this else section, all the statistics are for unselected people
				unselectA += YY[i];
				unselectCount++;

				if ( YY[i] > XX[i] )	{

					yStats[i] = cyan;//cyan is for lucky but still unselected people
					cyanT += XX[i];
					cyanA += YY[i];
					cyanCount++;
				}
				else if (YY[i] == XX[i]) {

					yStats[i] = magenta2;//magenta is for unselected people with true score=required score
					magenta2T += XX[i];
					magenta2A += YY[i];
					magenta2Count++;
				}
				else if (XX[i] < UpperLim) {

					yStats[i] = orange;//orange is for unlucky and unselected people with ture score < required score
					orangeT += XX[i];
					orangeA += YY[i];
					orangeCount++;
				}
				else	{

					yStats[i] = Color.red;//red is for unlucky and unselected people with true score >= required score, they should pass test but they didn't
					redT += XX[i];
					redA += YY[i];
					redCount++;
				}
			}
		}

		//write all the statistics results to the owner applet
		if (darkgrayCount == 0)
		{
			range.result1.label32.setText("0");
			range.result1.label29.setText("0");
			range.result1.label30.setText("0");
		}
		else
		{
			darkgrayT /= darkgrayCount;
			darkgrayA /= darkgrayCount;
			range.result1.label32.setText(Integer.toString(darkgrayCount));
			range.result1.label29.setText(graphUtilities.format(darkgrayT,1));
			range.result1.label30.setText(graphUtilities.format(darkgrayA,1));
		}

		if (magentaCount ==0)
		{
			range.result1.label3.setText("0");
			range.result1.label6.setText("0");
			range.result1.label11.setText("0");
		}
		else
		{
			magentaT /= magentaCount;
			magentaA /= magentaCount;
			range.result1.label3.setText(Integer.toString(magentaCount));
			range.result1.label6.setText(graphUtilities.format(magentaT,1));
			range.result1.label11.setText(graphUtilities.format(magentaA,1));
		}

		if (dkblueCount ==0)
		{
			range.result1.label16.setText("0");
			range.result1.label14.setText("0");
			range.result1.label15.setText("0");
		}
		else
		{
			dkblueT /= dkblueCount;
			dkblueA /= dkblueCount;
			range.result1.label16.setText(Integer.toString(dkblueCount));
			range.result1.label14.setText(graphUtilities.format(dkblueT,1));
			range.result1.label15.setText(graphUtilities.format(dkblueA,1));
		}

		if (ltblueCount == 0)
		{
			range.result1.label13.setText("0");
			range.result1.label20.setText("0");
			range.result1.label21.setText("0");
		}
		else
		{
			ltblueT /= ltblueCount;
			ltblueA /= ltblueCount;
			range.result1.label13.setText(Integer.toString(ltblueCount));
			range.result1.label20.setText(graphUtilities.format(ltblueT,1));
			range.result1.label21.setText(graphUtilities.format(ltblueA,1));
		}

		if (greenCount == 0)
		{
			range.result1.label27.setText("0");
			range.result1.label24.setText("0");
			range.result1.label25.setText("0");
		}
		else
		{
			greenT /= greenCount;
			greenA /= greenCount;
			range.result1.label27.setText(Integer.toString(greenCount));
			range.result1.label24.setText(graphUtilities.format(greenT,1));
			range.result1.label25.setText(graphUtilities.format(greenA,1));
		}

		if (redCount == 0)
		{
			range.result1.label36.setText("0");
			range.result1.label34.setText("0");
			range.result1.label35.setText("0");
		}
		else
		{
			redT /= redCount;
			redA /= redCount;
			range.result1.label36.setText(Integer.toString(redCount));
			range.result1.label34.setText(graphUtilities.format(redT,1));
			range.result1.label35.setText(graphUtilities.format(redA,1));
		}

		if (cyanCount == 0)
		{
			range.result1.label41.setText("0");
			range.result1.label38.setText("0");
			range.result1.label39.setText("0");
		}
		else
		{
			cyanT /= cyanCount;
			cyanA /= cyanCount;
			range.result1.label41.setText(Integer.toString(cyanCount));
			range.result1.label38.setText(graphUtilities.format(cyanT,1));
			range.result1.label39.setText(graphUtilities.format(cyanA,1));
		}

		if (meanCount == 0)
		{
			range.result1.label42.setText("0");
			range.result1.label43.setText("0");
			range.result1.label44.setText("0");
		}
		else
		{
			meanT /= meanCount;
			meanA /= meanCount;
			range.result1.label42.setText(Integer.toString(meanCount));
			range.result1.label43.setText(graphUtilities.format(meanT,1));
			range.result1.label44.setText(graphUtilities.format(meanA,1));
		}

		if (unselectCount == 0)
		{
			range.result1.label18.setText("0");
			range.result1.label19.setText("0");
			range.result1.label45.setText("0");
		}
		else
		{
			unselectT /= unselectCount;
			unselectA /= unselectCount;
			range.result1.label18.setText(Integer.toString(unselectCount));
			range.result1.label19.setText(graphUtilities.format(unselectT,1));
			range.result1.label45.setText(graphUtilities.format(unselectA,1));
		}

		if (orangeCount == 0)
		{
			range.result1.label48.setText("0");
			range.result1.label49.setText("0");
			range.result1.label50.setText("0");
		}
		else
		{
			orangeT /= orangeCount;
			orangeA /= orangeCount;
			range.result1.label48.setText(Integer.toString(orangeCount));
			range.result1.label49.setText(graphUtilities.format(orangeT,1));
			range.result1.label50.setText(graphUtilities.format(orangeA,1));
		}

		if (magenta2Count == 0)
		{
			range.result1.label52.setText("0");
			range.result1.label53.setText("0");
			range.result1.label54.setText("0");
		}
		else
		{
			magenta2T /= magenta2Count;
			magenta2A /= magenta2Count;
			range.result1.label52.setText(Integer.toString(magenta2Count));
			range.result1.label53.setText(graphUtilities.format(magenta2T,1));
			range.result1.label54.setText(graphUtilities.format(magenta2A,1));
		}

		if ( ((dkblueCount == 0) & (ltblueCount == 0)) | (darkgrayCount == 0) )
		{
			range.result1.label64.setText("0%");
		}
		else
		{
			range.result1.label64.setText(graphUtilities.format(100.0*(dkblueCount+ltblueCount)/darkgrayCount,1)+"%");
		}
	}



	public void drawPoints(Graphics g) {

			for (int i=0; i<N; i++)
			{
				g.setColor(yStats[i]);
				g.fillOval(X[i]-2,Y[i]-2,4,4);
			}

	}

	/**
	 * paint draws the diagnal line on the regression chart, according to mouse releasd position draw the selected bar position,
	 * display the required minimum test score on applet. If it is the first time painting, the minimum required score will be
	 * displayed as 0, and the bar will be on X axis.
	 */
	public void paint(Graphics g){

		double m, b;
		int vy1, vy2;

		Point p1 = getUpperLeft();
		Point p2 = getLowerRight();

		if (first) {

			edge = p1.x;
			lastycoor1 = p2.y+1;
			lastycoor2 = p2.y+1;
			width = p2.x - p1.x +1;
			first = false;
		}

		super.paint(g);

		g.fillRect(edge,lastycoor1,width,BARWIDTH);

		m = 100/(Ly.transformToValue(100)-Ly.transformToValue(0));
		b = 100-m*Ly.transformToValue(100);

		vy1 = (int)(m*Lx.transformToValue(p1.x)+b);
		vy2 = (int)(m*Lx.transformToValue(p2.x)+b);

		g.clipRect(p1.x,p1.y,p2.x-p1.x,p2.y-p1.y);
		g.drawLine(p1.x,vy1,p2.x,vy2);
		if (Ly.transformToValue(lastycoor1+BARWIDTH-2) > 0.0)
		range.label7.setText(graphUtilities.format(Math.rint(Ly.transformToValue(lastycoor1+BARWIDTH-2)),0)+"");
		else
		range.label7.setText(graphUtilities.format(0.0,0)+"");
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == regMeanScatter.this)
				regMeanScatter_MouseReleased(event);

		}

		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == regMeanScatter.this)
				regMeanScatter_MousePressed(event);
		}
	}

	/**
	 * If mouse pressed within the rrscatter rectangle area, set inRect1=true so that mouse drag will draw the bar using
	 * XOR Mode.
	 */
	void regMeanScatter_MousePressed(java.awt.event.MouseEvent event)
	{

		if ((event.getY() >= lastycoor1-5 && event.getY() < lastycoor1+BARWIDTH+5)  && (event.getX() >40 && event.getX()<416)) {
			inRect1=true;
			//yadj1=lastycoor1-event.getY();
			/*Graphics g = getGraphics();
			g.setXORMode(this.getBackground());
			g.fillRect(edge,lastycoor1,width,BARWIDTH);*/
		}
		else {
			inRect1=false;
		}

	}

	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseDragged(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == regMeanScatter.this)
				regMeanScatter_MouseDragged(event);
		}
	}


	/**
	 * If mouse pressed within the rrscatter rectangle area, mouse drag using XOR mode to draw the bar along the user's action
	 */
	void regMeanScatter_MouseDragged(java.awt.event.MouseEvent event)
	{
		if (inRect1) {
			Graphics g = getGraphics();
			g.setXORMode(this.getBackground());
			g.fillRect(edge,lastycoor1,width,BARWIDTH);

			Point p1 = getUpperLeft();
			//currycoor=event.getY()-yadj1-1;
			currycoor=event.getY();
			if (currycoor<p1.y+1)  {
				currycoor=p1.y+1;
			}

			else if (currycoor > (lastycoor2-BARWIDTH))  {
				currycoor=lastycoor2-BARWIDTH;
			}

			g.fillRect(edge,currycoor,width,BARWIDTH);

		  	lastycoor1=currycoor;
		}

	}


	/**
	 * Mouse released caused the statistics recalulation, repaint the rrscatter and send new cutoff color message(yStats) to applet.
	 */
	void regMeanScatter_MouseReleased(java.awt.event.MouseEvent event)
	{
		cal_Color(XX, YY, N);
		repaint();
		range.newCutOff(yStats);
	}


}
