package regtomean;
import RVLS.*;
import java.awt.*;
import java.applet.*;

public class scatterRm extends scatter {
	Color [] yStats;
	double m, b;
	int vy1, vy2;

	rangeFrame range=null;

	/**
	 * class constructor, the only difference between scatterRm and rrscatter is that rrscatter
	 * has the score selection function as the bar moving up and down, and rrscatter can
	 * calculate the color array yStats[] according to the test score selections.
	 */
	public scatterRm() {
		super();
	}

	/**
	 * Before it calls super setData, it calculate the current statistics according to current score distribution
	 */
	public void setData(double [] X, double [] Y, double minX, double maxX, double minY, double maxY, int N, Color[] yStats) {

		this.yStats = yStats;
		calcStats(X,Y,N);
		super.setData(X,Y,minX,maxX,minY,maxY,N);
	}

	public void setApplet(rangeFrame range) {
		this.range= range;
	}

	public void drawPoints(Graphics g) {
		for (int i=0;i<N;i++) {
			g.setColor(yStats[i]);
	  		switch (shape) {

  	 		case RECT:
  	 			if (filled)
  	 				g.fillRect(X[i]-2,Y[i]-2,4,4);
  				else
  			    	g.drawRect(X[i]-2,Y[i]-2,4,4);
  			    	break;
  			case CIRCLE:
  				if (filled)
  	 				g.fillOval(X[i]-2,Y[i]-2,4,4);
  				else
  			   	 g.drawOval(X[i]-2,Y[i]-2,4,4);
  			}
		}
	}

	/**
	 * paint draws the diagnal line in addition to the super scatter paint.
	 */
	public void paint(Graphics g) {
		super.paint(g);
		Point p1 = getUpperLeft();
		Point p2 = getLowerRight();
		m = 100/(Ly.transformToValue(100)-Ly.transformToValue(0));
		b = 100-m*Ly.transformToValue(100);
		vy1 = (int)(m*Lx.transformToValue(p1.x)+b);
		vy2 = (int)(m*Lx.transformToValue(p2.x)+b);
		g.clipRect(p1.x,p1.y,p2.x-p1.x,p2.y-p1.y);
		g.drawLine(p1.x,vy1,p2.x,vy2);
	}

	/**
	 * calcStats() carried the colors from Test 1 scores, see in each category of people,
	 * how their second test scores turning out. Notice XX[] is the array of the true score and
	 * YY[] is the array of the second test scores.
	 */
 	public void calcStats(double[] XX, double[] YY, int N) {

 		double meanT=0, meanA=0, magentaT=0, magentaA=0, magenta2T=0, magenta2A=0, dkblueT=0, dkblueA=0, ltblueT=0, ltblueA=0, greenT=0, greenA=0;
		double redT=0, redA=0, orangeT=0, orangeA=0, darkgrayT=0, darkgrayA=0, cyanT=0, cyanA=0, unselectA=0, unselectT=0;
		int meanCount=0, magentaCount=0, magenta2Count=0, dkblueCount=0, ltblueCount=0, greenCount=0, redCount=0, orangeCount=0, cyanCount=0, darkgrayCount=0, unselectCount=0;

		Color ltBlue = new Color(3708415);
		Color cyan = new Color(6947071);
		Color magenta2 = new Color(-3536129);
		Color orange = new Color(16747778);

 		for (int i = 0; i<N; i++)
 		{
 			meanT += XX[i];
			meanA += YY[i];
			meanCount++;
			if ((yStats[i].equals(ltBlue))|(yStats[i]==Color.blue)|(yStats[i]==Color.green)|(yStats[i]==Color.magenta))
			{
				darkgrayT += XX[i];
				darkgrayA += YY[i];
				darkgrayCount++;

				if ( yStats[i].equals(ltBlue))	{
					ltblueT += XX[i];
					ltblueA += YY[i];
					ltblueCount++;
				}
				else if (yStats[i] == Color.magenta )	{
					magentaT += XX[i];
					magentaA += YY[i];
					magentaCount++;
				}
				else if  (yStats[i] == Color.green ){
					greenT += XX[i];
					greenA += YY[i];
					greenCount++;
				}
				else 	{
					dkblueT += XX[i];
					dkblueA += YY[i];
					dkblueCount++;
				}
			}
			else
			{
				unselectT += XX[i];
				unselectA += YY[i];
				unselectCount++;

				if ( yStats[i].equals(magenta2))	{
					magenta2T += XX[i];
					magenta2A += YY[i];
					magenta2Count++;
				}
				else if ( yStats[i].equals(cyan))	{
					cyanT += XX[i];
					cyanA += YY[i];
					cyanCount++;
				}
				else if (yStats[i].equals(orange))	{
					orangeT += XX[i];
					orangeA += YY[i];
					orangeCount++;
				}
				else if (yStats[i] == Color.red )	{
					redT += XX[i];
					redA += YY[i];
					redCount++;
				}
			}

		}
		if (darkgrayCount == 0)
		{
			range.result1.label23.setText("0");
		}
		else
		{
			darkgrayT /= darkgrayCount;
			darkgrayA /= darkgrayCount;
			range.result1.label23.setText(graphUtilities.format(darkgrayA,1));
		}

		if (magentaCount ==0)
		{
			range.result1.label12.setText("0");
		}
		else
		{
			magentaT /= magentaCount;
			magentaA /= magentaCount;
			range.result1.label12.setText(graphUtilities.format(magentaA,1));
		}

		if (dkblueCount ==0)
		{
			range.result1.label7.setText("0");
		}
		else
		{
			dkblueT /= dkblueCount;
			dkblueA /= dkblueCount;
			range.result1.label7.setText(graphUtilities.format(dkblueA,1));
		}

		if (ltblueCount == 0)
		{
			range.result1.label22.setText("0");
		}
		else
		{
			ltblueT /= ltblueCount;
			ltblueA /= ltblueCount;
			range.result1.label22.setText(graphUtilities.format(ltblueA,1));
		}

		if (greenCount == 0)
		{
			range.result1.label17.setText("0");
		}
		else
		{
			greenT /= greenCount;
			greenA /= greenCount;
			range.result1.label17.setText(graphUtilities.format(greenA,1));
		}

		if (redCount == 0)
		{
			range.result1.label28.setText("0");
		}
		else
		{
			redT /= redCount;
			redA /= redCount;
			range.result1.label28.setText(graphUtilities.format(redA,1));
		}

		if (cyanCount == 0)
		{
			range.result1.label33.setText("0");
		}
		else
		{
			cyanT /= cyanCount;
			cyanA /= cyanCount;
			range.result1.label33.setText(graphUtilities.format(cyanA,1));
		}

		if (meanCount == 0)
		{
			range.result1.label37.setText("0");
		}
		else
		{
			meanT /= meanCount;
			meanA /= meanCount;
			range.result1.label37.setText(graphUtilities.format(meanA,1));
		}

		if (unselectCount == 0)
		{
			range.result1.label2.setText("0");
		}
		else
		{
			unselectT /= unselectCount;
			unselectA /= unselectCount;
			range.result1.label2.setText(graphUtilities.format(unselectA,1));
		}

		if (magenta2Count == 0)
		{
			range.result1.label51.setText("0");
		}
		else
		{
			magenta2T /= magenta2Count;
			magenta2A /= magenta2Count;
			range.result1.label51.setText(graphUtilities.format(magenta2A,1));
		}

		if (orangeCount == 0)
		{
			range.result1.label47.setText("0");
		}
		else
		{
			orangeT /= orangeCount;
			orangeA /= orangeCount;
			range.result1.label47.setText(graphUtilities.format(orangeA,1));
		}
	}

}

