package sampdist;

import java.awt.*;
import RVLS.notified;
class Histogram extends Canvas {
	//Sampling applet;
	int[] f;
	int yinc;
	//int lastHeight = -1;
	final int yoffset = 30; //at the bottom
	final int yoffset2=16; // at the top
	final int 	xoffset = 145;
	int[] fdata;
	int[] mRect;
	int yintervals,XaxisDec;
	int numInt,width,rWidth,rHeight,gap,theBin,inter,Nobs;
	double fmin,fmax,sp2v,sv2p,ip2v,iv2p;
	double sum,ssq;
	boolean[] stats;
	float[] xdata;
	boolean top,norm,showStat,clickable,labelXaxis,endsOnly;
	Color[] colors;
	// = {Color.blue,Color.magenta,Color.red,Color.orange,Color.green};
	String title;
	Font font,fontN;
	//Sampling applet;
	Label testlabel;
	Color color;
        notified myNotify;

	public Histogram(float[] xxdata, int[] data, int nn) {
		String _title = "";
		boolean[] _stats = new boolean[8];
		for (int i=0;i<8;i++){
			_stats[i]=false;
		}
		int _yintervals=5;

		boolean yticks=true;
		endsOnly = false;
		int _rWidth= 400; //joan change 400 to 410
		int _rHeight=200;
		Color[] _colors = {Color.blue,Color.magenta,Color.red,Color.green,Color.black, Color.cyan, Color.darkGray, Color.lightGray};
		boolean _clickable=false;
		boolean _labelXaxis=true;
		int _gap=0;
		initialize(_title,xxdata,data,nn,_stats,yticks,_rWidth,_rHeight,_yintervals,_clickable,_labelXaxis,_gap,_colors);

	}
        public void setInform (notified myNotify)
        {
                this.myNotify = myNotify;
	}
	public Histogram(String _title,float[] xxdata,int[] data,int nn, boolean [] _stats, boolean yticks,int _rWidth, int _rHeight, int _yintervals, boolean _clickable, boolean _labelXaxis, int _gap,Color[] _colors) {

		// _title
		// xxdata [] array containing bin midpoints
		// data[] bin frequencies
		// nn number of bins
		// _stats a boolean for each of 8 stats indicating whether to display
		// yticks should ticks on the Y axis be displayed
		//_rWidth the width of the display area

		// _rHeight the height of the display area
		// _ yintervals is the number of ticks on the Y axis
		// _colors is an array of colors to display the statistics


		initialize(_title,xxdata,data,nn,_stats,yticks,_rWidth,_rHeight,_yintervals,_clickable,_labelXaxis,_gap,_colors);
	}

	 void initialize(String _title,float[] xxdata,int[] data,int nn, boolean [] _stats, boolean yticks,int _rWidth, int _rHeight, int _yintervals, boolean _clickable, boolean _labelXaxis,int _gap,Color[] _colors) {

		font = new Font("TimesRoman",Font.PLAIN,12);showStat=true;
		fontN = new Font("TimesRoman",Font.PLAIN,9);
		title=_title;
		labelXaxis=_labelXaxis;
		XaxisDec=0;
		clickable=_clickable;
		yintervals = _yintervals;
		norm=false;
		sum=0;
		ssq=0;
		Nobs=0;
		stats = new boolean[_stats.length];
		for (int i=0;i<_stats.length;i++){
			stats[i]=_stats[i];
			//System.out.println(i + "  " + stats[i]);
		}
		int cl = _colors.length;
		colors = new Color[cl];

		for (int i=0;i<cl;i++){
			colors[i]=_colors[i];
		}
		top= yticks;
		gap=_gap;
		numInt = nn;
		f = new int[nn];
		mRect = new int[4];
		mRect[0]=0;mRect[1]=0;mRect[2]=width;mRect[3]=0;
		fdata = new int[nn];
		xdata = new float[nn];
		fmin=0;
		fmax=0;
		boolean theSame=true;
		for (int i=0;i<nn;i++){
			fdata[i]=data[i];
			xdata[i] = xxdata[i];
			fmin = Math.min(fmin,fdata[i]);
			fmax =  Math.max(fmax,fdata[i]);
			sum+=xdata[i]*fdata[i];
			ssq+=xdata[i]*xdata[i]*fdata[i];
			Nobs+=fdata[i];
			if (fdata[i] != fdata[0]) {theSame=false;}
		}

		if (fmax == 0){
			fmax = yintervals;
		}
		else if (theSame) {
			fmax+=5;
		}

		if (fmax < yintervals){
			fmax=yintervals;
		}
		//fmax is the highest tick mark

		//width=10;
		rWidth=_rWidth;
		width = (rWidth-xoffset-10)/numInt;
		resize(rWidth,_rHeight);
		rHeight = _rHeight - yoffset2 -yoffset; //height of histogram itself

		setSlopes();
		//resize(rWidth+xoffset+20,rHeight+yoffset+yoffset2);
		//resize(rWidth,rHeight+yoffset+yoffset2);
		//testlabel = new Label("testing");
		//add(testlabel);

		//f[0] = (int) Math.round(iv2p);


	}
	public void setClickable(boolean _click) {
		clickable=_click;
	}
	public void setStats(boolean s){
		showStat=s;
		repaint();
	}
	public int getNumSamples() {
		return Nobs;
	}
	public void clear (){
		for (int i=0;i<numInt;i++){
			fdata[i]=0;
		}
		setData(fdata,numInt,false,0,0);
		//sum=0;
		//ssq=0;
		Nobs=0;
		//repaint();
	}
	public void setTitle(String _title){
		title=_title;
		repaint();
	}
	public void setData(float[] _xdata){
		numInt = _xdata.length;
		for (int i=0;i<numInt;i++){
			xdata[i]=_xdata[i];
			//System.out.println(i + " " + xdata[i]);
		}
		//System.out.println(title + " Xdata has been set");
	}
	public void setStats(boolean[] s){
		for (int i=0;i< 10; i++) {
			stats[i]=s[i];
		}
		repaint();
	}
	public void setFmax(double fm){
		fmax = fm;
		setSlopes();
		repaint();
	}
	final void setColor(Color c) {
		Graphics g;
		g= getGraphics();
		color=c;
		//g.setColor(Color.blue);
		//System.out.println(c);
		// g.setColor(c);
	}
	private final void setSlopes() {
		//System.out.println(" setSlopes begin");
		sp2v = (fmax-fmin)/(0-rHeight);
		ip2v = (fmax+fmin)/2 - sp2v * (0+rHeight)/2;
		sv2p = 1/sp2v;
		iv2p = (0+rHeight)/2 - sv2p * (fmax+fmin)/2;
		//if (Math.abs(sv2p)>.5){
			//sv2p = Math.round(sv2p);
		//}

		yinc = (int) Math.round(sv2p);

		yinc = -yinc;
		//System.out.println("from setSlopes: fmax = " + fmax + " min = " + fmin + "height " + rHeight);
		inter = (int) Math.round(iv2p)+1;
		Nobs=0;
		for (int i = 0;i<numInt;i++)
		{
			Nobs+=fdata[i];
			f[i] = (int) (sv2p*fdata[i]+inter) ;

			//System.out.println(i + " " + fdata[i] + " " + f[i]);
		}
		//System.out.println(" setSlopes end");
	}
	public final void SetNorm(boolean nValue){
		norm=nValue;
		repaint();
	}
	public void AdRect(int inc, Graphics g){
		g.clearRect(mRect[0],mRect[1],mRect[2],mRect[3]);
		mRect[1]+=inc;
		//if (mRect[1] >=	bot) {
			g.fillRect(mRect[0],mRect[1],mRect[2],mRect[3]);
			//return true;
		//}
		//else
		// {return false;}
	}
	private void fitNormal(Graphics g) {
		int x1,height,npix;
		int maxHeight = rHeight+yoffset2;
		//Graphics g=getGraphics();
		float M,s,inc,Y;
		double temp,X,z,p;
		float[] R = new float[3];
		float step = xdata[1]-xdata[0];
		int done = (width+gap)*numInt;
		//N=0;
		height=0;
		R=MeanSd();
		npix=5;
		M=R[1];
		s=R[2];
		inc = step/width; // units/pixel
		inc = inc/= s;  //sd's per pixel
		//p = zprob(1.96);
		//System.out.println(" p(1.960) = " + p);
		z=step/2/s;	//sd's below mean of cutoff of middle bin
		p=(0.5-zprob(z))*2.0;
		//System.out.println(" p = " + p);
		//for(int i=0;i<numInt;i++){
			//N+=fdata[i];
		//}
		p*=Nobs;


		temp =   Math.sqrt(1.0/(2.0*Math.PI));
		temp =temp *p/.3989;
	//	double scale = meanY/.3989/10;
		x1=xoffset + gap/2;

		X=(xdata[0] - step/2 - M)/s; //z score of first point
		 Y= (float) (temp* Math.exp(-X*X/2));

		int Lastheight = (int) Math.min((sv2p*Y+inter +yoffset2),maxHeight);


		if (s>0.0){
		for (int i = 0;i<done;i+=npix){
			X+= npix*inc; //number of sd's
			 Y= (float) (temp* Math.exp(-X*X/2));

			 //Y*=R[0];

			// System.out.println("X =" + X + " Y = " + Y + " temp = " + temp );

			 height = (int) Math.min((sv2p*Y+inter +yoffset2),maxHeight);
			 g.drawLine(x1,Lastheight,x1+npix,height);
			 x1+=npix;
			 Lastheight=height;


		}

		}

	}
		private float[] MeanSd(){
			//N returned in R[0], Mean in R[1], and sd in R[2]
			float[] R = new float[3];
			float s,ssq;
			int N=0;
			s=0;
			ssq=0;
				for (int i = 0;i<numInt;i++){
					//System.out.println(fdata[i]);
					N+=fdata[i];
					s+=xdata[i]*fdata[i];
					ssq+=xdata[i]*xdata[i]*fdata[i];
				}
				//System.out.println("sum =  " + s);
			R[0] = (float) N;
			R[1] = s/R[0];
			R[2] = (float) Math.sqrt((ssq-s*s/R[0])/R[0]);
			//System.out.println(R[0] + " " + R[1] + " " + R[2]);
			return R;
		}
	public void paint(Graphics g)
	{
		g.setFont(font);
		int x1,xadd;
		x1=xoffset + gap/2;
		xadd = width+gap;
		g.setColor(Color.black);
		g.drawString(title,xoffset+4,yoffset2-4);
		g.setColor(color);
		//System.out.println("from paint " + color);

		/*
		if (mRect[3]>0) {
			//System.out.println("Painting rect");
			g.fillRect(mRect[0],mRect[1],mRect[2],mRect[3]);
		}
		*/

		for (int i=0;i<numInt;i++)
		{
			g.fillRect(x1,f[i]+yoffset2 ,width, rHeight-f[i]);
			//g.fillRect(x1,f[i]+yoffset2 ,width,f[i]);
			x1+=xadd;
			//if (fdata[17] > 0){
			//	System.out.println("i= " + i + " fdata[i] " + fdata[i] + " f[i] " + f[i]);
			//}
		}
		drawAxes(g);
			if (norm && (Nobs > 2)){
				fitNormal(g);
			}
		if (showStat) {
			plotStats(g);
		}
	//	System.out.println("f[0]= " + f[0]);
	}

	public int PrepAdd (double s){
		float step = xdata[1]-xdata[0];
		float x0 = xdata[0] - step/2;
		int x1;
		theBin = (int) Math.floor((s-x0)/step);

		x1 = xoffset +theBin*width + gap/2;
		//y = (int) Math.round(sv2p*fdata[theBin]);
		mRect[0]=x1;
		mRect[2]=width;
		mRect[3] = yinc;
		mRect[1]= yoffset2-mRect[3];
		int b = f[theBin]-yinc;
		//System.out.println("from prepadd: mRect[3]= " + mRect[3]);
		//System.out.println(" b = " + b);
		return b;
	}

public	double zprob(double z){
	 double b,s,a,HH,p;
	boolean flag;
	if (z<-7) {return 0.0;}
	if (z>7) {return 1.0;}


	if (z<0.0) {flag= true;}
		else
		{flag = false;}

	z = Math.abs(z);
	b=0.0;
	s=Math.sqrt(2)/3*z;
	HH=.5;
	for (int i=0;i<12;i++) {
		a = Math.exp(-HH*HH/9)*Math.sin(HH*s)/HH;
		b=b+a;
		HH=HH+1.0;
	}
	p= .5-b/Math.PI;
	if (flag) {p=1.0-p;}
		return p;
}

	public void addX (int _bin)
	{
		int bin = _bin;
		//mRect[3]=0;
		fdata[bin]++;
		f[bin] = (int) Math.round(sv2p*fdata[bin]+inter);

		if (fdata[bin] >=fmax) {
			fmax+=yintervals;
			setSlopes();
		}
		else {
			Nobs++;
		}
		//System.out.println("bin = " + bin + " freq= " + fdata[bin] + " pixels= " + f[bin]);
		//System.out.println("rheight= " +rHeight);
		//setSlopes();
		update(getGraphics());
	}

public void update(Graphics g) {
	Dimension dim = size();
	Image osi=createImage(dim.width,dim.height);
	Graphics osg=osi.getGraphics();
	osg.setColor(getBackground());
	osg.fillRect(0,0,dim.width,dim.height);
	osg.setColor(g.getColor());
	paint(osg);
	g.drawImage(osi,0,0,this);
}
	private void drawAxes(Graphics g){
		int h;
		g.setColor(Color.black);
		FontMetrics met,metN;
		g.setFont(fontN); //joan change 10/5/03
		met=g.getFontMetrics(font);
		metN=g.getFontMetrics(fontN);
		h = met.getAscent();
		h/=2;
		String yLabel;
		int x1 = xoffset-gap/2;
		int x2 = x1-4;
		int xa, SL,topline;
		//System.out.println("X1 = " + x1);
		//g.drawRect(0,0,rWidth+xoffset-1,rHeight-1);
		g.drawLine(x1-1,rHeight+yoffset2,x1-1,yoffset2-5);
		//g.drawLine(x1,rHeight,rWidth+xoffset,rHeight);
		int iadd = (int) Math.round(fmax/yintervals);
		double fadd = fmax/yintervals;
	//	System.out.println("fadd= " + fadd);
		//System.out.println("iadd= " + iadd);
		//System.out.println("fmax= " + fmax);
		//System.out.println("yintervals= " + yintervals);

		topline = yintervals*iadd;
		int y=rHeight+yoffset2;
		if (top == true) {
			//for (int i=0;i<=topline; i+= iadd){
			for (int i=0;i<=yintervals; i++){
				y= (int) Math.round(i*sv2p*fadd +rHeight+yoffset2);
				//System.out.println(i + " y " + y);
				g.setColor(Color.lightGray);
				g.drawLine(x1-2,y,x2,y);
				g.setColor(Color.black);
				yLabel = i * iadd +" ";
				//SL = 18;
				SL = metN.stringWidth(yLabel) + 3;
				g.drawString(yLabel, x1-SL,y+h);
				//y+= (int) iadd*sv2p;

			}
		}

		//xa=xoffset+gap/2+width/2;
		//xa=xoffset+gap/2 +width/2;
		xa=xoffset+gap/2;
		//xa=xoffset;
		int xinc = width+gap;
		xa-=xinc;
		int xx = rHeight+yoffset2+4;
		int xx2=xx+4;
		g.setFont(fontN);

		for (int i=0;i<numInt;i++){
			xa+=xinc;
			if (labelXaxis || (endsOnly && (i==0 || i== numInt-1))) {

				//String num = Float.toString(xdata[i]);
				double xd = (double) xdata[i];
				String num = format(xd,XaxisDec);
				SL = metN.stringWidth(num);
				int adj = (xinc-SL)/2+1;
				g.drawString(num, xa+adj,xx2);
				//System.out.println("xinc= " + xinc);
				//System.out.println("SL= " + SL);
				//System.out.println("adj= " + adj);
			}
			g.setColor(Color.lightGray);
			g.drawLine(xa,rHeight+yoffset2,xa,xx);
			g.setColor(Color.black);
		}
		xa+=xinc;
		g.setColor(Color.lightGray);
		g.drawLine(xa,rHeight+yoffset2,xa,xx);
		g.setColor(Color.black);
		g.drawLine(x1-1,rHeight+yoffset2,xa,rHeight+yoffset2);

	}


	//--------
	static String format( double X, int nd){
		//double R;
		String sign;
		if(X<0) sign="-"; else sign="";

		int RR;
		String Rstr;
	//	int off;
		if (nd==0) {
			RR = (int) Math.rint(X);
			Rstr = RR+"";
			//off = Rstr.indexOf('.',0);
			//if (off != -1) {
			//	Rstr=Rstr.substring(0,off);
			//}

		}
		else {
		double xx=Math.pow(10,nd);
		//R = Math.round(xx*X);
		 RR = (int) Math.rint(xx*Math.abs(X));
		//R/=xx;
		//Rstr = Double.toString(R);
		if (RR==0) {
			Rstr="0.";
			for (int i=0;i<nd;i++) {
				Rstr+="0";
			}
		}
		else {
			Rstr = RR+"";
		//System.out.println(Rstr);

			int L = Rstr.length();
		//System.out.println("l= " + L + " nd= " + nd);
		if (L<nd) {
			Rstr=".";
			for (int i=0;i<nd-L;i++) {
				Rstr+="0";
			}
			Rstr+=RR;
		}
		else {
			String sa = Rstr.substring(0,L-nd);
			String sb = Rstr.substring(L-nd);
			Rstr = sa + "." + sb;
		}
		}
		/*
		off = Rstr.indexOf('.',0);
		if (off == -1)  {
			Rstr+= ".";
			for (int i=0;i<nd;i++){
				Rstr+="0";
			}
		}
		else {

			//int LL= Rstr.length();
			int LF = off + nd+1;
			while (Rstr.length() < LF) {
				Rstr+="0";
			}
		}
		*/
	}
	if (Rstr.indexOf(".") ==0) Rstr="0"+Rstr;
	Rstr = sign+Rstr;
	return Rstr;
}
	//------------


	public void plotStats(Graphics g){
		double s,sq,med,range;
		int N,L,Y,xmn,xsd;

		float xstep,pixstep;
		//g.setColor(Color.black);
		FontMetrics met;
		g.setFont(font);
		met=g.getFontMetrics(font); //joan change to fontN
		int maxA = met.getMaxAscent() + 4;
//		int h=met.stringWidth("mean = 16");
//		System.out.println("sw ps = " + h);
		s=0;N=0;sq=0;

		s=sum/Nobs;
		if (Nobs==1) {
			sq=0;
		}
		else {
			sq= Math.sqrt((ssq-sum*sum/Nobs)/Nobs);
		}
		//System.out.println(title + " ssq= " + ssq + " sum= " + sum + " Nobs = " + Nobs);
		for (int i = 0;i<numInt;i++){
			N+=fdata[i];
		}

		xstep = xdata[1]-xdata[0];
		pixstep = (width+gap)/xstep;

		//s=Math.round(100*s);
		//s/=100;

		//sq = format(sq,2);
		//L=xoffset;
		L= 12;
		int in=0;
		Y=rHeight+yoffset2;
		int Y1=Y+10;
		int Y2= Y1+5;
		Y=rHeight+yoffset2;
		xmn = xoffset + (int) Math.round((s-xdata[0]+xstep/2.0)*pixstep);
		/*
		System.out.println("s = " + s);
		System.out.println("xoffset = " + xoffset);
		 System.out.println("xdata[0]= " + xdata[0] + " xdata[1]= " + xdata[1]);
		 System.out.println("width = " + width);
		 System.out.println("pixstep = " + pixstep);
		 System.out.println("xmn = " + xmn);
		 */
		//g.setColor(Color.blue);

		if (N > 0) {
			if (top) {
				String fstr = "" + N;
				int LL =95 - met.stringWidth(fstr); //joan change 80 to 88 to 95 10/5/03
				g.drawString("Reps=", 1,L);//joan change 4 to 1
				g.drawString(fstr,LL,L);
				L+=maxA;
			}
			if (stats[in]){
				printStat(s,true,xstep, pixstep,L,in, Y1,Y2, "mean=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				if ((stats[0]) && (N <= 2)) {
					med=s;
				}
				else {
					med = ComputeGroupedMedian(fdata,numInt,N);
				}

				int Yx;
				if ((int) Math.round((med+xstep/2.0)*pixstep) == (int) Math.round((s+xstep/2.0)*pixstep) && (stats[0])) {

					Yx=Y1+3;
				}
				else {
					Yx=Y1;
				}


				printStat(med,true,xstep, pixstep,L,in, Yx,Y2, "median=", g, met);
				L+= maxA;
			}
			in++;
			//if ((stats[in]) && (sq >.01)){
			if (stats[in]){
				boolean drawLine;
				drawLine = !stats[0];
				//System.out.println("sq= " + sq);
				xsd = (int) Math.round(sq*pixstep);
				g.setColor(colors[in]);
				if (sq > 0) {

					g.drawLine(xmn-xsd,Y+8,xmn+xsd,Y+8);
					g.drawLine(xmn-xsd,Y,xmn-xsd,Y+8);
					g.drawLine(xmn+xsd,Y,xmn+xsd,Y+8);
				}
				else
				{
					drawLine = false;
				}
				//sq=format(sq,2);
				//tstring = "sd = " + sq;
				//g.drawString(tstring, L,Y+28);
				//L+=met.stringWidth(tstring)+ 5;
				printStat(sq,drawLine,xstep, pixstep,L,in, Y1,Y2, "sd=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				range= ComputeGroupedRange(fdata,xdata,numInt);
				printStat(range,true,xstep, pixstep,L,in, Y1,Y2, "range=", g, met);
				L+= maxA;
			}
			in++;
			//if ((stats[in]) && (sq >.01)){
			if (stats[in]) {
				double skew= ComputeSkew(fdata,xdata,numInt,s);
				printStat(skew,false,xstep, pixstep,L,in, Y1,Y2, "skew=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				double MAD= ComputeMAD(fdata,xdata,numInt);
				printStat(MAD,false,xstep, pixstep,L,in, Y1,Y2, "MAD=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				double vv= sq*sq;
				printStat(vv,false,xstep, pixstep,L,in, Y1,Y2, "Var=", g, met);
				L+= maxA;
			}
			in++;
			if (stats[in]) {
				double kurt= ComputeKurt(fdata,xdata,numInt,s);
				printStat(kurt,false,xstep, pixstep,L,in, Y1,Y2, "kurtosis=", g, met);
				L+= maxA;
			}
                        in++;
			if (stats[in]) {
				double vu= (sq*sq*Nobs)/(Nobs-1);
				printStat(vu,false,xstep, pixstep,L,in, Y1,Y2, "Var (U)=", g, met);
				L+= maxA;
			}
			g.setColor(Color.darkGray);
		}
	}
	public void printStat(double stat,boolean drawLine, float xstep, float pixstep, int L, int in, int Y1, int Y2, String tstring, Graphics g, FontMetrics met) {
		String statStr, fstr;
		int x,LL;
		g.setColor(colors[in]);
		x=xoffset + (int) Math.round((stat-xdata[0]+xstep/2.0)*pixstep);
		fstr = format(stat,2);
		statStr = tstring + fstr;
		if (drawLine){
			g.drawLine(x,Y1,x,Y2);
		}
		LL = 95 - met.stringWidth(fstr); //joan change 80 to 88
		//g.drawString(statStr, L,Y2 + 13);
		g.drawString(tstring, 1,L); //joan change 4 to 1
		g.drawString(fstr, LL,L);
		//r =  L + met.stringWidth(statStr)+ 10;
		//r=L+12;
		//return r;
	}

public double ComputeGroupedRange(int[] freq,float[] xdata, int k){
		double r;
		int min,max,count,in;
		min=0;
		max=0;
		count=0;
		in=-1;
			//for (int i=0;i<k;i++){
			//System.out.println(i + " " + freq[i]);
		//}
		while ((count==0) && (in<k-1)){
			in++;
			count=freq[in];
		}
		min=in;
		//System.out.println("min = " + min);

		count=freq[k-1];
		//System.out.println("initial count = " + count);
		in=k-1;
		while ((count <= 0) && (in>0)){
			in--;
			count=freq[in];
		}
		max=in;

		r = xdata[max]-xdata[min];
		return r;
}
	public double ComputeGroupedMean(int[] freq,float[] xdata, int k){
		double s;
		int N;
		s=0;N=0;
		for (int i = 0;i<k;i++){
			s+= xdata[i]*freq[i];
//			sq+=xdata[i]*xdata[i]*fdata[i];
			N+=freq[i];
		}
//		sq = Math.sqrt((sq-s*s/N)/N);
		if (N>0) {
			s=s/N;
		}
		return s;
	}

	public double ComputeGroupedsd(int[] freq,float[] xdata, int k){
		double s,sq;
		int N;
		s=0;sq=0;N=0;
		for (int i = 0;i<k;i++){
			s+= xdata[i]*freq[i];
			sq+=xdata[i]*xdata[i]*freq[i];
			N+=freq[i];
		}
		//System.out.println("s = " + s + " sq= " + sq);
		sq = Math.sqrt((sq-s*s/N)/N);
		return sq;
	}
		public double ComputeSkew(int[] freq,float[] xdata, int k, double m){
		double sq;
		int N;
		double sd = ComputeGroupedsd(freq,xdata,k);
		sq=0;N=0;
		for (int i = 0;i<k;i++){
			//s+= xdata[i]*freq[i];
			sq+=Math.pow((xdata[i]-m),3)*freq[i];
			N+=freq[i];
		}
		if ( (sd==0) || (N<2)) {
			 sq = 0;
		}
		else {
			sq = (sq/N)/Math.pow(sd,3);
		}
		return sq;
	}
		public double ComputeKurt(int[] freq,float[] xdata, int k, double m){
		double sq;
		int N;
		double sd = ComputeGroupedsd(freq,xdata,k);
		sq=0;N=0;
		for (int i = 0;i<k;i++){
			//s+= xdata[i]*freq[i];
			sq+=Math.pow((xdata[i]-m),4)*freq[i];
			N+=freq[i];
		}
		if ( (sd==0) || (N<2)) {
			 sq = 0;
		}
		else {
			sq = (sq/N)/Math.pow(sd,4)-3;
		}

		return sq;
	}
	public double ComputeMAD(int[] freq,float[] xdata, int k){
		double MAD,m;
		int N=0;
		m=0;
		MAD=0;
		for (int i = 0;i<k;i++){
			//s+= xdata[i]*freq[i];
			//MAD+=Math.abs(xdata[i]-m)*freq[i];
			N+=freq[i];
			m+=xdata[i]*freq[i];
		}
		m/=N;
		for (int i = 0;i<k;i++){
			//s+= xdata[i]*freq[i];
			MAD+=Math.abs(xdata[i]-m)*freq[i];

		}

		MAD/=N;
		return MAD;
	}
public double ComputeGroupedMedian(int[] fd,int k,int N){

		double R = 0.5*(double)(N+1);
		int    IR = (int)Math.floor(R);
		int nc=0;
		double med =0;

		for (int i = 0; i<k;i++)
		{
			nc+=fd[i];
			if (nc == IR)
			{
				if ((i+1) < k)
				med = xdata[i] + (R-(double)(IR))*(xdata[i+1]-xdata[i]);
				else
				med = xdata[i];

				break;
			}
			else if (nc > IR)
			{
				med = xdata[i];
				break;
			}
		}

		return med;
}
	public void setGap(int agap) {
		//System.out.println("setting");
		gap=agap;
		repaint();
	}
	public void setData(int[] data, int nn, boolean add, double _sum, double _ssq){
		numInt = nn;
		//fdata = new int[nn];
		fmax=yintervals;
		int tmax=0;
		if (add) {
			sum+=_sum;
			ssq+=_ssq;
		}
		else {
			sum=_sum;
			ssq=_ssq;
		}

		//System.out.println(" before = " );
		//for (int i=0;i<nn;i++){
			//System.out.println(i + " " +fdata[i]);
		//}
		//System.out.println(" add = " + add);
		for (int i=0;i<nn;i++){
			if (add){
				fdata[i]+=data[i];
			}
			else {
				fdata[i]=data[i];
			}
			if (fdata[i] > tmax){tmax=fdata[i];}
		}

		if (tmax>fmax) {
			//while (fmax<tmax){
				//fmax+=5;
			//}
			fmax = Math.floor(tmax/yintervals)*yintervals+yintervals;

				//	System.out.println("setData before setSlopes: sv2p = " + sv2p + " max = " + fmax);


				//	System.out.println("setData after setSlopes: sv2p = " + sv2p + " max = " + fmax);

		}
		setSlopes();
		for (int i = 0;i<numInt;i++)
		{
			f[i] = (int) Math.round(sv2p*fdata[i]+iv2p);
			//System.out.println(fdata[i] + " " + f[i]);
		}
		drawAxes(getGraphics());
		repaint();
		//System.out.println("sum = " + sum + " " + " ssq = " + ssq);
	}

	public boolean mouseDown(Event e, int x, int y)
	{
		if (clickable) {

                        myNotify.dataChanged(0);
			//setStats(false);
			changeDist(x,y);
		//applet.mean.setText(Double.toString(s));
		//applet.mean.setText(String.toString(y));
		}
		return true;
	}
	public boolean mouseUp(Event e, int x, int y)
	{
		if (clickable) {

		//	changeDist(x,y);
		//applet.mean.setText(Double.toString(s));
		//applet.mean.setText(String.toString(y));
		}
		sum=0;
		ssq=0;
		Nobs=0;
		for (int i=0;i<numInt;i++) {
			//System.out.println(i + " " + fdata[i]);
			sum+=xdata[i]*fdata[i];
			ssq+=xdata[i]*xdata[i]*fdata[i];
			Nobs+=fdata[i];
		}
		//float theMean = (float) (sum/Nobs);
		//System.out.println("mean = " + theMean);
		//setStats(true);
		//setSlopes();
		repaint();
		return true;
	}
	public void setEndsOnly (boolean _endsOnly) {
		endsOnly=_endsOnly;
	}
	public void setXaxisDec (int _XaxisDec) {
		XaxisDec = _XaxisDec;
	}
	public void changeDist (int x, int y){
		Graphics g;

			int theBin,ff;
			int xadd = width+gap;
			g=getGraphics();
			g.setColor(color);
			//g.setColor(Color.yellow);
			theBin = (x-xoffset-gap/2)/width;
			//System.out.println("Bin = " + theBin);
			if ((theBin >=0)  && (theBin <numInt)){
				y=Math.max(y,yoffset2);
				//f[theBin]=y-yoffset2;
				ff=y-yoffset2;
				fdata[theBin] = Math.max(0,(int) Math.round(sp2v*ff+ip2v));
				//System.out.println(fdata[theBin]);
				f[theBin]=(int) (fdata[theBin] * sv2p + inter);
				int x1= xoffset+gap/2+theBin*xadd;

				g.fillRect( x1,f[theBin]+yoffset2,width,rHeight-f[theBin]);
				g.clearRect(x1,yoffset2,width,Math.min(f[theBin],rHeight));
				//g.clearRect(x1,yoffset2,width,f[theBin]);

//System.out.println(f[theBin] + " " + rHeight + " " + yoffset2);
				//applet.fdata[theBin] = fdata[theBin];
				//setSlopes();
				//repaint();
			}
		}

	public boolean mouseDrag(Event e, int x, int y)	{
		if (clickable) {
			//showStat=false;
			changeDist(x,y);
		}
		return true;
	}


}