var chapterLengths = new Array(2)
chapterLengths[0]=2;
chapterLengths[1] = 8;

//------------------------------------------------------------
/*Internet explorer 5.5 is the first IE version to support the Array.push() method.  Since IE for mac stopped before 5.5, we define our own push method.
*/
function myPush(x)
{
this[this.length] = x;
return this.length;
}

version=6
if (navigator.appVersion.indexOf("MSIE")!=-1){
temp=navigator.appVersion.split("MSIE")
version=parseFloat(temp[1])
}

if (version<5.5) //NON IE browser will return 0
    {
    Array.prototype.push = myPush;
    //alert("You're using IE less than IE5.5")
    }


function tocRecord(parent,myName,theUrl,indent, description) {
    this.parent = parent   // what object is the parent, only a chapter entry should have null.
    this.myName = myName // text to display
    this.indent = indent   // how deeply nested? 
    this.theUrl = theUrl
    this.description = description
    return this
}
//--------------------------------------------------------------


var roman = new Array("     ", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XI", "XII", "XIII", "XIV", "XV")
var alpha = new Array("A", "B", "C", "D", "E","F","G","H","I","K","L","M","N","O")
var nums = new Array("1", "2", "3","4","5","6","7","8","9");
var small_alpha = new Array("a", "b", "c", "d","e","f","g","h","i")
var outline_tags = new Array(roman, alpha, nums, small_alpha)


var db = new Array()    //db is a database of all table-of-contents entries

/*A new table of contents entry is declared like this:

newEntry = new tocRecord(tocRecord parentEntry, String title, String URL, int indent, String description)

parentEntry must be a reference to the entry that directly contains the new entry.  For instance, if chapterI is a reference to chapter one, then
section A of chapter one would have chapterI as its parent.  The parent is important for the table of contents, as it is used in determining which entries are to be displayed, and which are hidden.
If the entry is top-level (has no parent), parent should be null.

title is a string which defines the printed title of the page, i.e. "What are Statistics"

URL is the filename of the main page for this section, minus any suffixes.  for instance, if URL = "what_are", then this entry will point to the section defined by what_are.html, what_areC.html, what_areM.html etc...   URL must be a string
if the page has no URL link, set URL to the string "null"

indent is the amount of indentation in the outline.  roman numerals and letters are assigned automatically from outline_tags.  indent = 0 is no indentation, like for a chapter heading.

description is a string used by search functions to determine what type of page each entry is.  Here are the descriptions we've used here:
chapter heading:                "chapter_title"
any section of a chapter:       "chapxx" were xx is the chapter number.  i.e. "chap1", "chap11"
In other words, description is a way of grouping entries.


Sample code:  this code creates a new chapter 42 entitled "the meaning of life", and adds one section to it

var chapter42 = new tocRecord(null, "The meaning of life", "meaning_of_life", 0, "chapter_title")
db.push(chapter42)  //add chapter42 to our database

    //next, to add a section that had no child entries, we can skip the var and condense the previous into one step
    db.push(new tocRecord(chapter42, "On the merits of having a towel", "towel_merits", 1, "chap42")
    
thats all.
note: when adding a new section, the chxMM array may need to be updated or expanded

-Dan Treiman
*/


//Chapter 1

db.push(new tocRecord(null, null, "none", 1, "space filler"))  //TOC doesn't like to display the 0th entry of DB.

var home = new tocRecord(null, "Home", "title", 0, "chap0")
db.push(home)
    db.push(new tocRecord(home, "Contents", "map", 1, "chap0"))
    db.push(new tocRecord(home, "Instructions", "instructions", 1, "chap0"))
    db.push(new tocRecord(home, "Revision History", "revision", 1, "chap0"))

var chapterI =  new tocRecord(null, "Introduction", "none", 0, "chapter_title")
db.push(chapterI)
    db.push(new tocRecord(chapterI, "What Are Statistics?", "what_are", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Importance of Statistics", "importance", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Descriptive Statistics", "descriptive", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Inferential Statistics", "inferential", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Sampling Demonstration", "sampling_demo", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Variables", "variables", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Percentiles", "percentiles", 1, "chap1"))
    var measurement = new tocRecord(chapterI, "Measurement", "measurement", 1, "chap1")
    db.push(measurement)
        db.push(new tocRecord(measurement, "Levels of Measurement", "levels_of_measurement", 2, "chap1"))
        db.push(new tocRecord(measurement, "Measurement Demonstration", "measurement_demo", 2, "chap1"))
        db.push(new tocRecord(measurement, "Basics of Data Collection", "data_collection", 2, "chap1"))
    db.push(new tocRecord(chapterI, "Distributions", "distributions", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Summation Notation", "summation", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Linear Transformations", "linear_transforms", 1, "chap1"))
    db.push(new tocRecord(chapterI, "Exercises", "Ch1_exercises", 1, "chap1"))
//Chapter 2

var chapterII = new tocRecord(null, "Graphing Distributions", "none", 0, "chapter_title")
db.push(chapterII)
    db.push(new tocRecord(chapterII, "Introduction", "intro_graphing", 1, "chap2"))
    db.push(new tocRecord(chapterII, "Qualitative Variables", "graphing_qualitative", 1, "chap2"))
    quantitative = new tocRecord(chapterII, "Quantitative Variables", "intro_quantitative", 1, "chap2")
    db.push(quantitative)
        db.push(new tocRecord(quantitative, "Stem and Leaf Displays", "stem", 2, "chap2"))
        db.push(new tocRecord(quantitative, "Histograms", "histograms", 2, "chap2"))
        db.push(new tocRecord(quantitative, "Frequency Polygons", "freq_poly", 2, "chap2"))
        db.push(new tocRecord(quantitative, "Box Plots", "boxplots", 2, "chap2"))
        db.push(new tocRecord(quantitative, "Box Plot Demo", "boxplot_demo", 2, "chap2"))
        db.push(new tocRecord(quantitative, "Bar Charts", "bar_chart", 2, "chap2"))
        db.push(new tocRecord(quantitative, "Line Graphs", "line_graphs", 2, "chap2"))
    db.push(new tocRecord(chapterII, "Exercises", "Ch2_exercises", 1, "chap2"))

//Chapter 3

var chapterIII = new tocRecord(null, "Summarizing Distributions", "none", 0, "chapter_title")
db.push(chapterIII)
    central = new tocRecord(chapterIII, "Central Tendency", "ct_overview", 1, "chap3")
    db.push(central)
        db.push(new tocRecord(central, "What is Central Tendency?", "what_is_ct", 2, "chap3"))
        measurement = new tocRecord(central, "Measures of Central Tendency Overview", "measures_of_ct", 2, "chap3")
        db.push(measurement)
            db.push(new tocRecord(measurement, "Measures of Central Tendency", "measures", 3, "chap3"))
            db.push(new tocRecord(measurement, "Balance Scale Simulation", "balance", 3, "chap3"))
            db.push(new tocRecord(measurement, "Absolute Differences Simulation", "median_sim", 3, "chap3"))
            db.push(new tocRecord(measurement, "Squared Differences Simulation", "mean_sq_sim", 3, "chap3"))
            db.push(new tocRecord(measurement, "Median and Mean", "mean_median_def", 3, "chap3"))
            db.push(new tocRecord(measurement, "Mean and Median Demo", "mean_median_sim", 3, "chap3"))
            db.push(new tocRecord(measurement, "Additional Measures", "additional_measures", 3, "chap3"))
        db.push(new tocRecord(central, "Comparing Measures", "comparing_measures", 2, "chap3"))
    variability = new tocRecord(chapterIII, "Variability", "variability_overview", 1, "chap3")
    db.push(variability)
        db.push(new tocRecord(variability, "Measures of Variability", "variability", 2, "chap3"))
        db.push(new tocRecord(variability, "Variability Demo", "spread_sim", 2, "chap3"))
        db.push(new tocRecord(variability, "Estimating Variance Simulation", "variance_est", 2, "chap3"))
    db.push(new tocRecord(chapterIII, "Shapes of Distributions", "shapes", 1, "chap3"))
    db.push(new tocRecord(chapterIII, "Effects of Linear Transformations", "transformations", 1, "chap3"))
    db.push(new tocRecord(chapterIII, "Variance Sum Law I", "variance_sum_law", 1, "chap3"))
    db.push(new tocRecord(chapterIII, "Exercises", "Ch3_exercises", 1, "chap3"))
    


//Chapter 4
var chapterIV = new tocRecord(null, "Describing Bivariate Data", "none", 0, "chapter_title")
db.push(chapterIV)
    db.push(new tocRecord(chapterIV, "Introduction to Bivariate Data", "intro", 1, "chap4"))
    db.push(new tocRecord(chapterIV, "Values of the Pearson Correlation", "pearson", 1, "chap4"))
    db.push(new tocRecord(chapterIV, "Guessing Correlations", "pearson_demo", 1, "chap4"))
    db.push(new tocRecord(chapterIV, "Properties of r", "properties", 1, "chap4"))
    db.push(new tocRecord(chapterIV, "Computing r", "calculation", 1, "chap4"))
    db.push(new tocRecord(chapterIV, "Restriction of Range Demo", "restriction_demo", 1, "chap4"))
    db.push(new tocRecord(chapterIV, "Variance Sum Law II", "variance_sum_law2", 1, "chap4"))
    db.push(new tocRecord(chapterIV, "Exercises", "Ch4_exercises", 1, "chap4"))
     
//Chapter 5
var chapterV = new tocRecord(null, "Probability", "none", 0, "chapter_title")
db.push(chapterV)
    db.push(new tocRecord(chapterV, "Introduction", "probability_intro", 1, "chap5"))
    db.push(new tocRecord(chapterV, "Basic Concepts", "basic", 1, "chap5"))
    db.push(new tocRecord(chapterV, "Gambler's Fallacy", "gambler", 1, "chap5"))
    db.push(new tocRecord(chapterV, "Binomial Distribution", "binomial", 1, "chap5"))
    db.push(new tocRecord(chapterV, "Binomial Demonstration", "binomial_demonstration", 1, "chap5"))
    db.push(new tocRecord(chapterV, "Base Rates", "base_rates", 1, "chap5"))
    db.push(new tocRecord(chapterV, "Exercises", "Ch5_exercises", 1, "chap5"))
//Chapter 6

var chapterVI = new tocRecord(null, "Normal Distribution", "none", 0, "chapter_title")
db.push(chapterVI)
    db.push(new tocRecord(chapterVI, "Introduction", "intro", 1, "chap6"))
    db.push(new tocRecord(chapterVI, "History", "history_normal", 1, "chap6"))
    db.push(new tocRecord(chapterVI, "Areas of Normal Distributions", "areas_normal", 1, "chap6"))
    db.push(new tocRecord(chapterVI, "Varieties Demonstration", "varieties_demo", 1, "chap6"))
    db.push(new tocRecord(chapterVI, "Standard Normal", "standard_normal", 1, "chap6"))
    db.push(new tocRecord(chapterVI, "Normal Approximation to the Binomial", "normal_approx", 1, "chap6"))
    db.push(new tocRecord(chapterVI, "Normal Approximation Demo", "normal_approx_demo", 1, "chap6"))
    db.push(new tocRecord(chapterVI, "Exercises", "Ch6_exercises", 1, "chap6"))

//Chapter 7

var chapterVII = new tocRecord(null, "Sampling Distributions", "none", 0, "chapter_title")
db.push(chapterVII)
    db.push(new tocRecord(chapterVII, "Introduction", "intro_samp_dist", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "Basic Demo", "SampDist_v1", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "Sample Size Demo", "SampDist_v2", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "CLT Demo", "clt_demo", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "Sampling Distribution of the Mean", "samp_dist_mean", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "Difference Between Means", "samplingdist_diff_means", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "Sampling Distribution of r", "samp_dist_r", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "Sampling Distribution of p", "samp_dist_p", 1, "chap7"))
    db.push(new tocRecord(chapterVII, "Exercises", "Ch7_exercises", 1, "chap7"))

//Chapter 8

var chapterVIII = new tocRecord(null, "Estimation", "none", 0, "chapter_title")
db.push(chapterVIII)
    db.push(new tocRecord(chapterVIII, "Introduction", "intro", 1, "chap8"))
    db.push(new tocRecord(chapterVIII, "Degrees of Freedom", "df", 1, "chap8"))
    db.push(new tocRecord(chapterVIII, "Characteristics of Estimators", "characteristics", 1, "chap8"))
    confidence_int = new tocRecord(chapterVIII, "Overview of Confidence Intervals", "confidence_overview", 1, "chap8")
    db.push(confidence_int)
            db.push(new tocRecord(confidence_int, "Confidence Intervals", "confidence", 2, "chap8"))
            db.push(new tocRecord(confidence_int, "Confidence Interval for Mean", "mean", 2, "chap8"))
            db.push(new tocRecord(confidence_int, "t distribution", "t_distribution", 2, "chap8"))
            db.push(new tocRecord(confidence_int, "Confidence Interval Simulation", "ci_sim", 2, "chap8"))
            db.push(new tocRecord(confidence_int, "Difference between Means", "difference_means", 2, "chap8"))
            db.push(new tocRecord(confidence_int, "Correlation", "correlation_ci", 2, "chap8"))
            db.push(new tocRecord(confidence_int, "Proportion", "proportion_ci", 2, "chap8"))
    db.push(new tocRecord(chapterVIII, "Exercises", "Ch8_exercises", 1, "chap8"))
    
//Chapter 9
var chapterIX = new tocRecord(null, "Logic of Hypothesis Testing", "none", 0, "chapter_title")
db.push(chapterIX)
db.push(new tocRecord(chapterIX, "Introduction","intro", 1, "chap9"))
db.push(new tocRecord(chapterIX, "Significance Testing","significance", 1, "chap9"))
db.push(new tocRecord(chapterIX, "Type I and II Errors","errors", 1, "chap9"))
db.push(new tocRecord(chapterIX, "One- and Two-Tailed Tests","tails", 1, "chap9"))
db.push(new tocRecord(chapterIX, "Interpreting Significant Results","significant", 1, "chap9"))
db.push(new tocRecord(chapterIX, "Interpreting Non-Significant Results","nonsignificant", 1, "chap9"))
db.push(new tocRecord(chapterIX, "Steps in Hypothesis Testing","steps", 1, "chap9"))
db.push(new tocRecord(chapterIX, "Misconceptions","misconceptions", 1, "chap9"))
db.push(new tocRecord(chapterIX, "Exercises", "Ch9_exercises", 1, "chap9"))

//Chapter 10

var chapterX = new tocRecord(null, "Testing Means", "none", 0, "chapter_title")
db.push(chapterX)

    db.push(new tocRecord(chapterX, "Single Mean", "single_mean", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Difference between 2 Means", "difference_means", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Robustness Simulation", "robust_sim", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Pairwise Comparisons", "pairwise", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Specific Comparisons", "specific_comparisons", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Correlated Pairs", "correlated", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Comparisons (correlated)", "specific_related", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Pairwise Comparisons (Correlated Observations)", "pairwise_correlated", 1, "chap10"))
    db.push(new tocRecord(chapterX, "Exercises", "Ch10_exercises", 1, "chap10"))

//Chapter 11 (in development)

var chapterXI = new tocRecord(null, "Simple Regression", "none", 0, "chapter_title")
db.push(chapterXI)
    db.push(new tocRecord(chapterXI, "Introduction", "intro", 1, "chap11"))
    db.push(new tocRecord(chapterXI, "Exercises", "Ch11_exercises", 1, "chap9"))

//Chapter 12 (case studies)
var chapterXII = new tocRecord(null, "Case Studies", "none", 0, "chapter_title")
db.push(chapterXII)
    db.push(new tocRecord(chapterXII, "Angry Moods", "angry_moods", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Flatulence", "flatulence", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Stroop Color-Word Interference", "stroop", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Physicians Reactions to Patient Size", "weight", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Instructor Reputation and Teacher Ratings", "ratings", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Mediterranean Diet and Health", "diet", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Smiles and Leniency", "leniency", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Animal Research", "animal_research", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "ADHD Treatment", "adhd", 1, "chap12"))
    db.push(new tocRecord(chapterXII, "Weapons and Aggression", "guns", 1, "chap12"))


//Chapter 13 (Calculators)

//test...

//Iterate through each item in the db and assign outline tags (I,A,1,a) to each entry

var currentLevel = db[0].indent   //current indent level as we scan through the db
var item_count = new Array(-1, -1, -1, -1, -1, -1)

for (var u = 0; u < db.length; u++)
    {        
    if (db[u].indent < currentLevel)  //pop out of this outline level
        {
        item_count[currentLevel] = -1
        if (db[u].indent == 0)
            for (var v = 1; v < item_count.length; v++)
                item_count[v] = -1;
        }
        
   currentLevel = db[u].indent
   item_count[currentLevel]++
   db[u].outlineTag = outline_tags[currentLevel][item_count[currentLevel]]
   }
 
 
//Begin added functions by Myah and Dan
//--------------------------------------------------------------------------------------------------------------

/**simple accessor for pages that include this file as an external .js*/
function getDB()
{return db
}

/**indent_menu returns a string of n*3 non-breaking spaces*/
function indent_menu(n) {
	var result = ""
	for (var i = 1; i <= n; i++) {
		result += "\xA0\xA0\xA0" //160 = 0xA0 is a non-breaking space.  Regular spaces are ignored in popup menus
	}
	return result
}

/**makeSectionList returns an array of the names (myName) of each element in db whose .description property matches theDescription.  It is used to generate lists of the section names in a particular chapter.*/
function makeSectionList(theDescription){ 

var list= new Array() 
var i
for (i=0;i<db.length;i++)
    {
        if(theDescription == db[i].description)
        {
            if(db[i].theUrl != "none") //Don't return a section entry that has no URL
            //But do return it if we are searching for chapter headings, because no chapter headings have a URL
            list.push(db[i].myName)
        }
    }
    return list
}

/**makeUrlList returns an array of the URLs (theUrl) of each element in db whose .description property matches theDescription.  It is used to generate lists of the URLS for each section in a particular chapter.*/
function makeUrlList(theDescription)
{ 
    var i
    var list= new Array() 
    for (i=0;i<db.length;i++)
        {
            if(theDescription ==  db[i].description)
            {
                if(db[i].theUrl != "none")
                list.push(db[i].theUrl)
            }
        }
    return list
}

/**makeChapterList returns an array of the titles of each chapter*/
function makeChapterList()
{ 
    var i
    var list= new Array("Home") 
    for (i=0;i<db.length;i++)
        {
            if(db[i].description == "chapter_title")
            {
            list.push(db[i].myName)
            }
        }
    return list
}

/**This function is a generalized version of the above three functions.  It searches db and returns an Array of all tocRecords in db whose .description property matches theDescription*/
function getSomeTOCs(theDescription)
{
     var i
    var list= new Array()
    for (i=0;i<db.length;i++)
        {
            if(db[i].description == theDescription)
            {
                //if(db[i].theUrl != "none")
                list.push(db[i])
            }
        }
    return list
}

//--------------------------------------------------------------------------------------------------------------
//end added functions

//To add a section
//  Fill in hidden fields on page
//  Add record to db
// indicate available modes in sectionModes array


/*The following arrays are the 'glue' that links the old navigation code with out new db.  Originally each of these arrays was hard-coded, as in

var h = new Array("Title Page","Contents", "Instructions", "Revision History")

Now these structures are generated by our search functions makeSectionList(String description) and makeUrlList(String description).  This is so that changes now only have to be made in db, and they will be reflected in both the navigation menus and the TOC.  The searches use the description property to group the records by chapter.
Note:
Each chapter name array must be added into the sectionNames array, as each chapter url array must be added to sectionUrls (and in the same order).
*/

/*var chapterNames = new Array("Home", "Introduction", "Graphing Distributions", "Summarizing Distributions", "Describing Bivariate Data", "Probability", "Normal Distribution", "Sampling Distributions","Estimation","Logic of Hypothesis Testing","Testing Means", "Simple Regression", "Case Studies", "Calculators")*/

var chapterNames = makeChapterList()

var h = makeSectionList("chap0")
var ch1 = makeSectionList("chap1")
var ch2 = makeSectionList("chap2")
var ch3 = makeSectionList("chap3")
var ch4 = makeSectionList("chap4")
var ch5 = makeSectionList("chap5")
var ch6 = makeSectionList("chap6")
var ch7 = makeSectionList("chap7")
var ch8 = makeSectionList("chap8")
var ch9 = makeSectionList("chap9")
var ch10 = makeSectionList("chap10")
var ch11 = makeSectionList("chap11")
var case_study = makeSectionList("chap12")
var analysis_lab = new Array("Analysis Lab")
var sectionNames = new Array(h,ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10, ch11 ,case_study,analysis_lab);

var homeUrl = makeUrlList("chap0");
var ch1Urls = makeUrlList("chap1");
var ch2Urls = makeUrlList("chap2");
var ch3Urls = makeUrlList("chap3");
var ch4Urls = makeUrlList("chap4");
var ch5Urls = makeUrlList("chap5");
var ch6Urls = makeUrlList("chap6");
var ch7Urls = makeUrlList("chap7");
var ch8Urls = makeUrlList("chap8");
var ch9Urls = makeUrlList("chap9");
var ch10Urls = makeUrlList("chap10");
var ch11Urls = makeUrlList("chap11");
var caseUrls = makeUrlList("chap12");
var calcUrls = new Array("analysisLab");

var sectionUrls = new Array(homeUrl,ch1Urls,ch2Urls,ch3Urls,ch4Urls,ch5Urls,ch6Urls,ch7Urls,ch8Urls,ch9Urls,ch10Urls,ch11Urls, caseUrls,calcUrls);

/*When adding a new section or chapter, it must be reflected in these arrays.  Eventually (hopefully) these should be phased out; when the site is finished, every entry will be 2. :-)
*/
var homeMM = new Array(0,0,0,0);
var ch1MM = new Array(2,2,2,2,2,2,2,2,2,2,2,2,2,2,0);
var ch2MM = new Array(2,2,2,2,2,2,2,2,2,2,2,0);
var ch3MM = new Array(2,2,2,2,2,2,2,2,2,2,2,2,2,2,2);
var ch4MM = new Array(2,2,2,2,2,2,0,0,0,0,0,0);
var ch5MM = new Array(2,2,2,2,2,2,2);
var ch6MM = new Array(2,0,2,2,2,2,2,0,0,0,0,0);
var ch7MM = new Array(2,0,0,0,0,0,0,0,0,0,0,0);
var ch8MM = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
var ch9MM = new Array(0,0,0,0,0,0,0,0,0,0,0,0);
var ch10MM = new Array(0,0,0,0,0,0,0,0,0,0,0,0);
var ch11MM = new Array(0,0,0,0,0,0,0,0,0,0,0,0);
var ch12MM = new Array(0,0,0,0,0,0,0,0,0,0,0,0);

// 0 : standard
// 1: standard, condensed,
// 2 standard, condensed, mm


var sectionModes = new Array(homeMM,ch1MM,ch2MM,ch3MM,ch4MM, ch5MM,ch6MM,ch7MM, ch8MM, ch9MM, ch10MM,ch11MM,ch12MM);


var sectionIndex=0;
var chapterIndex=0;

var mmOption = 	new Option("Multimedia", "2");
var conOption = new Option("Condensed", "2");
var stOption = 	new Option("Standard", "1");
var modeMMOptions = new Array(mmOption, conOption, stOption);
var modeOptions = new Array(mmOption, conOption);


var mode =  new Array("","C", "M");
var modeStatus = 0;
var selectedMode = 0;



function  explainMode() {
	alert ("Streamlined has fewer examples and is less chatty; multimedia is a lecture presented as a quicktime movie.\nOnly standard is available now.")
}
function changeSection()
{
	//alert("changing section")
	//if((sectionIndex != document.forms[0].section.selectedIndex) || (chapterIndex != document.forms[0].chapter.selectedIndex)) {
	sectionIndex = document.forms[0].section.value
	chapterIndex = document.forms[0].chapter.selectedIndex
	upDateMode()
	parent.mainFrame.location = getSectionUrl(chapterIndex,sectionIndex)
	
	//}
	
	
}

function changeChapter(chapterIndex){

upDateMode() 

v = getSectionUrl(chapterIndex,0)
parent.mainFrame.location = v
chapterIndex = document.forms[0].chapter.selectedIndex

upDateSections(chapterIndex,sectionNames[chapterIndex][0])

}

function getSectionUrl(theChapter, theSection) {

	//xx = mode[document.forms[0].mode.selectedIndex]
	//alert(theChapter)
	xx = mode[selectedMode]
	if(chapterNames[theChapter] == "Case Studies" || theChapter == 12) {
		x = "case_studies/" + sectionUrls[theChapter][theSection] + xx +  ".html"
    }
	else if (chapterNames[theChapter] == "Calculators") {
		x = "analysis_lab/" + sectionUrls[theChapter][theSection] + xx +  ".html"
		
	}
	else 
	   x = "chapter" + (theChapter) + "/" + sectionUrls[theChapter][theSection] + xx +  ".html"

return x
}

//var sections = new Array(3)
//var sectionIndex=0;
//sections[0] = "introductiontographingdata.html"
//sections[1] = "graphingcategoricaldata.html"
//var v = new Array(3)

function goNext() {
//alert(document.forms[0].section.length + " "  + (document.forms[0].section.selectedIndex +1))
	if (document.forms[0].section.length == document.forms[0].section.selectedIndex +1) {
	
		if (document.forms[0].chapter.length != document.forms[0].chapter.selectedIndex +1){
			document.forms[0].chapter.selectedIndex++
			changeChapter(document.forms[0].chapter.selectedIndex)
		}
	}
	else {
		document.forms[0].section.selectedIndex++
		changeSection()
	}
	
}
function testing() {
	x =parent.frames[0].document.forms[0]
	alert(x.section.length)
}

function goPrev() {
	if (document.forms[0].section.selectedIndex != 0) {

			document.forms[0].section.selectedIndex--
			changeSection()

		}
	else {
		if (document.forms[0].chapter.selectedIndex != 0) {
			document.forms[0].chapter.selectedIndex--
		
			//changeChapter(document.forms[0].chapter.selectedIndex)
			var L = sectionNames[document.forms[0].chapter.selectedIndex].length
			upDateMode()
			v = getSectionUrl(document.forms[0].chapter.selectedIndex,L-1)
			parent.mainFrame.location = v
			chapterIndex = document.forms[0].chapter.selectedIndex
			upDateSections(chapterIndex,sectionNames[chapterIndex][L-1])
		}
	}
}

/**upDateSections(chapterIndex, theSection) updates the 
section popup menu when the user changes chapters.  
Additions:
upDateSections now indents and labels each section in outline form.
If the section does not have a URL, then the menu item is disabled.  
It should show up as gray and not be selectable.  This feature will
not be used in the final TOC, for tow reasons:
1. All TOC entries will have a link
2. It is only currently supported in mozilla/NN
*/

function upDateSections(chapterIndex,theSection) 
	{

		//var sectionIndex=0
		var j=0  //j is the index of selectable items only, not all items
		document.forms[0].chapter.selectedIndex=chapterIndex
		
		var sl = document.forms[0].section.options.length;
		var theseSections = getSomeTOCs("chap" + chapterIndex)
		
		for (i=0;i<theseSections.length;i++) {
			
			if(theSection == theseSections[i].myName) {
		
				sectionIndex = i;
			}
			if (i+1 > sl) {
				document.forms[0].section.options[i] =	new Option(indent_menu(theseSections[i].indent -1) + theseSections[i].outlineTag + ". " + theseSections[i].myName, "i")
			}
			else {
				document.forms[0].section.options[i].text = indent_menu(theseSections[i].indent -1) + theseSections[i].outlineTag + ". " +theseSections[i].myName
			}
			if (theseSections[i].theUrl == "none")
			     document.forms[0].section.options[i].disabled="disabled";  //no url, gray out that item
			    //added by Dan 07/07/2004
			 else  //this one is valid - it needs an index
			     {
			     document.forms[0].section.options[i].value=j;
			     j++;
			     }
		}
		
		if (sl > theseSections.length) {
			//for (i = theseSections.length;i<sl;i++) {
			for (i = sl-1; i>= theseSections.length;i--) {
				document.forms[0].section.options[i] = null;
			}
			
	}
}

function upDateMode() {
//alert(document.forms[0].section.selectedIndex)
//alert("checking if update necessary " + document.forms[0].chapter.selectedIndex + " " + document.forms[0].section.selectedIndex)
	var newStatus = sectionModes[document.forms[0].chapter.selectedIndex][document.forms[0].section.selectedIndex];
	if (newStatus != modeStatus) {
		//alert(" necessary new: " + newStatus + " old:  " +  modeStatus)
		var curSelected = document.forms[0].mode.selectedIndex
		
		if (newStatus == 2) {
				if(modeStatus == 0) document.forms[0].mode.options[1] = new Option("Condensed", "1")			
				document.forms[0].mode.options[2] = new Option("Multimedia", "2")
		}
		else if (newStatus == 1){
				if(modeStatus == 0) document.forms[0].mode.options[1] = new Option("Condensed", "1")
				else {
					document.forms[0].mode.options[2] = null
					if (curSelected == 2) {
						document.forms[0].mode.selectedIndex = 0
						selectedMode = 0
					}
				}
		}
		else if (newStatus == 0) {
			if(modeStatus == 2) document.forms[0].mode.options[2] = null
			document.forms[0].mode.options[1] = null
			document.forms[0].mode.selectedIndex = 0
			selectedMode = 0
			//alert("status set to 0")
		}
		modeStatus = newStatus
		//alert("updated")
	}	
	//else alert("not necesary " + newStatus + " " + modeStatus )	
	
}
function changeMode() {
	selectedMode= document.forms[0].mode.selectedIndex
	parent.mainFrame.location = getSectionUrl(document.forms[0].chapter.selectedIndex,document.forms[0].section.selectedIndex)

}
